#include <stdio.h>
#include <iostream>
#include <fstream>
#include <string>
#include "paramSimul.h"
#include "evaluationConfigurerations.h"
#include "ue.h"
#include "const.h"
#include "struct.h"
#include "objectBSSectorUe.h"
#include "paramFastFading.h"
#include "channel.h"
#define dBm2linear(x) (pow(10.0, (x- 30)/10.0))

double Sector_Antenna_gain_in_dB(SPHERICAL_ANGLE LCS_angle);
double UE_Antenna_gain_in_dB(SPHERICAL_ANGLE LCS_angle);
ANTENNA_FIELD Antenna_field_in_LCS(double LCS_antenna_gain_in_dB, double zeta);
ANTENNA_FIELD LCS_Antenna_field_to_GCS_antenna_pattern(double alpha, double beta, double gamma, SPHERICAL_ANGLE GCS_angle, ANTENNA_FIELD LCS_field); //GCS_angle degree
SPHERICAL_ANGLE GCS_Angle_to_LCS_Angle(double alpha, double beta, double gamma, SPHERICAL_ANGLE GCS_angle);
double Transform_angle_minus_180_to_plus_180(double x);


void PIot_ue_antenna_gain();
void PIot_sector_antenna_gain();
int Max_idx(double *A, int size);
double max(double *A, int size);


void Generate_sector_port0_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX sector_port0_LOS_field[][8], ANTENNA_FIELD_COMPLEX sector_port0_NLOS_field[][8][20][20]);
void Generate_sector_port0_LOS_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX sector_port0_LOS_field[][8]);
void Generate_sector_port0_NLOS_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX sector_port0_NLOS_field[][8][20][20]);

void Generate_ue_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX ue_port_LOS_field[][2][2][4], ANTENNA_FIELD_COMPLEX ue_port_NLOS_field[][2][2][4][20][20], ANTENNA_FIELD_COMPLEX ue_antenna_element_LOS_field[][2], ANTENNA_FIELD_COMPLEX ue_antenna_element_NLOS_field[][2][20][20]);
void Generate_ue_port_LOS_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX ue_port_LOS_field[][2][2][4]);
void Generate_ue_port_NLOS_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX ue_port_NLOS_field[][2][2][4][20][20]);

void Generate_antenna_element_LOS_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX ue_antenna_element_LOS_field[][2]);
void Generate_antenna_element_NLOS_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX ue_antenna_element_NLOS_field[][2][20][20]);

double Calculate_Coupling_loss_dirctional_ue(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX sector_port0_LOS_field[][8], ANTENNA_FIELD_COMPLEX sector_port0_NLOS_field[][8][20][20], ANTENNA_FIELD_COMPLEX ue_port_LOS_field[][2][2][4], ANTENNA_FIELD_COMPLEX ue_port_NLOS_field[][2][2][4][20][20], STEERING_IDX steering_idx[]);
void Compute_sum_of_alpha_LOS_directional_ue(int  sec_zenith_idx, int sec_azimuth_idx,   int  ue_zenith_idx, int ue_azimuth_idx, int ue_idx, int sec_idx, double sum_of_alpha_LOS[], ANTENNA_FIELD_COMPLEX sector_port0_LOS_field[][8], ANTENNA_FIELD_COMPLEX ue_port_LOS_field[][2][2][4]);
void Compute_sum_of_alpha_NLOS_directional_ue(int  sec_zenith_idx, int sec_azimuth_idx, int  ue_zenith_idx, int ue_azimuth_idx, int ue_idx, int sec_idx, double sum_of_alpha_NLOS[], ANTENNA_FIELD_COMPLEX sector_port0_NLOS_field[][8][20][20], ANTENNA_FIELD_COMPLEX ue_port_NLOS_field[][2][2][4][20][20]);

double Calculate_Coupling_loss_omni_dirctional_ue(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX sector_port0_LOS_field[][8], ANTENNA_FIELD_COMPLEX sector_port0_NLOS_field[][8][20][20], ANTENNA_FIELD_COMPLEX ue_antenna_element_LOS_field[][2], ANTENNA_FIELD_COMPLEX ue_antenna_element_NLOS_field[][2][20][20], STEERING_IDX steering_idx[]);
double Compute_sum_of_alpha_LOS_omni_directiona_ue(int sec_zenith_idx, int  sec_azimuth_idx, int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX sector_port0_LOS_field[][8], ANTENNA_FIELD_COMPLEX ue_antenna_element_LOS_field[][2]);
double Compute_sum_of_alpha_NLOS_omni_directional_ue(int sec_zenith_idx, int sec_azimuth_idx, int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX sector_port0_NLOS_field[][8][20][20], ANTENNA_FIELD_COMPLEX  ue_antenna_element_NLOS_field[][2][20][20]);

void Calculate_geometry(int ue_idx);



double dot(LOCATION a, LOCATION b);

LOCATION Transform_angle_to_spheical_vector(double phi, double theta);

/*===================================================================
FUNCTION: void Attach_ue_to_sector()

AUTHOR: GJ

DESCRIPTION: 36.873 Coupling_loss

INPUT :

OUTPUT :

NOTES: Currently, nothing is done when a sector is instantiated

===================================================================*/

void Attach_ue_to_sector()
{
	ANTENNA_FIELD_COMPLEX sector_port0_LOS_field[4][8];// [zenith][azimuth] (maximum number) 
	ANTENNA_FIELD_COMPLEX sector_port0_NLOS_field[4][8][20][20]; //[zenith][azimuth][cluster][ray]

	ANTENNA_FIELD_COMPLEX ue_port_LOS_field[2][2][2][4];// [panel][pol][zenith][azimuth] (maximum number) 
	ANTENNA_FIELD_COMPLEX ue_port_NLOS_field[2][2][2][4][20][20]; //[panel][pol][zenith][azimuth][cluster][ray]
		
	ANTENNA_FIELD_COMPLEX ue_antenna_element_LOS_field[2][2];//horizontal_antenna][pol]
	ANTENNA_FIELD_COMPLEX ue_antenna_element_NLOS_field[2][2][20][20]; //[horizontal_antenna][pol][cluster][ray]

	double Coupling_loss[57];
	STEERING_IDX steering_idx[57];

	//PIot_sector_antenna_gain();
	//PIot_ue_antenna_gain();
	cout << endl;
	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		cout << '\r';
		cout << ue_idx << "/" << num_ue-1 ;
		for (int sec_idx = 0; sec_idx < num_sector; sec_idx++)
		{
			Coupling_loss[sec_idx] = 0;
		}
		for (int sec_idx = 0; sec_idx < num_sector; sec_idx++)
		{
			
			//for (int idx = 0; idx < num_compute_coef; idx++)
			{
				//if(ue[ue_idx].adj_bs[idx]==(sec_idx/num_TRxP_per_site))
				{					
					//
					Generate_sector_port0_field(ue_idx, sec_idx, sector_port0_LOS_field, sector_port0_NLOS_field);
			
					Generate_ue_field(ue_idx, sec_idx, ue_port_LOS_field, ue_port_NLOS_field, ue_antenna_element_LOS_field, ue_antenna_element_NLOS_field);
					
					if (ue_antenna.Ng == 2)
					{
						Coupling_loss[sec_idx] = Calculate_Coupling_loss_dirctional_ue(ue_idx, sec_idx, sector_port0_LOS_field, sector_port0_NLOS_field, ue_port_LOS_field, ue_port_NLOS_field, steering_idx);
						//cout << "Coupling_loss["<<sec_idx<<"] : " << Coupling_loss[sec_idx] << endl;
					}
					else
					{
						Coupling_loss[sec_idx] = Calculate_Coupling_loss_omni_dirctional_ue(ue_idx, sec_idx, sector_port0_LOS_field, sector_port0_NLOS_field, ue_antenna_element_LOS_field, ue_antenna_element_NLOS_field, steering_idx);
					}


				}
			}		
		}
		

		ue[ue_idx].sector_in_control = Max_idx(Coupling_loss, num_sector);
		
		/*
		cout << Coupling_loss[0] << endl;
		cout << Coupling_loss[1] << endl;
		cout << Coupling_loss[2] << endl;
		*/
		if (ue_antenna.Ng == 2)
		{
			ue[ue_idx].zenith_steering_idx = steering_idx[ue[ue_idx].sector_in_control].ue_zenith;
			ue[ue_idx].azimuth_steering_idx = steering_idx[ue[ue_idx].sector_in_control].ue_azimuth;
			ue[ue_idx].panel_idx = steering_idx[ue[ue_idx].sector_in_control].ue_panel;
		}
	
		sector[ue[ue_idx].sector_in_control].ue_in_control.push_back(ue_idx);
		sector[ue[ue_idx].sector_in_control].zenith_steering_idx.push_back(steering_idx[ue[ue_idx].sector_in_control].sector_zenith);
		sector[ue[ue_idx].sector_in_control].azimuth_steering_idx.push_back(steering_idx[ue[ue_idx].sector_in_control].sector_azimuth);
		ue[ue_idx].sector_zenith_steering_idx = steering_idx[ue[ue_idx].sector_in_control].sector_zenith;
		ue[ue_idx].sector_azimuth_steering_idx = steering_idx[ue[ue_idx].sector_in_control].sector_azimuth;
		
	

		ue[ue_idx].couplingloss_dB = linear2dB(max(Coupling_loss, num_sector));
	/*	cout << "coupling_loss : " << linear2dB(max(Coupling_loss, num_sector)) << endl;
		cout << "pathloss : " << linear2dB(channel[ue[ue_idx].sector_in_control / 3][ue_idx].pathloss*channel[ue[ue_idx].sector_in_control / 3][ue_idx].SF) << endl;*/
		/*cout << "sector : " << ue[ue_idx].sector_in_control << endl;
		cout << "ue : " << ue_idx << endl;
		cout << channel[ue[ue_idx].sector_in_control / 3][ue_idx].GCS_Departure_angle_LOS.phi << endl;
		getchar();
*/

		/*
		cout << "Departure_theta : " << channel[ue_idx][ue[ue_idx].sector_in_control].GCS_Departure_angle_LOS.theta  << endl;
		cout << "Departure_phi: " << Transform_angle_minus_180_to_plus_180(channel[ue_idx][ue[ue_idx].sector_in_control].GCS_Departure_angle_LOS.phi - ue[ue_idx].alpha * 180 / PI) << endl;
		cout << "ue_zenith : " << steering_idx[ue[ue_idx].sector_in_control].ue_zenith << "  " << ue_analog_beam.zenith_steering_angle[steering_idx[ue[ue_idx].sector_in_control].ue_zenith] / PI * 180 << endl;
		if(steering_idx[ue[ue_idx].sector_in_control].ue_panel==0)
			cout << "ue_azimuth : " << steering_idx[ue[ue_idx].sector_in_control].ue_azimuth << "  " << ue_analog_beam.azimuth_steering_angle[steering_idx[ue[ue_idx].sector_in_control].ue_azimuth] / PI * 180 << endl;
		else
			cout << "ue_azimuth : " << steering_idx[ue[ue_idx].sector_in_control].ue_azimuth << "  " << Transform_angle_minus_180_to_plus_180((ue_analog_beam.azimuth_steering_angle[steering_idx[ue[ue_idx].sector_in_control].ue_azimuth]+PI)/ PI * 180 )<< endl;

		cout << endl;
		
		cout << "Arrival_theta : "<< channel[ue_idx][ue[ue_idx].sector_in_control].GCS_Arrival_angle_LOS.theta<<endl;
		cout << "Arrival_phi: " << Transform_angle_minus_180_to_plus_180(channel[ue_idx][ue[ue_idx].sector_in_control].GCS_Arrival_angle_LOS.phi -sector[ue[ue_idx].sector_in_control].alpha*180/PI)<< endl;
		cout << endl;

		cout << "bs_zenith : " << steering_idx[ue[ue_idx].sector_in_control].sector_zenith <<"  "<<bs_analog_beam.zenith_steering_angle[steering_idx[ue[ue_idx].sector_in_control].sector_zenith] / PI * 180 << endl;
		cout << "bs_azimuth : " << steering_idx[ue[ue_idx].sector_in_control].sector_azimuth << "  "<<bs_analog_beam.azimuth_steering_angle[steering_idx[ue[ue_idx].sector_in_control].sector_azimuth] / PI * 180 << endl;

		getchar();*/
	
	}
	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		Calculate_geometry(ue_idx);
	}
	cout << endl;

	//for (int sec_idx = 0; sec_idx < num_sector; sec_idx++)
	//{
	//	cout << "sec_idx : " << sec_idx << endl;
	//	for (int i = 0; i < sector[sec_idx].ue_in_control.size(); i++)
	//	{
	//		cout << sector[sec_idx].ue_in_control[i] << "  ";
	//	}

	//	for (int i = 0; i < sector[sec_idx].ue_in_control.size(); i++)
	//	{
	//		cout << "distance : "<< channel[sec_idx][sector[sec_idx].ue_in_control[i]]._3D_distance << endl;
	//		cout << "SF : "<< ue[sector[sec_idx].ue_in_control[i]].couplingloss_dB << endl;
	//	}
	//	cout << endl;
	//	cout << endl;
	//}
	//getchar();

	//for (int sec_idx = 0; sec_idx < num_sector; sec_idx++)
	//{
	//	cout << "sec_idx : " << sec_idx << endl;
	//	cout << "num_ue : " << sector[sec_idx].zenith_steering_idx.size() << endl;
	//	cout << endl;
	//	for (int i = 0; i < sector[sec_idx].zenith_steering_idx.size(); i++)
	//	{
	//		cout <<" zenith : " <<sector[sec_idx].zenith_steering_idx[i] << "   azimuth : "<< sector[sec_idx].azimuth_steering_idx[i] << endl;
	//	}
	//	getchar();
	//}

	//getchar();

}

void Generate_sector_port0_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX sector_port0_LOS_field[][8], ANTENNA_FIELD_COMPLEX sector_port0_NLOS_field[][8][20][20])
{
	if (channel[sec_idx / num_TRxP_per_site][ue_idx].fast_fading_condition == LOS)
	{
		Generate_sector_port0_LOS_field(ue_idx, sec_idx, sector_port0_LOS_field);
	}
	Generate_sector_port0_NLOS_field(ue_idx, sec_idx, sector_port0_NLOS_field);
}
void Generate_sector_port0_LOS_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX sector_port0_LOS_field[][8])
{
	complex <double> weight(0, 0);
	complex <double> j(0.0, 1.0);

	int bs_idx = sec_idx / num_TRxP_per_site;
	complex <double> w;
	LOCATION d_rx;
	LOCATION r_LOS;
	ANTENNA_FIELD F_LOS;
	
	int fast_fading_condition = channel[bs_idx][ue_idx].fast_fading_condition;
	int N = channel[bs_idx][ue_idx].num_cluster;
	int M = num_ray_per_cluster[fast_fading_condition];

	r_LOS = channel[bs_idx][ue_idx].r_rx_LOS;
	F_LOS = channel[bs_idx][ue_idx].GCS_LOS_arrival_field[sec_idx%num_TRxP_per_site][0];
	
	/*cout << endl;
	
	cout << "---------------------------" << endl;
	cout << "sec_idx : "<<sec_idx<<endl;
	cout << "GCS_Arrival_angle_LOS.phi : "<<channel[bs_idx][ue_idx].GCS_Arrival_angle_LOS.phi << endl;;
	cout << "GCS_Arrival_angle_LOS.theta : " << channel[bs_idx][ue_idx].GCS_Arrival_angle_LOS.theta << endl;;
	cout << "---------------------------" << endl;
	*/


	for (int zenith_idx = 0; zenith_idx< bs_analog_beam.num_steering_zenith_angle; zenith_idx++)
	{
		for (int azimuth_idx = 0; azimuth_idx< bs_analog_beam.num_steering_azimuth_angle; azimuth_idx++)
		{
			weight = (0, 0);

			for (int k = 0; k < bs_antenna.K; k++) // vertical element
			{
				for (int l = 0; l < bs_antenna.L; l++) // horizental element
				{
					w = bs_analog_beam.virtualization_weight[zenith_idx][azimuth_idx][k][l];
						
					d_rx = sector[sec_idx].d_rx[k][l][0][0][0]; //// sector(rx) [M][N][P][Mg][Ng] <port0>
						
					weight += w * exp(j*2.0*PI / lamda_0 * dot(r_LOS, d_rx));
				}
			}
			sector_port0_LOS_field[zenith_idx][azimuth_idx].theta = weight * F_LOS.theta;
			sector_port0_LOS_field[zenith_idx][azimuth_idx].phi = weight * F_LOS.phi;


			/*		cout << "azimuth : " << Transform_angle_minus_180_to_plus_180(bs_analog_beam.azimuth_steering_angle[azimuth_idx]*180/PI+(double(sec_idx%num_TRxP_per_site)*120+30)) << endl;
			cout << "zenith : "<< bs_analog_beam.zenith_steering_angle[zenith_idx] * 180 / PI << endl;
			cout << pow(abs(sector_port0_LOS_field[zenith_idx][azimuth_idx].theta), 2) + pow(abs(sector_port0_LOS_field[zenith_idx][azimuth_idx].phi), 2) << endl;
			cout << endl;*/
		}
	}
	/*getchar();*/	
}
void Generate_sector_port0_NLOS_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX sector_port0_NLOS_field[][8][20][20])
{

	complex <double> weight(0, 0);
	complex <double> j(0.0, 1.0);

	int bs_idx = sec_idx / num_TRxP_per_site;
	complex <double> w;
	LOCATION d_rx;
	LOCATION r_NLOS[20][20];
	ANTENNA_FIELD F_NLOS[20][20]; //F_rx_theta
	int fast_fading_condition = channel[bs_idx][ue_idx].fast_fading_condition;
	int N = channel[bs_idx][ue_idx].num_cluster;
	int M = num_ray_per_cluster[fast_fading_condition];
	

	for (int cluster_idx = 0; cluster_idx < N; cluster_idx++)
	{
		for (int ray_idx = 0; ray_idx < M; ray_idx++)
		{

			r_NLOS[cluster_idx][ray_idx] = channel[bs_idx][ue_idx].r_rx[cluster_idx][ray_idx];
	/*
			////r_NLOS 
			r_NLOS[cluster_idx][ray_idx].x = 1;
			r_NLOS[cluster_idx][ray_idx].y = 1;
			r_NLOS[cluster_idx][ray_idx].z = 1;
*/
			F_NLOS[cluster_idx][ray_idx] = channel[bs_idx][ue_idx].GCS_NLOS_arrival_field[sec_idx % num_TRxP_per_site][0][cluster_idx][ray_idx];
	/*		F_NLOS[cluster_idx][ray_idx].phi = 1;
			F_NLOS[cluster_idx][ray_idx].theta = 1;*/
		}
	}
	/*	cout << "sec_idx : " << sec_idx << endl;
			cout << "sec_azimuth : " << channel[bs_idx][ue_idx].GCS_Arrival_angle_NLOS[cluster_idx][ray_idx].phi << endl;;
			cout << "sec_zenith : " << channel[bs_idx][ue_idx].GCS_Arrival_angle_NLOS[cluster_idx][ray_idx].theta << endl;;
			cout << "---------------------------" << endl;
			*/
		
	for (int zenith_idx = 0; zenith_idx < bs_analog_beam.num_steering_zenith_angle; zenith_idx++)
	{
		for (int azimuth_idx = 0; azimuth_idx < bs_analog_beam.num_steering_azimuth_angle; azimuth_idx++)
		{
				for (int cluster_idx = 0; cluster_idx < N; cluster_idx++)
				{
					for (int ray_idx = 0; ray_idx < M; ray_idx++)
					{
				
					weight = (0, 0);
					for (int k = 0; k < bs_antenna.K; k++) // vertical element
					{
						for (int l = 0; l < bs_antenna.L; l++) // horizental element
						{
							w =  bs_analog_beam.virtualization_weight[zenith_idx][azimuth_idx][k][l];
							d_rx = sector[sec_idx].d_rx[k][l][0][0][0]; //// sector(rx) [M][N][P][Mg][Ng] <port0>
							weight += w * exp(j*2.0*PI / lamda_0 * dot(r_NLOS[cluster_idx][ray_idx], d_rx));
						}
					}
					
					sector_port0_NLOS_field[zenith_idx][azimuth_idx][cluster_idx][ray_idx].theta =  weight * F_NLOS[cluster_idx][ray_idx].theta;
					sector_port0_NLOS_field[zenith_idx][azimuth_idx][cluster_idx][ray_idx].phi =  weight * F_NLOS[cluster_idx][ray_idx].phi;

					/*	cout << "azimuth : " << Transform_angle_minus_180_to_plus_180(bs_analog_beam.azimuth_steering_angle[azimuth_idx] * 180 / PI + (double(sec_idx % num_TRxP_per_site) * 120 + 30)) << endl;
					cout << "zenith : " << bs_analog_beam.zenith_steering_angle[zenith_idx] * 180 / PI << endl;
					cout << pow(abs(sector_port0_NLOS_field[zenith_idx][azimuth_idx][cluster_idx][ray_idx].theta), 2) + pow(abs(sector_port0_NLOS_field[zenith_idx][azimuth_idx][cluster_idx][ray_idx].phi), 2) << endl;
					cout << endl;*/
				}
			}
		}
	}
}

void Generate_ue_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX ue_port_LOS_field[][2][2][4], ANTENNA_FIELD_COMPLEX ue_port_NLOS_field[][2][2][4][20][20], ANTENNA_FIELD_COMPLEX ue_antenna_element_LOS_field[][2], ANTENNA_FIELD_COMPLEX ue_antenna_element_NLOS_field[][2][20][20])
{
	if (ue_antenna.Ng == 2) // directional antenna
	{
		if (channel[sec_idx / num_TRxP_per_site][ue_idx].fast_fading_condition == LOS)
		{
			Generate_ue_port_LOS_field(ue_idx, sec_idx, ue_port_LOS_field);
		}
		Generate_ue_port_NLOS_field(ue_idx, sec_idx, ue_port_NLOS_field);
	}
	else // omni directional antenna
	{

		if (channel[sec_idx / num_TRxP_per_site][ue_idx].fast_fading_condition == LOS)
		{

			Generate_antenna_element_LOS_field(ue_idx, sec_idx, ue_antenna_element_LOS_field);

		}

		Generate_antenna_element_NLOS_field(ue_idx, sec_idx, ue_antenna_element_NLOS_field);
	}
}
void Generate_ue_port_LOS_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX ue_port_LOS_field[][2][2][4])
{
	int bs_idx = sec_idx / num_TRxP_per_site;
	
	complex <double> j(0.0, 1.0);
	complex <double> weight[2];
	complex <double> w;

	LOCATION d_tx[2];
	LOCATION r_LOS = channel[bs_idx][ue_idx].r_tx_LOS;
	ANTENNA_FIELD F_LOS[2][2];
	
	for (int panel_idx=0;panel_idx<2; panel_idx++)
	{
		for (int pol_idx = 0; pol_idx<2; pol_idx++)
		{
			F_LOS[panel_idx][pol_idx] = channel[bs_idx][ue_idx].GCS_LOS_departure_field[panel_idx][pol_idx]; // [panel_idx][pol_idx];
		}
	}
		
	//cout << "---------------------------" << endl;
	//cout << endl;
	//cout << "---------------------------" << endl;
	//cout << "sec_idx : "<<sec_idx<<endl;
	//cout << "sec_azimuth : "<<channel[bs_idx][ue_idx].GCS_Departure_angle_LOS.phi << endl;;
	//cout << "sec_zenith : " << channel[bs_idx][ue_idx].GCS_Departure_angle_LOS.theta << endl;;
	//cout << "---------------------------" << endl;
	//

	for (int zenith_idx = 0; zenith_idx < ue_analog_beam.num_steering_zenith_angle; zenith_idx++)
	{
		for (int azimuth_idx = 0; azimuth_idx < ue_analog_beam.num_steering_azimuth_angle; azimuth_idx++)
		{
			/*cout << "phi : " << bs_analog_beam.azimuth_steering_angle[azimuth_idx] / PI * 180. << endl;
			cout << "theta : " << bs_analog_beam.zenith_steering_angle[zenith_idx] / PI * 180. << endl;*/
			weight[0] = (0, 0);
			weight[1] = (0, 0);
			for (int k = 0; k < ue_antenna.K; k++) // vertical element
			{
				for (int l = 0; l < ue_antenna.L; l++) // horizental element
				{
					w = ue_analog_beam.virtualization_weight[zenith_idx][azimuth_idx][k][l];
					d_tx[0] = ue[ue_idx].d_tx[k][l][0][0][0]; //// [M][N][P][Mg][Ng] <panel0>		

					d_tx[1] = ue[ue_idx].d_tx[k][l][0][0][1]; //// [M][N][P][Mg][Ng] <panel1>		
					
					weight[0] += w * exp(j*2.0*PI / lamda_0 * dot(r_LOS, d_tx[0]));
					weight[1] += w * exp(j*2.0*PI / lamda_0 * dot(r_LOS, d_tx[1]));
				}
			}

			for (int panel_idx = 0; panel_idx<2; panel_idx++)
			{
				for (int pol_idx = 0; pol_idx < 2; pol_idx++)
				{
					ue_port_LOS_field[panel_idx][pol_idx][zenith_idx][azimuth_idx].theta = weight[panel_idx] * F_LOS[panel_idx][pol_idx].theta;
					ue_port_LOS_field[panel_idx][pol_idx][zenith_idx][azimuth_idx].phi = weight[panel_idx] * F_LOS[panel_idx][pol_idx].phi;
				}
			}
			/*
			cout << "azimuth : " << Transform_angle_minus_180_to_plus_180(ue_analog_beam.azimuth_steering_angle[azimuth_idx]*180/PI+ue[ue_idx].alpha) << endl;
			cout << "zenith : "<< ue_analog_beam.zenith_steering_angle[zenith_idx] * 180 / PI << endl;
			cout << pow(abs(ue_port_LOS_field[0][0][zenith_idx][azimuth_idx].theta), 2) + pow(abs(ue_port_LOS_field[0][0][zenith_idx][azimuth_idx].phi), 2) << endl;
			cout << pow(abs(ue_port_LOS_field[0][1][zenith_idx][azimuth_idx].theta), 2) + pow(abs(ue_port_LOS_field[0][1][zenith_idx][azimuth_idx].phi), 2) << endl;
			cout << endl;
			*/
		}
	}
}
void Generate_ue_port_NLOS_field(int ue_idx, int sec_idx,ANTENNA_FIELD_COMPLEX ue_port_NLOS_field[][2][2][4][20][20])
{
	complex <double> j(0.0, 1.0);
	complex <double> weight[2];
	complex <double> w;
	int bs_idx = sec_idx / num_TRxP_per_site;
	
	LOCATION d_tx[2];
	LOCATION r_NLOS[20][20];
	ANTENNA_FIELD F_NLOS[2][2][20][20];//panel,pol

	int fast_fading_condition = channel[bs_idx][ue_idx].fast_fading_condition;
	int N = channel[bs_idx][ue_idx].num_cluster;
	int M = num_ray_per_cluster[fast_fading_condition];

	
	for (int panel_idx = 0; panel_idx < 2; panel_idx++)
	{
		for (int pol_idx = 0; pol_idx < 2; pol_idx++)
		{
			for (int cluster_idx = 0; cluster_idx < N; cluster_idx++)
			{
				for (int ray_idx = 0; ray_idx < M; ray_idx++)
				{
					r_NLOS[cluster_idx][ray_idx] = channel[bs_idx][ue_idx].r_tx[cluster_idx][ray_idx];

					F_NLOS[panel_idx][pol_idx][cluster_idx][ray_idx] = channel[bs_idx][ue_idx].GCS_NLOS_departure_field[panel_idx][pol_idx][cluster_idx][ray_idx];
					F_NLOS[panel_idx][pol_idx][cluster_idx][ray_idx] = channel[bs_idx][ue_idx].GCS_NLOS_departure_field[panel_idx][pol_idx][cluster_idx][ray_idx];
				}
			}
		}
	}
	


			/*cout << "azimuth : " << channel[bs_idx][ue_idx].GCS_Departure_angle_NLOS[cluster_idx][ray_idx].phi << endl;;
			cout << "zenith : " << channel[bs_idx][ue_idx].GCS_Departure_angle_NLOS[cluster_idx][ray_idx].theta << endl;;
			cout << "---------------------------" << endl;
			*/
	for (int zenith_idx = 0; zenith_idx < ue_analog_beam.num_steering_zenith_angle; zenith_idx++)
	{
		for (int azimuth_idx = 0; azimuth_idx < ue_analog_beam.num_steering_azimuth_angle; azimuth_idx++)
		{

			for (int cluster_idx = 0; cluster_idx < N; cluster_idx++)
			{
				for (int ray_idx = 0; ray_idx < M; ray_idx++)
				{
					weight[0] = (0, 0);
					weight[1] = (0, 0);
					for (int k = 0; k < ue_antenna.K; k++) // vertical element
					{
						for (int l = 0; l < ue_antenna.L; l++) // horizental element
						{
							w = ue_analog_beam.virtualization_weight[zenith_idx][azimuth_idx][k][l];
							d_tx[0] = ue[ue_idx].d_tx[k][l][0][0][0]; //// [M][N][P][Mg][Ng] <panel0>		
							
							d_tx[1] = ue[ue_idx].d_tx[k][l][0][0][1]; //// [M][N][P][Mg][Ng] <panel0>		
								

							//d_tx[0] = ue[ue_idx].d_tx[k][l][0][0][0]; //// <panel0>		
						//	d_tx[1] = ue[ue_idx].d_tx[k][l][0][0][1]; //// <panel1>		
							weight[0] += w*exp(j*2.0*PI / lamda_0 * dot(r_NLOS[cluster_idx][ray_idx], d_tx[0]));
							weight[1] += w*exp(j*2.0*PI / lamda_0 * dot(r_NLOS[cluster_idx][ray_idx], d_tx[1]));
						}
					}
					for (int panel_idx = 0; panel_idx<2; panel_idx++)
					{
						for (int pol_idx = 0; pol_idx < 2; pol_idx++)
						{
							ue_port_NLOS_field[panel_idx][pol_idx][zenith_idx][azimuth_idx][cluster_idx][ray_idx].theta = weight[panel_idx] * F_NLOS[panel_idx][pol_idx][cluster_idx][ray_idx].theta;
							ue_port_NLOS_field[panel_idx][pol_idx][zenith_idx][azimuth_idx][cluster_idx][ray_idx].phi = weight[panel_idx] * F_NLOS[panel_idx][pol_idx][cluster_idx][ray_idx].phi;
						}
					}
					
				/*	cout << "azimuth : " << Transform_angle_minus_180_to_plus_180(ue_analog_beam.azimuth_steering_angle[azimuth_idx] * 180 / PI) << endl;
					cout << "zenith : " << ue_analog_beam.zenith_steering_angle[zenith_idx] * 180 / PI << endl;
					cout << pow(abs(ue_port_NLOS_field[0][0][zenith_idx][azimuth_idx][cluster_idx][ray_idx].theta), 2) + pow(abs(ue_port_NLOS_field[0][0][zenith_idx][azimuth_idx][cluster_idx][ray_idx].phi), 2) << endl;
					cout << pow(abs(ue_port_NLOS_field[1][1][zenith_idx][azimuth_idx][cluster_idx][ray_idx].theta), 2) + pow(abs(ue_port_NLOS_field[1][1][zenith_idx][azimuth_idx][cluster_idx][ray_idx].phi), 2) << endl;
					cout << endl;*/

				}
			}

		}
		//getchar();
	}


}
void Generate_antenna_element_LOS_field(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX ue_antenna_element_LOS_field[][2])
{
	int bs_idx = sec_idx / num_TRxP_per_site;
	complex <double> j(0.0, 1.0);
	LOCATION r_LOS = channel[bs_idx][ue_idx].r_tx_LOS;;
	LOCATION d_tx;

	for (int n = 0; n < ue_antenna.N; n++) // horizental element
	{
		for (int pol_idx = 0; pol_idx < 2; pol_idx++)
		{
			d_tx = ue[ue_idx].d_tx[0][n][pol_idx][0][0]; //// [M][N][P][Mg][Ng] <panel0>		

			ue_antenna_element_LOS_field[n][pol_idx].theta = exp(j*2.0*PI / lamda_0 * dot(r_LOS, d_tx)) * channel[bs_idx][ue_idx].GCS_LOS_departure_field[0][pol_idx].theta;//  d_tx[M][N][P][Mg][Ng] <panel0>
			
			ue_antenna_element_LOS_field[n][pol_idx].phi = exp(j*2.0*PI / lamda_0 * dot(r_LOS, d_tx)) * channel[bs_idx][ue_idx].GCS_LOS_departure_field[0][pol_idx].phi;// d_tx[M][N][P][Mg][Ng] <panel0>
		}
	}
}
void Generate_antenna_element_NLOS_field(int ue_idx, int sec_idx,ANTENNA_FIELD_COMPLEX ue_antenna_element_NLOS_field[][2][20][20])
{
	complex <double> j(0.0, 1.0);
	
	int bs_idx = sec_idx / num_TRxP_per_site;
	int fast_fading_condition = channel[bs_idx][ue_idx].fast_fading_condition;
	int N = channel[bs_idx][ue_idx].num_cluster;
	int M = num_ray_per_cluster[fast_fading_condition];
	
	LOCATION d_tx;

	LOCATION r_NLOS[20][20];
	
	for (int cluster_idx = 0; cluster_idx < N; cluster_idx++)
	{
		for (int ray_idx = 0; ray_idx < M; ray_idx++)
		{
			r_NLOS[cluster_idx][ray_idx] = channel[bs_idx][ue_idx].r_tx[cluster_idx][ray_idx];
		}
	}

	for (int n = 0; n < ue_antenna.N; n++) // horizental element
	{
		for (int pol_idx = 0; pol_idx < 2; pol_idx++)
		{	
			//cout << "------------ " << endl;
			for (int cluster_idx = 0; cluster_idx < N; cluster_idx++)
			{
				for (int ray_idx = 0; ray_idx < M; ray_idx++)
				{
					d_tx = ue[ue_idx].d_tx[0][n][pol_idx][0][0];

					ue_antenna_element_NLOS_field[n][pol_idx][cluster_idx][ray_idx].theta = exp(j*2.0*PI / lamda_0 * dot(r_NLOS[cluster_idx][ray_idx], d_tx)) * channel[bs_idx][ue_idx].GCS_NLOS_departure_field[0][pol_idx][cluster_idx][ray_idx].theta;//  d_tx[M][N][P][Mg][Ng] <panel0>
					ue_antenna_element_NLOS_field[n][pol_idx][cluster_idx][ray_idx].phi = exp(j*2.0*PI / lamda_0 * dot(r_NLOS[cluster_idx][ray_idx], d_tx)) * channel[bs_idx][ue_idx].GCS_NLOS_departure_field[0][pol_idx][cluster_idx][ray_idx].phi;// d_tx[M][N][P][Mg][Ng] <panel0>	
/*
					cout <<"theta : "<< ue_antenna_element_NLOS_field[l][pol_idx][cluster_idx][ray_idx].theta << endl;
					cout<<"phi"<< ue_antenna_element_NLOS_field[l][pol_idx][cluster_idx][ray_idx].phi <<endl;
					cout << pow(abs(ue_antenna_element_NLOS_field[l][pol_idx][cluster_idx][ray_idx].phi), 2) + pow(abs(ue_antenna_element_NLOS_field[l][pol_idx][cluster_idx][ray_idx].theta), 2) << endl;
					cout << endl;*/
				}
			}
		}
		//getchar();
	}	
}

double Calculate_Coupling_loss_dirctional_ue(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX sector_port0_LOS_field[][8], ANTENNA_FIELD_COMPLEX sector_port0_NLOS_field[][8][20][20], ANTENNA_FIELD_COMPLEX ue_port_LOS_field[][2][2][4], ANTENNA_FIELD_COMPLEX ue_port_NLOS_field[][2][2][4][20][20], STEERING_IDX steering_idx[])
{
	double sum_of_alpha_LOS[2]; // [panel]
	double sum_of_alpha_NLOS[2]; // [panel]
	
	int bs_idx = sec_idx / num_TRxP_per_site;
	int panel_idx = 0;
	steering_idx[sec_idx].sector_azimuth = 0;
	steering_idx[sec_idx].sector_zenith = 0;
	steering_idx[sec_idx].ue_azimuth= 0;
	steering_idx[sec_idx].ue_zenith= 0;
	steering_idx[sec_idx].ue_panel = 0;

	double max_Coupling_loss = 0;
	double Coupling_loss = 0;
	
	for (int sec_azimuth_idx = 0;  sec_azimuth_idx< bs_analog_beam.num_steering_azimuth_angle;  sec_azimuth_idx++)
	{
		for (int  sec_zenith_idx = 0;  sec_zenith_idx < bs_analog_beam.num_steering_zenith_angle; sec_zenith_idx++)
		{		
			for (int ue_azimuth_idx = 0; ue_azimuth_idx< ue_analog_beam.num_steering_azimuth_angle; ue_azimuth_idx++)
			{
				for (int ue_zenith_idx = 0; ue_zenith_idx < ue_analog_beam.num_steering_zenith_angle; ue_zenith_idx++)
				{
					sum_of_alpha_LOS[0] = 0;
					sum_of_alpha_LOS[1] = 0;

					sum_of_alpha_NLOS[0] = 0;
					sum_of_alpha_NLOS[1] = 0;
					
					if (channel[sec_idx / num_TRxP_per_site][ue_idx].fast_fading_condition == LOS)
					{
						Compute_sum_of_alpha_LOS_directional_ue(sec_zenith_idx, sec_azimuth_idx, ue_zenith_idx, ue_azimuth_idx , ue_idx, sec_idx, sum_of_alpha_LOS, sector_port0_LOS_field, ue_port_LOS_field); //36.873 8.1-1 sum[ | alpha_0^2 | ]
					}
					
				/*	cout << "sum_of_alpha_LOS0 : "<<sum_of_alpha_LOS[0] << endl;
					cout << "sum_of_alpha_LOS1 : " << sum_of_alpha_LOS[1] << endl;
					cout << "sum_of_alpha_NLOS0 : " << sum_of_alpha_NLOS[0] << endl;
					cout << "sum_of_alpha_NLOS1 : "<<sum_of_alpha_NLOS[1] << endl;
					*/
					
					Compute_sum_of_alpha_NLOS_directional_ue(sec_zenith_idx, sec_azimuth_idx, ue_zenith_idx, ue_azimuth_idx,  ue_idx, sec_idx, sum_of_alpha_NLOS, sector_port0_NLOS_field, ue_port_NLOS_field); //36.873 8.1-1 sum[ | alpha_0^2 | ]
				
				/*	cout << sum_of_alpha_LOS[0] + sum_of_alpha_NLOS[0] << endl;
					cout << sum_of_alpha_LOS[1] + sum_of_alpha_NLOS[1] << endl;*/

					channel[bs_idx][ue_idx].couplingloss[sec_idx%num_TRxP_per_site][sec_zenith_idx][sec_azimuth_idx][ue_zenith_idx][ue_azimuth_idx][0]= channel[bs_idx][ue_idx].SF*channel[bs_idx][ue_idx].pathloss* (sum_of_alpha_LOS[0] + sum_of_alpha_NLOS[0]) / (ue_antenna.num_txru/2);
					channel[bs_idx][ue_idx].couplingloss[sec_idx%num_TRxP_per_site][sec_zenith_idx][sec_azimuth_idx][ue_zenith_idx][ue_azimuth_idx][1] = channel[bs_idx][ue_idx].SF*channel[bs_idx][ue_idx].pathloss* (sum_of_alpha_LOS[1] + sum_of_alpha_NLOS[1]) / (ue_antenna.num_txru/2);

					if ((sum_of_alpha_LOS[0] + sum_of_alpha_NLOS[0])> (sum_of_alpha_LOS[1] + sum_of_alpha_NLOS[1]))
					{
						Coupling_loss = channel[bs_idx][ue_idx].SF*channel[bs_idx][ue_idx].pathloss* (sum_of_alpha_LOS[0] + sum_of_alpha_NLOS[0])/ (ue_antenna.num_txru / 2);
						panel_idx = 0;
					}
					else
					{
						Coupling_loss = channel[bs_idx][ue_idx].SF*channel[bs_idx][ue_idx].pathloss *(sum_of_alpha_LOS[1] + sum_of_alpha_NLOS[1]) / (ue_antenna.num_txru / 2);
						panel_idx = 1;
					}
					
					if (Coupling_loss > max_Coupling_loss)
					{
						steering_idx[sec_idx].sector_azimuth = sec_azimuth_idx;
						steering_idx[sec_idx].sector_zenith = sec_zenith_idx;
						steering_idx[sec_idx].ue_azimuth = ue_azimuth_idx;
						steering_idx[sec_idx].ue_zenith = ue_zenith_idx;
						steering_idx[sec_idx].ue_panel = panel_idx;

						max_Coupling_loss = Coupling_loss;						
					}

				}
			}
		}
	}
	//cout << sec_idx << endl;

	//cout << max_Coupling_loss << endl;

	return max_Coupling_loss;
}

void Compute_sum_of_alpha_LOS_directional_ue(int  sec_zenith_idx, int sec_azimuth_idx, int  ue_zenith_idx, int ue_azimuth_idx, int ue_idx, int sec_idx, double sum_of_alpha_LOS[], ANTENNA_FIELD_COMPLEX sector_port0_LOS_field[][8], ANTENNA_FIELD_COMPLEX ue_port_LOS_field[][2][2][4])
{
	ANTENNA_FIELD_COMPLEX F_ue;// num_txru
	ANTENNA_FIELD_COMPLEX F_sector;
	complex <double> j(0.0, 1.0);
	complex <double> alpha;

	int bs_idx = sec_idx / num_TRxP_per_site;
	double K = channel[bs_idx][ue_idx].LSPs[LOS_K];
	double K_R= pow(10, K / 10);
	double PHI_LOS = - 2.*PI*channel[bs_idx][ue_idx]._3D_distance / lamda_0; // m.2412
	complex <double> exp_j_PHI_LOS= exp(j*PHI_LOS);
	
	/*cout << "K : "<<K << endl;
	cout << "K_R : "<<K_R << endl;
	cout << "Phi_LOS : " << Phi_LOS << endl;
	cout << "exp_jPhi_LOS : " << exp_jPhi_LOS << endl;*/
	F_sector = sector_port0_LOS_field[sec_zenith_idx][sec_azimuth_idx];

	/*cout<<" F_sector.phi  : " << F_sector.phi << endl;
	cout<<"F_sector.theta : " << F_sector.theta << endl;
*/
	for (int panel_idx = 0; panel_idx < 2; panel_idx++)
	{
		for (int pol_idx = 0; pol_idx <  ue_antenna.P; pol_idx++)
		{
			F_ue = ue_port_LOS_field[panel_idx][pol_idx][ue_zenith_idx][ue_azimuth_idx];

			//cout << "F_ue.phi : "<<F_ue.phi << endl;
			//cout << "F_ue.theta : " << F_ue.theta << endl;

			alpha = sqrt(K_R / (K_R + 1))*(F_sector.theta * F_ue.theta* exp_j_PHI_LOS - F_sector.phi * F_ue.phi* exp_j_PHI_LOS);
			
			//cout << "alpha"<< alpha << endl;
			sum_of_alpha_LOS[panel_idx] += pow(abs(alpha),2);

			//cout << "sum_of_alpha_LOS[" << panel_idx << "] : " << sum_of_alpha_LOS[panel_idx] << endl;
			//getchar();
		}
	}
}
void Compute_sum_of_alpha_NLOS_directional_ue(int  sec_zenith_idx, int sec_azimuth_idx, int  ue_zenith_idx, int ue_azimuth_idx, int ue_idx, int sec_idx, double sum_of_alpha_NLOS[], ANTENNA_FIELD_COMPLEX sector_port0_NLOS_field[][8][20][20], ANTENNA_FIELD_COMPLEX ue_port_NLOS_field[][2][2][4][20][20])
{
	ANTENNA_FIELD_COMPLEX F_ue;// num_txru
	ANTENNA_FIELD_COMPLEX F_sector;
	complex <double> j(0.0, 1.0);
	complex <double> alpha;
	

	int bs_idx = sec_idx / num_TRxP_per_site;
	double K = channel[bs_idx][ue_idx].LSPs[LOS_K];
	double K_R = pow(10, K / 10);
	double Phi_LOS = -2.*PI*channel[bs_idx][ue_idx]._3D_distance / lamda_0; // m.2412
	double kappa;
	double power_term;
	double _1_over_sqrt_K;
	double cluster_power;
	RANDOM_INITIAL_PHASE exp_j_PHI;

	int fast_fading_condition = channel[bs_idx][ue_idx].fast_fading_condition;
	int N = channel[bs_idx][ue_idx].num_cluster;
	int M = num_ray_per_cluster[fast_fading_condition];
	
	if (fast_fading_condition != LOS )
	{
		K_R = 0;
	}

	for (int cluster_idx = 0; cluster_idx < N; cluster_idx++)
	{
		cluster_power =channel[bs_idx][ue_idx].cluster_power[cluster_idx];

		power_term = sqrt(cluster_power / (M*(K_R + 1)));

		for (int ray_idx = 0; ray_idx < M; ray_idx++)
		{
			F_sector = sector_port0_NLOS_field[sec_zenith_idx][sec_azimuth_idx][cluster_idx][ray_idx];
			kappa = channel[bs_idx][ue_idx].kappa[cluster_idx][ray_idx]; 
			_1_over_sqrt_K = 1.0/sqrt(kappa);
			exp_j_PHI = channel[bs_idx][ue_idx].exp_j_PHI[cluster_idx][ray_idx];
			
			for (int panel_idx = 0; panel_idx < 2; panel_idx++)
			{
				for (int pol_idx = 0; pol_idx <  ue_antenna.P; pol_idx++)
				{
					F_ue = ue_port_NLOS_field[panel_idx][pol_idx][ue_zenith_idx][ue_azimuth_idx][cluster_idx][ray_idx];

					alpha = power_term *(F_sector.theta * F_ue.theta* exp_j_PHI.theta_theta + _1_over_sqrt_K*F_sector.theta * F_ue.phi*exp_j_PHI.theta_phi+ _1_over_sqrt_K*F_sector.phi * F_ue.theta* exp_j_PHI.phi_theta+ F_sector.phi * F_ue.phi* exp_j_PHI.phi_phi);

					sum_of_alpha_NLOS[panel_idx] += pow(abs(alpha), 2);
				}
			}
		}	
	}
	
}

double Calculate_Coupling_loss_omni_dirctional_ue(int ue_idx, int sec_idx, ANTENNA_FIELD_COMPLEX sector_port0_LOS_field[][8], ANTENNA_FIELD_COMPLEX sector_port0_NLOS_field[][8][20][20], ANTENNA_FIELD_COMPLEX ue_antenna_element_LOS_field[][2], ANTENNA_FIELD_COMPLEX ue_antenna_element_NLOS_field[][2][20][20], STEERING_IDX steering_idx[])
{
	double sum_of_alpha_LOS; 
	double sum_of_alpha_NLOS;

	int bs_idx = sec_idx / num_TRxP_per_site;
	int panel_idx = 0;
	
	steering_idx[sec_idx].sector_azimuth = 0;
	steering_idx[sec_idx].sector_zenith = 0;

	double max_Coupling_loss = 0;
	double Coupling_loss = 0;



	for (int sec_azimuth_idx = 0; sec_azimuth_idx< bs_analog_beam.num_steering_azimuth_angle; sec_azimuth_idx++)
	{

		//cout << "sec_azimuth_idx :"<< sec_azimuth_idx << endl;
		for (int sec_zenith_idx = 0; sec_zenith_idx < bs_analog_beam.num_steering_zenith_angle; sec_zenith_idx++)
		{
			// cout << "sec_zenith_idx :" << sec_zenith_idx << endl;
			
			sum_of_alpha_LOS = 0;
			sum_of_alpha_NLOS = 0;
				
			if (channel[sec_idx / num_TRxP_per_site][ue_idx].fast_fading_condition == LOS)
			{
				sum_of_alpha_LOS = Compute_sum_of_alpha_LOS_omni_directiona_ue(sec_zenith_idx, sec_azimuth_idx, ue_idx, sec_idx, sector_port0_LOS_field, ue_antenna_element_LOS_field); //36.873 8.1-1 sum[ | alpha_0^2 | ]
				/*cout <<"sum_of_alpha_LOS : "<< sum_of_alpha_LOS << endl;
				getchar();*/
			}

			sum_of_alpha_NLOS = Compute_sum_of_alpha_NLOS_omni_directional_ue(sec_zenith_idx, sec_azimuth_idx, ue_idx, sec_idx, sector_port0_NLOS_field, ue_antenna_element_NLOS_field);
			
			//cout << "sum_of_alpha_NLOS : " << sum_of_alpha_NLOS << endl;
			
			//Ŀøν  _omni antenna
			Coupling_loss = channel[bs_idx][ue_idx].SF*channel[bs_idx][ue_idx].pathloss*(sum_of_alpha_LOS + sum_of_alpha_NLOS) / ue_antenna.num_txru;//
			//Coupling_loss = (+sum_of_alpha_NLOS ) / ue_antenna.num_txru;//sum_of_alpha_LOS
			//Coupling_loss = channel[bs_idx][ue_idx].SF*channel[bs_idx][ue_idx].pathloss;

		
			channel[bs_idx][ue_idx].couplingloss[sec_idx % num_TRxP_per_site][sec_zenith_idx][sec_azimuth_idx][0][0][0]= Coupling_loss;

			if (Coupling_loss > max_Coupling_loss)
			{
				steering_idx[sec_idx].sector_azimuth = sec_azimuth_idx;
				steering_idx[sec_idx].sector_zenith = sec_zenith_idx;

				max_Coupling_loss = Coupling_loss;
			}
		}
	}

	//if (bs_idx==ue_idx/30)
	//{
	//	cout << " sec_idx : " << sec_idx << endl;
	//	cout << "pathloss :" <<10*log10( channel[bs_idx][ue_idx].SF*channel[bs_idx][ue_idx].pathloss) << endl;
	//	cout << "Coupling_loss : "<<10 * log10(max_Coupling_loss) << endl;
	//	cout << "Departure_angle.phi : "<<channel[bs_idx][ue_idx].GCS_Departure_angle_LOS.phi << endl;
	//	cout << "Departure_angle.theta : " << channel[bs_idx][ue_idx].GCS_Departure_angle_LOS.theta << endl;
	//}
	
	//getchar();
	return max_Coupling_loss;
}
double Compute_sum_of_alpha_LOS_omni_directiona_ue(int sec_zenith_idx, int  sec_azimuth_idx, int ue_idx, int sec_idx , ANTENNA_FIELD_COMPLEX sector_port0_LOS_field[][8], ANTENNA_FIELD_COMPLEX ue_antenna_element_LOS_field[][2])
{

	ANTENNA_FIELD_COMPLEX F_ue;// num_txru
	ANTENNA_FIELD_COMPLEX F_sector;
	complex <double> j(0.0, 1.0);
	complex <double> alpha;

	int bs_idx = sec_idx / num_TRxP_per_site;
	double K = channel[bs_idx][ue_idx].LSPs[LOS_K];
	double K_R = pow(10, K / 10);
	double PHI_LOS = -2.*PI*channel[bs_idx][ue_idx]._3D_distance / lamda_0; // m.2412
	complex <double> exp_j_PHI_LOS = exp(j*PHI_LOS);;

	double sum_of_alpha = 0;

	/*cout << "ue_idx : " << ue_idx << endl;
	cout << "sec_idx : " << sec_idx << endl;
	cout << "K : "<<K << endl;
	cout << "K_R : "<<K_R << endl;
	cout << "Phi_LOS : " << PHI_LOS << endl;
	cout << "exp_jPhi_LOS : " << exp_j_PHI_LOS << endl;
	getchar();*/
	
	F_sector = sector_port0_LOS_field[sec_zenith_idx][sec_azimuth_idx];
	
	/*cout<<" F_sector.phi  : " << F_sector.phi << endl;
	cout<<"F_sector.theta : " << F_sector.theta << endl;
	getchar();*/

	for (int n = 0; n <ue_antenna.N; n++) // horizental element
	{
		for (int pol_idx = 0; pol_idx < ue_antenna.P; pol_idx++)
		{
			
			F_ue = ue_antenna_element_LOS_field[n][pol_idx];
			
			//cout << "F_ue.phi : "<<F_ue.phi << endl;
			//cout << "F_ue.theta : " << F_ue.theta << endl;

			alpha =  sqrt(K_R / (K_R + 1)) *(F_sector.theta * F_ue.theta* exp_j_PHI_LOS - F_sector.phi * F_ue.phi* exp_j_PHI_LOS);
			
			//cout << "alpha"<< alpha << endl;
			sum_of_alpha += pow(abs(alpha), 2);

			//cout << "sum_of_alpha_LOS[" << panel_idx << "] : " << sum_of_alpha_LOS[panel_idx] << endl;
			//getchar();
		}
	}

	//getchar();
	


	return sum_of_alpha;
}
double Compute_sum_of_alpha_NLOS_omni_directional_ue(int sec_zenith_idx, int sec_azimuth_idx, int ue_idx, int sec_idx,  ANTENNA_FIELD_COMPLEX sector_port0_NLOS_field[][8][20][20], ANTENNA_FIELD_COMPLEX  ue_antenna_element_NLOS_field[][2][20][20])
{
	ANTENNA_FIELD_COMPLEX F_ue;// num_txru
	ANTENNA_FIELD_COMPLEX F_sector;
	complex <double> j(0.0, 1.0);
	complex <double> alpha;


	int bs_idx = sec_idx / num_TRxP_per_site;
	double K = channel[bs_idx][ue_idx].LSPs[LOS_K];
	double K_R = pow(10, K / 10);
	double Phi_LOS = -2.*PI*channel[bs_idx][ue_idx]._3D_distance / lamda_0; // m.2412
	double kappa;
	double power_term;
	double _1_over_sqrt_K;
	double cluster_power;
	RANDOM_INITIAL_PHASE exp_j_PHI;
	double sum_of_alpha=0;

	int fast_fading_condition = channel[bs_idx][ue_idx].fast_fading_condition;
	int N = channel[bs_idx][ue_idx].num_cluster;
	int M = num_ray_per_cluster[fast_fading_condition];

	if (fast_fading_condition != LOS)
	{
		K_R = 0;
	}


	for (int n = 0; n <ue_antenna.Np; n++) // horizental element
	{
		for (int pol_idx = 0; pol_idx < ue_antenna.P; pol_idx++)
		{
			
			for (int cluster_idx = 0; cluster_idx < N; cluster_idx++)
			{
				cluster_power = channel[bs_idx][ue_idx].cluster_power[cluster_idx];
				//cout << cluster_power << endl;
		
				//cout << cluster_power << endl;

				power_term = sqrt(cluster_power/ (M*(K_R + 1)));

				for (int ray_idx = 0; ray_idx < M; ray_idx++)
				{	
					F_sector = sector_port0_NLOS_field[sec_zenith_idx][sec_azimuth_idx][cluster_idx][ray_idx];
					kappa = channel[bs_idx][ue_idx].kappa[cluster_idx][ray_idx]; 
					_1_over_sqrt_K = 1.0 / sqrt(kappa);
					exp_j_PHI = channel[bs_idx][ue_idx].exp_j_PHI[cluster_idx][ray_idx];
					F_ue = ue_antenna_element_NLOS_field[n][pol_idx][cluster_idx][ray_idx];					
				
					/*exp_j_PHI.theta_theta = 1;
					exp_j_PHI.theta_phi = 1;
					exp_j_PHI.phi_phi = 1;
					exp_j_PHI.phi_theta = 1;*/
			
					//alpha = power_term * (F_sector.theta * F_ue.theta* exp_j_PHI.theta_theta + _1_over_sqrt_K * F_sector.theta * F_ue.phi*exp_j_PHI.theta_phi + _1_over_sqrt_K * F_sector.phi * F_ue.theta* exp_j_PHI.phi_theta + F_sector.phi * F_ue.phi* exp_j_PHI.phi_phi);
					alpha =  power_term*(F_sector.theta * F_ue.theta* exp_j_PHI.theta_theta + _1_over_sqrt_K * F_sector.theta * F_ue.phi*exp_j_PHI.theta_phi + _1_over_sqrt_K * F_sector.phi * F_ue.theta* exp_j_PHI.phi_theta + F_sector.phi * F_ue.phi* exp_j_PHI.phi_phi);
					sum_of_alpha+= pow(abs(alpha), 2); 
				}
			}
		}
	}

	//getchar();
	return sum_of_alpha;
}
void Calculate_geometry(int ue_idx)
{
	double signal =dB2linear( ue[ue_idx].couplingloss_dB);
	double interference = 0;
	int bs_idx = 0;
	int sec_zenith_idx;
	int sec_azimuth_idx;
	int ue_zenith_idx = ue[ue_idx].zenith_steering_idx;
	int ue_azimuth_idx= ue[ue_idx].azimuth_steering_idx;
	int panel_idx = ue[ue_idx].panel_idx;
	
	
	for (int sec_idx = 0; sec_idx < num_sector; sec_idx++)
	{	
		if (sec_idx != ue[ue_idx].sector_in_control)
		{
			bs_idx = sec_idx / num_TRxP_per_site;

			sec_zenith_idx = int(Rand.u()*double(bs_analog_beam.num_steering_zenith_angle)); // sector[sec_idx].zenith_steering_idx[_ue_idx];// //  //// 
			
			sec_azimuth_idx = int(Rand.u()*double(bs_analog_beam.num_steering_azimuth_angle)); //sector[sec_idx].azimuth_steering_idx[_ue_idx]; // //  // //

			if (ue_antenna.Ng == 2)
			{
				interference += channel[bs_idx][ue_idx].couplingloss[sec_idx % num_TRxP_per_site][sec_zenith_idx][sec_azimuth_idx][ue_zenith_idx][ue_azimuth_idx][panel_idx];
			}
			else
			{
				interference += channel[bs_idx][ue_idx].couplingloss[sec_idx % num_TRxP_per_site][sec_zenith_idx][sec_azimuth_idx][0][0][0];
			}			
		}
		
	}

	double thermal = dBm2linear(thermal_nosie_level+10*log10(simulation_bandwidth )+ue_noise_figure) ;
	double tx_power = dBm2linear(TRxP_power);
	//cout << "signal :" << signal << endl;
	//cout << "interference :" << interference << endl;
	ue[ue_idx].geometry = 10*log10( signal*tx_power / ((interference*tx_power+ thermal)));
		
}

void PIot_sector_antenna_gain()
{

	complex <double> w;
	LOCATION r_rx;
	LOCATION d_rx[3];
	complex <double> weight[3];
	complex <double> j(0.0, 1.0);
	SPHERICAL_ANGLE A;
	SPHERICAL_ANGLE A_LCS[3];
	double antenna_gain[3];
	ANTENNA_FIELD F[3];
	ANTENNA_FIELD F_LCS[3];

	ofstream x;
	ofstream y;
	
	x.open("output/x.dat");
	y.open("output/y.dat");
	for (int theta = 0; theta < 181; theta++)
	{
		for (int phi = -180; phi < 181; phi++)
		{
			r_rx = Transform_angle_to_spheical_vector(double(phi), double(theta));
			x << r_rx.x << '\t';
			y << r_rx.y << '\t';
		}
		x << endl;
		y << endl;
	}
	x.close();
	y.close();
	

	if (test_environment == InH_eMBB_A)
	{
		ofstream out;
		string filename;

		stringstream fn;
		fn << "output/sector_gain/InH_eMBB_A.dat";
		filename = fn.str();
		out.open(filename);
		for (int theta = 0; theta < 181; theta++)
		{
			for (int phi = -180; phi < 181; phi++)
			{
				A.phi = double(phi);
				A.theta = double(theta);

				A_LCS[0] = GCS_Angle_to_LCS_Angle(sector[0].alpha, sector[0].beta, sector[0].gamma, A);
				
				antenna_gain[0] = Sector_Antenna_gain_in_dB(A_LCS[0]);
				
				F_LCS[0] = Antenna_field_in_LCS(antenna_gain[0], 45);
				
				F[0] = LCS_Antenna_field_to_GCS_antenna_pattern(sector[0].alpha, sector[0].beta, sector[0].gamma, A, F_LCS[0]);
				
				r_rx = Transform_angle_to_spheical_vector(double(phi), double(theta));

				d_rx[0] = sector[0].d_rx[0][0][0][0][0]; //// sector(rx) [M][N][P][Mg][Ng] <port0>

				out << pow(abs(exp(j*2.0*PI / lamda_0 * dot(r_rx, d_rx[0]))* F[0].theta), 2) + pow(abs(exp(j*2.0*PI / lamda_0 * dot(r_rx, d_rx[0]))* F[0].phi), 2) << '\t';
			}
			out << endl;
		}
	}
	else
	{
		ofstream out[3];
		string filename[3];
		for (int zenith_idx = 0; zenith_idx< bs_analog_beam.num_steering_zenith_angle; zenith_idx++)
		{
			cout << zenith_idx << endl;
			for (int azimuth_idx = 0; azimuth_idx< bs_analog_beam.num_steering_azimuth_angle; azimuth_idx++)
			{
				stringstream fn[3];
				fn[0] << "output/sector_gain/" << "sector_0_zenith_" << zenith_idx << "_azimuth_" << azimuth_idx << ".dat";
				fn[1] << "output/sector_gain/" << "sector_1_zenith_" << zenith_idx << "_azimuth_" << azimuth_idx << ".dat";
				fn[2] << "output/sector_gain/" << "sector_2_zenith_" << zenith_idx << "_azimuth_" << azimuth_idx << ".dat";

				filename[0] = fn[0].str();
				filename[1] = fn[1].str();
				filename[2] = fn[2].str();
				fn[0].clear();
				fn[1].clear();
				fn[2].clear();


				out[0].open(filename[0]);
				out[1].open(filename[1]);
				out[2].open(filename[2]);

				for (int theta = 0; theta<181; theta++)
				{
					for (int phi = -180; phi<181; phi++)
					{

						A.phi = double(phi);
						A.theta = double(theta);

						A_LCS[0] = GCS_Angle_to_LCS_Angle(sector[0].alpha, sector[0].beta, sector[0].gamma, A);
						A_LCS[1] = GCS_Angle_to_LCS_Angle(sector[1].alpha, sector[1].beta, sector[1].gamma, A);
						A_LCS[2] = GCS_Angle_to_LCS_Angle(sector[2].alpha, sector[2].beta, sector[2].gamma, A);



						antenna_gain[0] = Sector_Antenna_gain_in_dB(A_LCS[0]);
						antenna_gain[1] = Sector_Antenna_gain_in_dB(A_LCS[1]);
						antenna_gain[2] = Sector_Antenna_gain_in_dB(A_LCS[2]);

						F_LCS[0] = Antenna_field_in_LCS(antenna_gain[0], 45);
						F_LCS[1] = Antenna_field_in_LCS(antenna_gain[1], 45);
						F_LCS[2] = Antenna_field_in_LCS(antenna_gain[2], 45);

						F[0] = LCS_Antenna_field_to_GCS_antenna_pattern(sector[0].alpha, sector[0].beta, sector[0].gamma, A, F_LCS[0]);
						F[1] = LCS_Antenna_field_to_GCS_antenna_pattern(sector[1].alpha, sector[1].beta, sector[1].gamma, A, F_LCS[1]);
						F[2] = LCS_Antenna_field_to_GCS_antenna_pattern(sector[2].alpha, sector[2].beta, sector[2].gamma, A, F_LCS[2]);

						r_rx = Transform_angle_to_spheical_vector(double(phi), double(theta));

						weight[0] = (0, 0);
						weight[1] = (0, 0);
						weight[2] = (0, 0);

						for (int k = 0; k < bs_antenna.K; k++) // vertical element
						{
							for (int l = 0; l < bs_antenna.L; l++) // horizental element
							{
								w = bs_analog_beam.virtualization_weight[zenith_idx][azimuth_idx][k][l];
								d_rx[0] = sector[0].d_rx[k][l][0][0][0]; //// sector(rx) [M][N][P][Mg][Ng] <port0>
								d_rx[1] = sector[1].d_rx[k][l][0][0][0]; //// sector(rx) [M][N][P][Mg][Ng] <port0>
								d_rx[2] = sector[2].d_rx[k][l][0][0][0]; //// sector(rx) [M][N][P][Mg][Ng] <port0>

								weight[0] += w * exp(j*2.0*PI / lamda_0 * dot(r_rx, d_rx[0]));
								weight[1] += w * exp(j*2.0*PI / lamda_0 * dot(r_rx, d_rx[1]));
								weight[2] += w * exp(j*2.0*PI / lamda_0 * dot(r_rx, d_rx[2]));

							}
						}

						out[0] << pow(abs(weight[0] * F[0].theta), 2) + pow(abs(weight[0] * F[0].phi), 2) << '\t';
						out[1] << pow(abs(weight[1] * F[1].theta), 2) + pow(abs(weight[1] * F[1].phi), 2) << '\t';
						out[2] << pow(abs(weight[2] * F[2].theta), 2) + pow(abs(weight[2] * F[2].phi), 2) << '\t';

					}
					out[0] << endl;
					out[1] << endl;
					out[2] << endl;
				}
				out[0].close();
				out[1].close();
				out[2].close();

			}
		}
	}
	
	//cout<<"sector gain--" <<endl;
	//getchar();

}

void PIot_ue_antenna_gain()
{
	complex <double> w;
	LOCATION r_tx;
	LOCATION d_tx[2];
	complex <double> weight0(0, 0);
	complex <double> weight1(0, 0);
	complex <double> j(0.0, 1.0);
	ofstream out0;
	ofstream out1;
	ofstream x;
	ofstream y;
	SPHERICAL_ANGLE A;
	SPHERICAL_ANGLE A_LCS[2];
	double antenna_gain[2];
	ANTENNA_FIELD F_LOS[2];
	ANTENNA_FIELD F_LCS[2];

	x.open("output/x.dat");
	y.open("output/y.dat");
	for (int theta = 0; theta < 181; theta++)
	{
		for (int phi = -180; phi < 181; phi++)
		{
			r_tx = Transform_angle_to_spheical_vector(double(phi), double(theta));
			x << r_tx.x << '\t';
			y << r_tx.y << '\t';
		}
		x << endl;
		y << endl;
	}
	x.close();
	y.close();
	string filename[2];
	

	for (int zenith_idx = 0; zenith_idx< ue_analog_beam.num_steering_zenith_angle; zenith_idx++)
	{
		for (int azimuth_idx = 0; azimuth_idx< ue_analog_beam.num_steering_azimuth_angle; azimuth_idx++)
		{
			stringstream fn;
			stringstream fn1;

			fn << "output/" << "ue_pannel_0_zenith_" << zenith_idx << "_azimuth_" << azimuth_idx << ".dat";
			fn1 << "output/" << "ue_pannel_1_zenith_" << zenith_idx << "_azimuth_" << azimuth_idx << ".dat";
			filename[0] = fn.str();
			filename[1] = fn1.str();

			fn.clear();
			fn1.clear();

			out0.open(filename[0]);
			out1.open(filename[1]);

			for (int theta = 0; theta<181; theta++)
			{
				for (int phi = -180; phi<181; phi++)
				{
					A.theta = double(theta);
					A.phi = double(phi);

					A_LCS[0] = GCS_Angle_to_LCS_Angle(ue[0].alpha , ue[0].beta, ue[0].gamma, A);
					A_LCS[1] = GCS_Angle_to_LCS_Angle(ue[0].alpha + PI, ue[0].beta, ue[0].gamma, A);

					antenna_gain[0] = UE_Antenna_gain_in_dB(A_LCS[0]);
					antenna_gain[1] = UE_Antenna_gain_in_dB(A_LCS[1]);

					F_LCS[0] = Antenna_field_in_LCS(antenna_gain[0], 0);
					F_LCS[1] = Antenna_field_in_LCS(antenna_gain[1], 0);

					F_LOS[0] = LCS_Antenna_field_to_GCS_antenna_pattern(ue[0].alpha, ue[0].beta, ue[0].gamma, A, F_LCS[0]);
					F_LOS[1] = LCS_Antenna_field_to_GCS_antenna_pattern(ue[0].alpha+PI, ue[0].beta, ue[0].gamma, A, F_LCS[1]);

					r_tx = Transform_angle_to_spheical_vector(double(phi), double(theta));

					weight0 = (0, 0);
					weight1 = (0, 0);
					for (int k = 0; k < ue_antenna.K; k++) // vertical element
					{
						for (int l = 0; l < ue_antenna.L; l++) // horizental element
						{
							w = ue_analog_beam.virtualization_weight[zenith_idx][azimuth_idx][k][l];
							d_tx[0] = ue[0].d_tx[k][l][0][0][0]; //// sector(rx) [M][N][P][Mg][Ng] <port0>
							d_tx[1] = ue[0].d_tx[k][l][0][0][1];
							weight0 += w * exp(j*2.0*PI / lamda_0 * dot(r_tx, d_tx[0]));
							weight1 += w * exp(j*2.0*PI / lamda_0 * dot(r_tx, d_tx[1]));
						}
					}

					out0 << pow(abs(weight0 * F_LOS[0].theta),2)+ pow(abs(weight0 * F_LOS[0].phi), 2) << '\t';
					out1 << pow(abs(weight1 * F_LOS[1].theta), 2) + pow(abs(weight1 * F_LOS[1].phi), 2) << '\t';
				}
				out0 << endl;
				out1 << endl;
			}
			out0.close();
			out1.close();

		}

	}

	cout << "ue_antenna_gain_end" << endl;
	getchar();
}

double dot(LOCATION a, LOCATION b)
{
	return a.x*b.x + a.y*b.y + a.z*b.z;
}

int Max_idx(double *A, int size)
{
	int max_idx = 0;
	double max_value = 0;
	for (int n = 0; n< size; n++)
	{
		if (n == 0)
		{
			max_value = A[0];
		}
		else
		{
			if (A[n] > max_value)
			{
				max_value = A[n];
				max_idx = n;
			}
		}
	}
	return max_idx;
}