#include <stdio.h>
#include <fstream>
#include <iostream>
#include "evaluationConfigurerations.h"
#include "paramSimul.h"
#include "objectBSSectorUe.h"
#include "ue.h"
#include "channel.h"



using namespace std;


double trans_azimuth_angle_minus_180_to_180(double x);
double trans_zenith_angle_0_to_180(double x);

void Calculate_angle_in_GCS()
{
	
	for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
	{
		for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
		{
			double height = h_BS - ue[ue_idx].h_UT;

			SPHERICAL_ANGLE LOS_departure_angle;
			SPHERICAL_ANGLE LOS_arrival_angle;
					
			LOS_departure_angle.phi =  atan2(-channel[bs_idx][ue_idx].location.y, -channel[bs_idx][ue_idx].location.x) * 180. / PI;
			LOS_departure_angle.theta =  atan2(channel[bs_idx][ue_idx]._2D_distance, height) * 180. / PI ;

			LOS_arrival_angle.phi = atan2(channel[bs_idx][ue_idx].location.y, channel[bs_idx][ue_idx].location.x) * 180./ PI;
			LOS_arrival_angle.theta = atan2(channel[bs_idx][ue_idx]._2D_distance, -height) * 180. / PI ;
			
			channel[bs_idx][ue_idx].GCS_Departure_angle_LOS = LOS_departure_angle;
							
			channel[bs_idx][ue_idx].GCS_Arrival_angle_LOS = LOS_arrival_angle;

		}
	}
	
}

double trans_azimuth_angle_minus_180_to_180( double x)
{
	x = fmod(x, 360);

	if (x < 0)
	{
		x = x + 360;
	}

	x = x - 360 * floor(x / 180);

	return x;
}

double trans_zenith_angle_0_to_180(double x)
{
	x = fmod(x, 360);

	if (x < 0)
	{
		x = x + 360;
	}

	x = abs(x - 360 * floor(x / 180));

	return x;
}
