#include "channel.h"
#include <stdio.h>
#include <iostream>
#include <fstream>
#include "const.h"
#include "struct.h"
#include "paramSimul.h"
#include "paramFastFading.h"
#include "evaluationConfigurerations.h"
#include "objectBSSectorUe.h"

double dot(LOCATION a, LOCATION b);
  
Channel::Channel()
{
	
}

/*===================================================================
FUNCTION: UE::~UE()


AUTHOR: SJ

DESCRIPTION: UE Object Destructor

NOTES: Currently, nothing is done

===================================================================*/
Channel::~Channel()
{

}

void Channel::Configure(int bs_idx, int ue_idx)
{
	_ue_idx = ue_idx;
	_bs_idx = bs_idx;
}

void Channel::Compute_alpha_LOS()
{
	cout.unsetf(ios::fixed);
	complex <double> j(0.0, 1.0);
	complex <double> weight;
	complex <double> w;
	
	double K = LSPs[LOS_K];
	double K_R = pow(10, K / 10);


	ANTENNA_FIELD_COMPLEX *F_sector;
	ANTENNA_FIELD_COMPLEX *F_ue;
	LOCATION d_rx;
	LOCATION d_tx;
	F_sector = new ANTENNA_FIELD_COMPLEX[bs_antenna.num_txru];
	F_ue = new ANTENNA_FIELD_COMPLEX[ue_antenna.num_txru];
	

	num_ue_antenna_port = ue_antenna.num_txru;
	int num_bs_antenna_port = bs_antenna.num_txru;
	if (ue_antenna.Ng == 2)
	{
		num_ue_antenna_port = ue_antenna.num_txru / 2;
	}
	
	int tx_idx = 0;
	for (int m = 0; m < ue_antenna.Mp; m++) // vertical element
	{
		for (int n = 0; n < ue_antenna.Np; n++) // horizental element
		{
			if (ue_antenna.Ng == 2)
			{
				weight = (0, 0);
				for (int k = 0; k < ue_antenna.K; k++) // vertical element
				{
					for (int l = 0; l < ue_antenna.L; l++) // horizental element
					{
						w = ue_analog_beam.virtualization_weight[ue[_ue_idx].zenith_steering_idx][ue[_ue_idx].azimuth_steering_idx][k][l];
						d_tx = ue[_ue_idx].d_tx[k][l][0][0][ue[_ue_idx].panel_idx]; //// [M][N][P][Mg][Ng] <panel0>		
						weight += w * exp(j*2.0*PI / lamda_0 * dot(r_tx_LOS, d_tx));
					}
				}

				for (int pol_idx = 0; pol_idx < 2; pol_idx++)
				{
					F_ue[tx_idx].phi = GCS_LOS_departure_field[ue[_ue_idx].panel_idx][pol_idx].phi * weight;
					F_ue[tx_idx].theta = GCS_LOS_departure_field[ue[_ue_idx].panel_idx][pol_idx].theta * weight;
					tx_idx++;
				}
			}
			else
			{
				for (int pol_idx = 0; pol_idx < 2; pol_idx++)
				{
					d_tx = ue[_ue_idx].d_tx[m][n][pol_idx][0][0];
					F_ue[tx_idx].phi = GCS_LOS_departure_field[0][pol_idx].phi *exp(j*2.0*PI / lamda_0 * dot(r_tx_LOS, d_tx));
					F_ue[tx_idx].theta = GCS_LOS_departure_field[0][pol_idx].theta * exp(j*2.0*PI / lamda_0 * dot(r_tx_LOS, d_tx));
					tx_idx++;
				}
			}
		}
	}
	/*cout << endl;
	cout << endl;
	for (int tx_idx = 0; tx_idx < ue_antenna.num_txru; tx_idx++)
	{
		cout << "tx_idx : " << tx_idx << endl;
		cout << "F_ue[rx_idx].phi : " << F_ue[tx_idx].phi << endl;
		cout << "F_ue[rx_idx].theta : " << F_ue[tx_idx].theta << endl;

		cout <<"gain : " <<pow(abs(F_ue[tx_idx].phi), 2) + pow(abs(F_ue[tx_idx].theta), 2) << endl;
	}
	getchar();*/


		
	for (int sec_idx = 0; sec_idx < num_TRxP_per_site; sec_idx++)
	{
		for (int azimuth_idx = 0; azimuth_idx < bs_analog_beam.num_steering_azimuth_angle; azimuth_idx++)
		{
			for (int zenith_idx = 0; zenith_idx < bs_analog_beam.num_steering_zenith_angle; zenith_idx++)
			{
				bool a = 0;
				for (int ue_idx = 0; ue_idx < sector[_bs_idx * num_TRxP_per_site + sec_idx].ue_in_control.size(); ue_idx++)
				{
					if ((azimuth_idx == sector[_bs_idx * num_TRxP_per_site + sec_idx].azimuth_steering_idx[ue_idx]) && (zenith_idx == sector[_bs_idx * num_TRxP_per_site + sec_idx].zenith_steering_idx[ue_idx]))
					{
						a = true;
					}
				}
				if (a == true)
				{

					int rx_idx = 0;

					for (int mg = 0; mg < bs_antenna.Mg; mg++) // vertical element
					{
						for (int ng = 0; ng < bs_antenna.Ng; ng++) // horizental element
						{
							for (int mp = 0; mp < bs_antenna.Mp; mp++) // vertical element
							{
								for (int np = 0; np < bs_antenna.Np; np++) // horizental element
								{
									weight = (0, 0);
									for (int k = 0; k < bs_antenna.K; k++) // vertical element
									{
										for (int l = 0; l < bs_antenna.L; l++) // horizental element
										{
											w = bs_analog_beam.virtualization_weight[zenith_idx][azimuth_idx][k][l];

											d_rx = sector[sec_idx].d_rx[k + mp * bs_antenna.K][l + np * bs_antenna.L][0][mg][ng]; //// sector(rx) [M][N][P][Mg][Ng] <port0>
											//cout << d_rx.x <<"  " << d_rx.y << "  " << d_rx.z << "  " << endl;
											weight += w * exp(j*2.0*PI / lamda_0 * dot(r_rx_LOS, d_rx));
										}
									}

									for (int pol_idx = 0; pol_idx < 2; pol_idx++)
									{
										F_sector[rx_idx].phi = GCS_LOS_arrival_field[sec_idx][pol_idx].phi *weight;
										F_sector[rx_idx].theta = GCS_LOS_arrival_field[sec_idx][pol_idx].theta *weight;
										rx_idx++;
									}
								}
							}
						}
					}

					/*		cout << endl;
							cout << endl;
							for (int rx_idx = 0; rx_idx < bs_antenna.num_txru; rx_idx++)
							{
							cout << "rx_idx : " << rx_idx << endl;
							cout << "F_sector[rx_idx].phi : " << F_sector[rx_idx].phi << endl;
							cout << "F_sector[rx_idx].theta : " << F_sector[rx_idx].theta << endl;

							cout <<"gain : " <<pow(abs(F_sector[rx_idx].phi), 2) + pow(abs(F_sector[rx_idx].theta), 2) << endl;
							}
							getchar();*/


					for (int rx_idx = 0; rx_idx < num_bs_antenna_port; rx_idx++)
					{
						for (int tx_idx = 0; tx_idx < num_ue_antenna_port; tx_idx++)
						{
							alpha_LOS[sec_idx][azimuth_idx][zenith_idx](rx_idx, tx_idx) =sqrt(K_R / (K_R + 1)) *(F_sector[rx_idx].theta * F_ue[tx_idx].theta* exp_j_PHI_LOS - F_sector[rx_idx].phi * F_ue[tx_idx].phi* exp_j_PHI_LOS);
						}
					}
				}

				/*cout << endl;
				cout << endl;
				
				cout << "alpha_LOS " << endl;
				cout << "azimuth_idx : " << azimuth_idx << endl;
				cout << "zenith_idx : " << zenith_idx << endl;
				cout<<endl;
				cout << alpha_LOS[sec_idx][azimuth_idx][zenith_idx] << endl;
				cout << alpha_LOS[sec_idx][azimuth_idx][zenith_idx] << endl;

				getchar();
				*/				
			}
		}

	}
	

	delete[] F_sector;
	delete[] F_ue;
}

void Channel::Compute_alpha_NLOS()
{
	cout.unsetf(ios::fixed);

	complex <double> j(0.0, 1.0);
	complex <double> weight;
	complex <double> w;

	double K = LSPs[LOS_K];
	double K_R = pow(10, K / 10);
	double _1_over_sqrt_K;
	double power_term;
	ANTENNA_FIELD_COMPLEX ***F_sector;
	ANTENNA_FIELD_COMPLEX ***F_ue;
	LOCATION d_rx;
	LOCATION d_tx;
	
	F_sector = new ANTENNA_FIELD_COMPLEX**[num_cluster];
	F_ue = new ANTENNA_FIELD_COMPLEX**[num_cluster];
	for (int cluster_idx = 0; cluster_idx < num_cluster; cluster_idx++)
	{
		F_sector[cluster_idx] = new ANTENNA_FIELD_COMPLEX *[num_ray_per_cluster[fast_fading_condition]];
		F_ue[cluster_idx] = new ANTENNA_FIELD_COMPLEX *[num_ray_per_cluster[fast_fading_condition]];

		for (int ray_idx = 0; ray_idx < num_ray_per_cluster[fast_fading_condition]; ray_idx++)
		{
			F_sector[cluster_idx][ray_idx] = new ANTENNA_FIELD_COMPLEX[bs_antenna.num_txru];
			F_ue[cluster_idx][ray_idx] = new ANTENNA_FIELD_COMPLEX[ue_antenna.num_txru];
		}
	}

	
	int num_ue_antenna_port = ue_antenna.num_txru;
	int num_bs_antenna_port = bs_antenna.num_txru;
	if (ue_antenna.Ng == 2)
	{
		num_ue_antenna_port = ue_antenna.num_txru / 2;
	}

	if (fast_fading_condition != LOS)
	{
		K_R = 0;
	}

	int tx_idx = 0;
	for (int m = 0; m < ue_antenna.Mp; m++) // vertical element
	{
		for (int n = 0; n < ue_antenna.Np; n++) // horizental element
		{
			for (int pol_idx = 0; pol_idx < 2; pol_idx++)
			{
				for (int cluster_idx = 0; cluster_idx < num_cluster; cluster_idx++)
				{
					for (int ray_idx = 0; ray_idx < num_ray_per_cluster[fast_fading_condition]; ray_idx++)
					{
						if (ue_antenna.Ng == 2)
						{
							weight = (0, 0);
							for (int k = 0; k < ue_antenna.K; k++) // vertical element
							{
								for (int l = 0; l < ue_antenna.L; l++) // horizental element
								{
									w = ue_analog_beam.virtualization_weight[ue[_ue_idx].zenith_steering_idx][ue[_ue_idx].azimuth_steering_idx][k][l];
									d_tx = ue[_ue_idx].d_tx[k][l][pol_idx][0][ue[_ue_idx].panel_idx]; //// [M][N][P][Mg][Ng] <panel0>		
									weight += w * exp(j*2.0*PI / lamda_0 * dot(r_tx[cluster_idx][ray_idx], d_tx));
								}
							}
							
							F_ue[cluster_idx][ray_idx][tx_idx].phi = GCS_NLOS_departure_field[ue[_ue_idx].panel_idx][pol_idx][cluster_idx][ray_idx].phi* weight;
							F_ue[cluster_idx][ray_idx][tx_idx].theta = GCS_NLOS_departure_field[ue[_ue_idx].panel_idx][pol_idx][cluster_idx][ray_idx].theta * weight;						
						}
						else
						{
							d_tx = ue[_ue_idx].d_tx[m][n][pol_idx][0][0];
/*
							cout << endl;
							cout << endl;
							cout <<"cluster_idx : "<< cluster_idx << endl;
							cout << "ray_idx : "<<ray_idx << endl;
							cout << "tx_idx : " << tx_idx << endl;

							cout << "GCS: "<<  GCS_NLOS_departure_field[0][pol_idx][cluster_idx][ray_idx].phi << endl;
							cout << "exp : "<<exp(j*2.0*PI / lamda_0 * dot(r_tx[cluster_idx][ray_idx], d_tx)) << endl;
							cout << "F_ue : " << F_ue[cluster_idx][ray_idx][tx_idx].phi << endl;*/
							F_ue[cluster_idx][ray_idx][tx_idx].phi = GCS_NLOS_departure_field[0][pol_idx][cluster_idx][ray_idx].phi*exp(j*2.0*PI / lamda_0 * dot(r_tx[cluster_idx][ray_idx], d_tx));
							F_ue[cluster_idx][ray_idx][tx_idx].theta = GCS_NLOS_departure_field[0][pol_idx][cluster_idx][ray_idx].theta * exp(j*2.0*PI / lamda_0 * dot(r_tx[cluster_idx][ray_idx], d_tx));
							
						}
						
					}
				}
				tx_idx++;
			}
		}
	}
	


	//cout << endl;
	//cout << endl;
	//for (int cluster_idx = 0; cluster_idx < num_cluster; cluster_idx++)
	//{
	//	cout <<"cluster_idx : "<< cluster_idx << endl;
	//	for (int ray_idx = 0; ray_idx < num_ray_per_cluster[fast_fading_condition]; ray_idx++)
	//	{
	//		cout <<"ray_idx : "<< ray_idx << endl;
	//		for (int tx_idx = 0; tx_idx < ue_antenna.num_txru; tx_idx++)
	//		{

	//			cout << "tx_idx : " << tx_idx << endl;
	//			
	//			cout << "F_ue[rx_idx].phi : " << F_ue[cluster_idx][ray_idx][tx_idx].phi << endl;
	//			cout << "F_ue[rx_idx].theta : " << F_ue[cluster_idx][ray_idx][tx_idx].theta << endl;

	//			cout << "gain : " << pow(abs(F_ue[cluster_idx][ray_idx][tx_idx].phi), 2) + pow(abs(F_ue[cluster_idx][ray_idx][tx_idx].theta), 2) << endl;
	//		}
	//	}
	//	getchar();
	//}
	

	for (int sec_idx = 0; sec_idx < num_TRxP_per_site; sec_idx++)
	{
		//cout << "ue_in_control.size() : "<< sector[_bs_idx * num_TRxP_per_site + sec_idx].ue_in_control.size() << endl;
		for (int azimuth_idx = 0; azimuth_idx < bs_analog_beam.num_steering_azimuth_angle; azimuth_idx++)
		{
			for (int zenith_idx = 0; zenith_idx < bs_analog_beam.num_steering_zenith_angle; zenith_idx++)
			{
				bool a= 0;
				for (int ue_idx = 0; ue_idx < sector[_bs_idx * num_TRxP_per_site + sec_idx].ue_in_control.size(); ue_idx++)
				{
					/*cout <<"azimuth_steering_idx : "<< sector[_bs_idx * num_TRxP_per_site + sec_idx].azimuth_steering_idx[ue_idx] << endl;
					cout << "zenith_steering_idx : "  <<sector[_bs_idx * num_TRxP_per_site + sec_idx].zenith_steering_idx[ue_idx] << endl;*/
					if ( (azimuth_idx == sector[_bs_idx * num_TRxP_per_site + sec_idx].azimuth_steering_idx[ue_idx]) && (zenith_idx == sector[_bs_idx * num_TRxP_per_site + sec_idx].zenith_steering_idx[ue_idx]))
					{
						a = true;
					}
				}

				if (a == true)
				{
					int rx_idx = 0;

					for (int mg = 0; mg < bs_antenna.Mg; mg++) // vertical element
					{
						for (int ng = 0; ng < bs_antenna.Ng; ng++) // horizental element
						{
							for (int mp = 0; mp < bs_antenna.Mp; mp++) // vertical element
							{
								for (int np = 0; np < bs_antenna.Np; np++) // horizental element
								{
									for (int pol_idx = 0; pol_idx < 2; pol_idx++)
									{
										for (int cluster_idx = 0; cluster_idx < num_cluster; cluster_idx++)
										{
											for (int ray_idx = 0; ray_idx < num_ray_per_cluster[fast_fading_condition]; ray_idx++)
											{
												weight = (0, 0);
												for (int k = 0; k < bs_antenna.K; k++) // vertical element
												{
													for (int l = 0; l < bs_antenna.L; l++) // horizental element
													{
														w = bs_analog_beam.virtualization_weight[zenith_idx][azimuth_idx][k][l];

														d_rx = sector[sec_idx].d_rx[k + mp * bs_antenna.K][l + np * bs_antenna.L][0][mg][ng]; //// sector(rx) [M][N][P][Mg][Ng] <port0>
																																			  //cout << d_rx.x <<"  " << d_rx.y << "  " << d_rx.z << "  " << endl;
														weight += w * exp(j*2.0*PI / lamda_0 * dot(r_rx[cluster_idx][ray_idx], d_rx));
													}
												}

												F_sector[cluster_idx][ray_idx][rx_idx].phi = GCS_NLOS_arrival_field[sec_idx][pol_idx][cluster_idx][ray_idx].phi *weight;
												F_sector[cluster_idx][ray_idx][rx_idx].theta = GCS_NLOS_arrival_field[sec_idx][pol_idx][cluster_idx][ray_idx].theta *weight;
											}
										}
										rx_idx++;
									}
								}
							}
						}
					}
					
					for (int cluster_idx = 0; cluster_idx < num_cluster; cluster_idx++)
					{
						power_term = sqrt(cluster_power[cluster_idx] / (num_ray_per_cluster[fast_fading_condition] * (K_R + 1)));

						for (int ray_idx = 0; ray_idx < num_ray_per_cluster[fast_fading_condition]; ray_idx++)
						{
							for (int rx_idx = 0; rx_idx < num_bs_antenna_port; rx_idx++)
							{
								for (int tx_idx = 0; tx_idx < num_ue_antenna_port; tx_idx++)
								{
									_1_over_sqrt_K = 1.0 / sqrt(kappa[cluster_idx][ray_idx]);
									/*cout << endl;
									cout << endl;
									cout << "sec_idx : "<< sec_idx << endl;
									cout << " azimuth_idx: " << azimuth_idx << endl;
									cout << " zenith_idx: " << zenith_idx << endl;
									cout << " cluster_idx: " << cluster_idx << endl;
									cout << " ray_idx: " << ray_idx << endl;*/
									alpha_NLOS[sec_idx][azimuth_idx][zenith_idx][cluster_idx][ray_idx](rx_idx, tx_idx)= power_term * (F_sector[cluster_idx][ray_idx][rx_idx].theta * F_ue[cluster_idx][ray_idx][tx_idx].theta* exp_j_PHI[cluster_idx][ray_idx].theta_theta
										+ _1_over_sqrt_K * F_sector[cluster_idx][ray_idx][rx_idx].theta * F_ue[cluster_idx][ray_idx][tx_idx].phi*exp_j_PHI[cluster_idx][ray_idx].theta_phi
										+ _1_over_sqrt_K * F_sector[cluster_idx][ray_idx][rx_idx].phi * F_ue[cluster_idx][ray_idx][tx_idx].theta* exp_j_PHI[cluster_idx][ray_idx].phi_theta
										+ F_sector[cluster_idx][ray_idx][rx_idx].phi * F_ue[cluster_idx][ray_idx][tx_idx].phi* exp_j_PHI[cluster_idx][ray_idx].phi_phi);

								}
							}



						

						/*	if (cluster_idx == 0 && ray_idx == 0)
							{

								cout << endl;
								cout << endl;
								cout << "sec_idx : " << sec_idx << endl;
								cout << " azimuth_idx: " << azimuth_idx << endl;
								cout << " zenith_idx: " << zenith_idx << endl;
								cout << " cluster_idx: " << cluster_idx << endl;
								cout << " ray_idx: " << ray_idx << endl;
								cout << alpha_NLOS[sec_idx][azimuth_idx][zenith_idx][cluster_idx][ray_idx] << endl;
								getchar();

							}*/
						}
					}

				}
				
			}
		}
	}

	
	for (int cluster_idx = 0; cluster_idx < num_cluster; cluster_idx++)
	{
		for (int ray_idx = 0; ray_idx < num_ray_per_cluster[fast_fading_condition]; ray_idx++)
		{
			delete[] F_ue[cluster_idx][ray_idx];
			delete[] F_sector[cluster_idx][ray_idx];
		}
		delete[] F_ue[cluster_idx];
		delete[] F_sector[cluster_idx];
	}
	delete[] F_ue;
	delete[] F_sector;
}



void Channel::Generate_channel(int sec_idx)
{

	int num_ue_antenna_port = ue_antenna.num_txru;
	int num_bs_antenna_port = bs_antenna.num_txru;
	if (ue_antenna.Ng == 2)
	{
		num_ue_antenna_port = ue_antenna.num_txru / 2;
	}

	int azimuth_idx = ue[_ue_idx].sector_azimuth_steering_idx;
	int zenith_idx = ue[_ue_idx].sector_zenith_steering_idx;
		
	complex <double> j(0.0, 1.0);
	complex <double> exp_v_LOS_t;
	complex <double> exp_v_t[20][20];
	
	MatrixXcd H_LOS[3];
	MatrixXcd H_n[3][20];
	MatrixXcd H_sub_cluster[3][6]; // sector/ num_sub_cluster

	//MatrixXcd sum_power_alpha_LOS;
	//MatrixXcd sum_power_alpha_NLOS;
	//MatrixXd sum_power_alpha;
	
	//sum_power_alpha_LOS  = MatrixXcd(num_bs_antenna_port, num_ue_antenna_port);
	//sum_power_alpha_NLOS = MatrixXcd(num_bs_antenna_port, num_ue_antenna_port);
	//sum_power_alpha_LOS.setZero();
	//sum_power_alpha_NLOS.setZero();

	for (int sec_idx = 0; sec_idx < num_TRxP_per_site; sec_idx++)
	{
		if (fast_fading_condition == LOS)
		{
			H_LOS[sec_idx] = MatrixXcd(num_bs_antenna_port, num_ue_antenna_port);
			H_LOS[sec_idx].setZero();
		}

		for (int cluster_idx = 0; cluster_idx < num_cluster; cluster_idx++)
		{
			H_n[sec_idx][cluster_idx] = MatrixXcd(num_bs_antenna_port, num_ue_antenna_port);
			H_n[sec_idx][cluster_idx].setZero();
		}
		
		for (int sub_cluster_idx = 0; sub_cluster_idx < 6; sub_cluster_idx++)
		{
			H_sub_cluster[sec_idx][sub_cluster_idx] = MatrixXcd(num_bs_antenna_port, num_ue_antenna_port);
			H_sub_cluster[sec_idx][sub_cluster_idx].setZero();
		}
	}
	

	if (fast_fading_condition == LOS)
	{

		exp_v_LOS_t = exp(j * 2. * PI * velocity_LOS * double(t) * slot_interval);
		H_LOS[sec_idx] = alpha_LOS[sec_idx][azimuth_idx][zenith_idx] * exp_v_LOS_t;
		
	/*	sum_power_alpha_LOS = alpha_LOS[sec_idx][azimuth_idx][zenith_idx].cwiseAbs2().real();

		cout << "alpha_LOS" << endl;
		cout << alpha_LOS[sec_idx][azimuth_idx][zenith_idx] << endl;
		cout << endl;
		cout << "sum_power_alpha_LOS" << endl;
		cout << sum_power_alpha_LOS << endl;
		cout << sum_power_alpha_LOS.rowwise().sum() << endl;
		getchar();*/
		/*cout << endl;
		cout << "H_LOS[sec_idx]" << endl;
		cout << H_LOS[sec_idx] << endl;
		getchar();*/
	}

	for (int cluster_idx = 0; cluster_idx < num_cluster; cluster_idx++)
	{
		for (int ray_idx = 0; ray_idx < num_ray_per_cluster[fast_fading_condition]; ray_idx++)
		{
			exp_v_t[cluster_idx][ray_idx] = exp(j * 2. * PI * velocity[cluster_idx][ray_idx] * double(t) * slot_interval);
		}
	}

	for (int cluster_idx = 0; cluster_idx < num_cluster; cluster_idx++)
	{
		//cout << "cluster_idx : " << cluster_idx << endl;

		if ((cluster_idx != strong_cluster[0]) && (cluster_idx != strong_cluster[1]))
		{
			//cout << "NOT STRONG cluster" << endl;
			for (int ray_idx = 0; ray_idx < num_ray_per_cluster[fast_fading_condition]; ray_idx++)
			{
				H_n[sec_idx][cluster_idx] += alpha_NLOS[sec_idx][azimuth_idx][zenith_idx][cluster_idx][ray_idx] * exp_v_t[cluster_idx][ray_idx];
				//sum_power_alpha_NLOS += alpha_NLOS[sec_idx][azimuth_idx][zenith_idx][cluster_idx][ray_idx].cwiseAbs2();
			}

		/*	cout << "H_n[sec_idx][cluster_idx]" << endl;
			cout << H_n[sec_idx][cluster_idx] << endl;*/
		}
		else
		{
			//cout << "STRONG cluster" << endl;
			int a;

			if (cluster_idx == strong_cluster[0])
			{
				a = 0;
			}
			else
			{
				a = 3;
			}
			//cout << "a :" << a << endl;
			for (int ray_idx = 0; ray_idx<10; ray_idx++)
			{
				H_sub_cluster[sec_idx][a+0] += alpha_NLOS[sec_idx][azimuth_idx][zenith_idx][cluster_idx][ray_idx] * exp_v_t[cluster_idx][ray_idx];
				
				//sum_power_alpha_NLOS += alpha_NLOS[sec_idx][azimuth_idx][zenith_idx][cluster_idx][ray_idx].cwiseAbs2();
			}
			/*cout << " H_sub_cluster[sec_idx][a + 0]" << endl;
			cout << H_sub_cluster[sec_idx][a + 0] << endl;
			cout << endl;

			cout << "a+1 :" << a + 1 << endl;*/
			for (int ray_idx = 10; ray_idx<16; ray_idx++)
			{
				H_sub_cluster[sec_idx][a+ 1] += alpha_NLOS[sec_idx][azimuth_idx][zenith_idx][cluster_idx][ray_idx] * exp_v_t[cluster_idx][ray_idx];

				//sum_power_alpha_NLOS += alpha_NLOS[sec_idx][azimuth_idx][zenith_idx][cluster_idx][ray_idx].cwiseAbs2();
			}
			/*cout << " H_sub_cluster[sec_idx][a + 1]" << endl;
			cout << H_sub_cluster[sec_idx][a + 1] << endl;
			cout << endl;
			cout << "a+1 :" << a + 2 << endl;*/
			for (int ray_idx = 16; ray_idx<20; ray_idx++)
			{
				H_sub_cluster[sec_idx][a + 2] += alpha_NLOS[sec_idx][azimuth_idx][zenith_idx][cluster_idx][ray_idx] * exp_v_t[cluster_idx][ray_idx];

				//sum_power_alpha_NLOS += alpha_NLOS[sec_idx][azimuth_idx][zenith_idx][cluster_idx][ray_idx].cwiseAbs2();
			}
			/*cout << " H_sub_cluster[sec_idx][a+2]" << endl;
			cout << H_sub_cluster[sec_idx][a + 2] << endl;
			cout << endl;*/
			
		}		
	}

	/*cout << "sum_power_alpha_LOS" << endl;
	cout << sum_power_alpha_NLOS << endl;
	cout << sum_power_alpha_NLOS.rowwise().sum() << endl;
	getchar();

	
	sum_power_alpha = sum_power_alpha_NLOS.rowwise().sum().real() + sum_power_alpha_LOS.rowwise().sum().real();

	cout << "sum_power_alpha" << endl;
	cout << sum_power_alpha << endl;
*/
	
	///////////////////////////////////////////////
	//H_LOS[sec_idx] 
	//H_n[sec_idx][cluster_idx] 
	//H_sub_cluster[sec_idx][a+2]


	int pointer = (fft_size - num_rb * num_freq_per_rbs) / 2;

	for (int rb_idx = 0; rb_idx < num_rb; rb_idx++)
	{
		H[sec_idx][rb_idx].setZero();

		int freq_idx = pointer + (num_freq_per_rbs / 2) + (rb_idx*num_freq_per_rbs);

		for (int cluster_idx = 0; cluster_idx < num_cluster; cluster_idx++)
		{
			complex <double> dft_exp(0.0, -(2 * PI*freq_idx* delay[cluster_idx]) * subcarrier_spacing );
			if ((fast_fading_condition == LOS) && (cluster_idx == 0))
			{
				H[sec_idx][rb_idx] += H_LOS[sec_idx];
			}
			if ((cluster_idx != strong_cluster[0]) && (cluster_idx != strong_cluster[1]))
			{
				H[sec_idx][rb_idx] += H_n[sec_idx][cluster_idx] * exp(dft_exp);
			}
			else
			{
					
				int a;
				if (cluster_idx == strong_cluster[0])
				{
					a = 0;
				}
				else
				{
					a = 3;
				}

				complex <double> dft_exp1(0.0, -(2 * PI*freq_idx* (delay[cluster_idx]) + 1.28*C_DS[fast_fading_condition]) * subcarrier_spacing);
				complex <double> dft_exp2(0.0, -(2 * PI*freq_idx* (delay[cluster_idx]) + 2.56*C_DS[fast_fading_condition]) * subcarrier_spacing);

				H[sec_idx][rb_idx] += H_sub_cluster[sec_idx][a + 0] * exp(dft_exp);
					
				H[sec_idx][rb_idx] += H_sub_cluster[sec_idx][a + 1] * exp(dft_exp1);
						
				H[sec_idx][rb_idx] += H_sub_cluster[sec_idx][a + 2] * exp(dft_exp2);

			}
		}

	
	}
	/*
	MatrixXd H_power;
	
	H_power = MatrixXd(num_bs_antenna_port, num_ue_antenna_port);
	H_power.setZero();
	for (int rb_idx = 0; rb_idx < num_rb; rb_idx++)
	{
		H_power += H[sec_idx][rb_idx].cwiseAbs2();
	}
	H_power = H_power / num_rb;
	cout << "H_power" << endl;
	cout << H_power.rowwise().sum() << endl;
	getchar();*/

}