#ifndef _CAHNNEL_H_
#define _CAHNNEL_H_
#include <vector>
#include <iostream>
#include <fstream>
#include "struct.h"
#include <Eigen/Dense>
#include "rvGenerater.h"
using namespace std;
using namespace Eigen;


class Channel
{
public:
	Channel();
	~Channel();

	void Configure(int,int);
	void Compute_alpha_LOS();
	void Compute_alpha_NLOS();
	void Generate_channel(int sec_idx);
	

	LOCATION location;
	double break_point_distance;
	double _2D_distance;
	double _3D_distance;
	double pathloss_dB;
	double pathloss;
	double sigma_SF;
	double SF;
	
	double kappa[20][20];
	RANDOM_INITIAL_PHASE exp_j_PHI[20][20];
	complex <double> exp_j_PHI_LOS;

	ArrayXd  TLSPs;
	ArrayXd  LSPs;

	

	double cluster_power[20];
	double delay[20];

	SPHERICAL_ANGLE GCS_Departure_angle_LOS;
	SPHERICAL_ANGLE GCS_Arrival_angle_LOS;
	
	SPHERICAL_ANGLE GCS_Arrival_angle_NLOS[20][20];
	SPHERICAL_ANGLE GCS_Departure_angle_NLOS[20][20];

	double ZOD_offset;
	double LS_gain;
	double log_ZSD_mean[3];

	LOCATION r_tx_LOS;
	LOCATION r_tx[20][20];

	LOCATION r_rx_LOS;
	LOCATION r_rx[20][20];
	double velocity_LOS;
	double velocity[20][20];
	

	MatrixXcd alpha_LOS[3][8][4];
	MatrixXcd alpha_NLOS[3][8][4][20][20]; //[sector][sec_zenith][sec_azimuth][cluster][ray]

	MatrixXcd H[3][52]; //[sector][resorceblock]
	
	//MatrixXcd h[52];

	ANTENNA_FIELD GCS_LOS_departure_field[2][2]; // [pannel][polarization]
	ANTENNA_FIELD GCS_NLOS_departure_field[2][2][20][20]; // [pannel][polarization][cluster][ray]

	
	ANTENNA_FIELD GCS_LOS_arrival_field[3][2];//[sector],[num_pol]
	ANTENNA_FIELD GCS_NLOS_arrival_field[3][2][20][20];//[sector][num_pol][num_cluser][num_ray]

		
	int propagation_condition; //LOS,NLOS
	int fast_fading_condition; // LOS,NLOS,OUT2IN

	double tau[20];
	int num_cluster;
	int strong_cluster[2];


	double couplingloss[3][4][8][4][2][2]; //[sec_idx] [sec_zenith][sec_azimuth][ue_zenith_idx][ue_azimuth_idx][pannel];

private:
	int _ue_idx;
	int _bs_idx;

};

#endif

