#ifndef _CONST_H_
#define _CONST_H_

#include <cmath>

#define NO_UE  -1
#define MIN(x,y) (((x)<=(y))?(x):(y))
#define MAX(x,y) (((x)>=(y))?(x):(y))
#define dB2linear(x) (pow(10.0,x/10.0))
#define dBm2linear(x) (pow(10.0, (x- 30)/10.0))
#define linear2dB(x) (10*log10(x))
#define linear2dBm(x) (10*log10(x * 1000 ))
const double PI = 4 * atan(1.);
const double SPEED_LIGHT = 300000000.;

enum O2I_penetration_loss_model
{
	High_loss_model, Low_loss_model
};
enum antenna_array_TYPE
{
	ULA, UPA
};


enum UE_antenna_element_pattern
{
	Omni_directional, directional
};

enum test_environment_TYPE
{
	InH_eMBB_A, InH_eMBB_B, InH_eMBB_C,
	Dense_Urban_eMBB_A, Dense_Urban_eMBB_B, Dense_Urban_eMBB_C_Macro, Dense_Urban_eMBB_C_Micro,
	Rural_eMBB_A, Rural_eMBB_B, Rural_eMBB_C
};

enum pathloss_model_TYPE
{
	InH_A, InH_B,
	UMa_A, UMa_B,
	UMi_A, UMi_B,
	RMa_A, RMa_B
};


enum UE_LOCATION
{
	INDOOR, IN_CAR, PEDESTRIAN

};

enum LSP
{
	SF, K, DS, ASD, ASA, ZSD, ZSA
};


enum LOS_LSP
{
	LOS_SF, LOS_K,LOS_DS, LOS_ASD, LOS_ASA, LOS_ZSD, LOS_ZSA
};

enum NLOS_LSP
{
	NLOS_SF, NLOS_DS, NLOS_ASD, NLOS_ASA, NLOS_ZSD, NLOS_ZSA
};

enum OUT2IN_LSP
{
	OUT2IN_SF, OUT2IN_DS, OUT2IN_ASD, OUT2IN_ASA, OUT2IN_ZSD, OUT2IN_ZSA
};

enum propagation_condition
{
	LOS, NLOS, OUT2IN
};

enum distribution
{
	Laplacian, Wrapped_Gaussian
};

enum CQI_MCS_TYPE
{
	QPSK0, QPSK1, QPSK2, QPSK3, QPSK4, QPSK5, QPSK6, QPSK7, QPSK8, QPSK9, QPSK10,
	QAM1611, QAM1612, QAM1613, QAM1614, QAM1615, QAM1616, QAM1617, QAM1618, QAM1619, QAM1620,
	QAM6421, QAM6422, QAM6423, QAM6424, QAM6425, QAM6426, QAM6427, QAM6428,
	NUM_CQI_MCS_TYPES
};


enum ACK_NACK
{
	ACK, NACK
};
#endif

#pragma once