#include "paramSimul.h"
#include "ue.h"
#include "objectBSSectorUe.h"
#include "const.h"
#include <vector> 
#include <algorithm> 
#include "paramStatistics.h"
#include "paramSimul.h"
#include <Windows.h>
#include "evaluationConfigurerations.h"
using namespace std;

double Total_Avr;
double Total_Min;

void Collect_Couplingloss()
{
	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		_couplingloss[drop_idx*num_ue + ue_idx] = ue[ue_idx].couplingloss_dB;
		_geometry[drop_idx*num_ue + ue_idx] = ue[ue_idx].geometry;
	}	
	
	for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
	{
		for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
		{
			_2Ddistance[drop_idx*num_ue*num_bs + num_ue *bs_idx + ue_idx] = channel[bs_idx][ue_idx]._2D_distance;
		}
	}
}


void Get_Couplingloss_CDF()
{
	vector <double> _2Ddistance_cdf;
	vector <double> _couplingloss_cdf;
	vector <double> _geometry_cdf;


	_2Ddistance_cdf.clear();
	_couplingloss_cdf.clear();
	_geometry_cdf.clear();

	
	sort(_2Ddistance, _2Ddistance + num_ue * num_drops*num_bs);
	sort(_couplingloss, _couplingloss + num_ue*num_drops);
	sort(_geometry, _geometry + num_ue * num_drops);
	
	_2Ddistance_cdf.push_back(_2Ddistance[0]);
	_couplingloss_cdf.push_back(_couplingloss[0]);
	_geometry_cdf.push_back(_geometry[0]);
	
	for (int percentile = 1; percentile < 101; percentile++)
	{
		int idx = (int)((num_ue*num_drops - 1)*percentile*0.01);
		_couplingloss_cdf.push_back(_couplingloss[idx]);
		_geometry_cdf.push_back(_geometry[idx]);

		int d_idx = (int)((num_ue*num_drops*num_bs - 1)*percentile*0.01);
		_2Ddistance_cdf.push_back(_2Ddistance[d_idx]);
	}



	ofstream Distance;
	ofstream  Couplingloss;
	ofstream  Geometry;
	char file_name[70];
	char file_name1[70];
	char file_name2[70];

	strcpy_s(file_name, sizeof(file_name), "Couplingloss");
	strcpy_s(file_name1, sizeof(file_name1), "Geometry");
	strcpy_s(file_name2, sizeof(file_name2), ".xls"); 
	//strcat_s(file_name, sizeof(file_name), "/NLOS.xls");

	
	if (pathloss_model == InH_A)
	{
		if (test_environment == InH_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_A_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/InH_eMBB_A_Geometry_A.xls");

		}
		else if (test_environment == InH_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_B_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/InH_eMBB_B_Geometry_A.xls");
		}
		else 
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_C_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/InH_eMBB_C_Geometry_A.xls");

		}


	}
	else if (pathloss_model == InH_B)
	{
		if (test_environment == InH_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_A_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/InH_eMBB_A_Geometry_B.xls");
			

		}
		else if (test_environment == InH_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_B_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/InH_eMBB_B_Geometry_B.xls");

		}
		else
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_C_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/InH_eMBB_C_Geometry_B.xls");

		}
	}
	else if (pathloss_model == UMa_A || pathloss_model == UMi_A)
	{
		if (test_environment == Dense_Urban_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_A_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_A_Geometry_A.xls");

		}
		else if (test_environment == Dense_Urban_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_B_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_B_Geometry_A.xls");

		}
		else if (test_environment == Dense_Urban_eMBB_C_Macro)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_C_Macro_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_C_Macro_Geometry_A.xls");

		}
		else if (test_environment == Dense_Urban_eMBB_C_Micro)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_C_Micro_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_C_Micro_Geometry_A.xls");

		}
	}
	else if (pathloss_model == UMa_B || pathloss_model== UMi_B)
	{
		if (test_environment == Dense_Urban_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_A_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_A_Geometry_B.xls");

		}
		else if (test_environment == Dense_Urban_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_B_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_B_Geometry_B.xls");

		}
		else if (test_environment == Dense_Urban_eMBB_C_Macro)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_C_Macro_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_C_Macro_Geometry_B.xls");

		}
		else if (test_environment == Dense_Urban_eMBB_C_Micro)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_C_Micro_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_C_Micro_Geometry_B.xls");

		}
	}
	else if (pathloss_model == RMa_A)
	{
		if (test_environment == Rural_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_A_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Rural_eMBB_A_Geometry_A.xls");

		}
		else if (test_environment == Rural_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_B_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Rural_eMBB_B_Geometry_A.xls");

		}
		else if (test_environment == Rural_eMBB_C)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_C_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Rural_eMBB_C_Geometry_A.xls");

		}
	}
	else if (pathloss_model == RMa_B)
	{
		if (test_environment == Rural_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_A_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Rural_eMBB_A_Geometry_B.xls");
		}
		else if (test_environment == Rural_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_B_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Rural_eMBB_B_Geometry_B.xls");
		}
		else if (test_environment == Rural_eMBB_C)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_C_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Rural_eMBB_C_Geometry_B.xls");
		}
	}

	else
	{
		cout << "check file name" << endl;
		getchar();
	}

	Couplingloss.open(file_name, ios::out);
	Geometry.open(file_name1, ios::out);
	Distance.open(file_name2, ios::out);

	Couplingloss <<"# " << "\t" << "# Couplingloss "  << endl;
	Geometry << "# " << "\t" << "# Geometry " << endl;

	for (int x_idx = 0; x_idx < 101; x_idx++)
	{
		Couplingloss << _couplingloss_cdf[x_idx] << "\t" <<endl;
		Geometry << _geometry_cdf[x_idx] << "\t"  << endl;
		Distance<< _2Ddistance_cdf[x_idx] << "\t" << endl;

	}
	Distance.close();
	Couplingloss.close();
	Geometry.close();
}



void PerDropStatistics(int drop_idx)
{
	double time_inverse;

	if (subcarrier_spacing == 15000)
	{
		time_inverse = 1000;

	}
	else if (subcarrier_spacing == 120000)
	{
		time_inverse = 8000;
	}

	if (drop_idx == 0)
	{
		Total_Avr = 0.;
		Total_Min = 0.;
	}
	ofstream  OutputFile;
	double *per_sector_throughput;
	per_sector_throughput =  new double [num_sector];
	


	char file_name[70];
	
	strcpy_s(file_name, sizeof(file_name), "Throughput");
	
	//strcat_s(file_name, sizeof(file_name), "/NLOS.xls");


	if (pathloss_model == InH_A)
	{
		if (test_environment == InH_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_InH_eMBB_A_A.xls");
			
		}
		else if (test_environment == InH_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_InH_eMBB_B_A.xls");
		}
		else
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_InH_eMBB_C_A.xls");
		}


	}
	else if (pathloss_model == InH_B)
	{
		if (test_environment == InH_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_InH_eMBB_A.xls");
		}
		else if (test_environment == InH_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_InH_eMBB_B.xls");
			

		}
		else
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_InH_eMBB_C.xls");
		}
	}
	else if (pathloss_model == UMa_A || pathloss_model == UMi_A)
	{
		if (test_environment == Dense_Urban_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Dense_Urban_eMBB_A.xls");
		}
		else if (test_environment == Dense_Urban_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Dense_Urban_eMBB_B_A.xls");
		}
		else if (test_environment == Dense_Urban_eMBB_C_Macro)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Dense_Urban_eMBB_C_Macro_A.xls");
		}
		else if (test_environment == Dense_Urban_eMBB_C_Micro)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Dense_Urban_eMBB_C_Micro_A.xls");
		}
	}
	else if (pathloss_model == UMa_B || pathloss_model == UMi_B)
	{
		if (test_environment == Dense_Urban_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Dense_Urban_eMBB_A_B.xls");

		}
		else if (test_environment == Dense_Urban_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Dense_Urban_eMBB_B_B.xls");
		}
		else if (test_environment == Dense_Urban_eMBB_C_Macro)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Dense_Urban_eMBB_C_Macro_B.xls");
		}
		else if (test_environment == Dense_Urban_eMBB_C_Micro)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Dense_Urban_eMBB_C_Micro_B.xls");
		}
	}
	else if (pathloss_model == RMa_A)
	{
		if (test_environment == Rural_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Rural_eMBB_A_A.xls");
		}
		else if (test_environment == Rural_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Rural_eMBB_B_Couplingloss_A.xls");
		}
		else if (test_environment == Rural_eMBB_C)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Rural_eMBB_C_A.xls");
		}
	}
	else if (pathloss_model == RMa_B)
	{
		if (test_environment == Rural_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Rural_eMBB_A_B.xls");
		}
		else if (test_environment == Rural_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Rural_eMBB_B_B.xls");
			
		}
		else if (test_environment == Rural_eMBB_C)
		{
			strcat_s(file_name, sizeof(file_name), "/Throughput_Rural_eMBB_C_B.xls");
		}
	}
	else
	{
		cout << "check file name" << endl;
		getchar();
	}




	for (int sector_idx = 0; sector_idx < num_sector; sector_idx++)
	{
		per_sector_throughput[sector_idx] = 0;
		for (int ue_idx = 0; ue_idx < sector[sector_idx].ue_in_control.size(); ue_idx++)
		{
			int ue2consider = sector[sector_idx].ue_in_control[ue_idx];
			per_sector_throughput[sector_idx] += ue[ue2consider].uplinkThroghput;
		}
	}

	double avg_thru = 0;
	double min_thru = per_sector_throughput[0];
	double max_thru = per_sector_throughput[0];
	for (int sector_idx = 0; sector_idx < num_sector; sector_idx++)
	{
		avg_thru += per_sector_throughput[sector_idx];
		if (min_thru > per_sector_throughput[sector_idx]) { min_thru = per_sector_throughput[sector_idx]; }
		if (max_thru < per_sector_throughput[sector_idx]) { max_thru = per_sector_throughput[sector_idx]; }
	}

	if (drop_idx == 0)
	{
		OutputFile.open(file_name, ios::out);
		OutputFile << "--------------------------- Simulation Configure ---------------------------" << endl;
		OutputFile << " num_drops        = " << num_drops << endl;
		OutputFile << " run_time         = " << run_times << endl;
		OutputFile << " num_user_cell    = " << num_user_per_sector << endl;
		OutputFile << "----------------------------------------------------------------------------" << endl;

	}
	else { OutputFile.open(file_name, ios::app); }

	OutputFile << "--------------------------- drop_idx = " << drop_idx + 1 << " --------------------------------- " << endl;
	OutputFile << "Sector Thruput [Avg, Max, Min] (b/s/Hz) = ";
	OutputFile << "[ " << avg_thru / num_sector * time_inverse / (run_times- stable_time) / simulation_bandwidth
		<< ", " << max_thru * time_inverse / (run_times - stable_time) / simulation_bandwidth
		<< ", " << min_thru * time_inverse / (run_times - stable_time) / simulation_bandwidth
		<< "]" << endl;

	Total_Avr += avg_thru / num_sector * time_inverse / (run_times - stable_time) /simulation_bandwidth;;

	//compute ue thru 
	long double *per_ue_throughput;
	long double *ue_statistics;
	int cell_edge_ue_idx = (int)(num_ue * 0.05);

	per_ue_throughput = new long double [num_ue];
	ue_statistics = new long double [num_ue];

	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		per_ue_throughput[ue_idx] = ue[ue_idx].uplinkThroghput;
		ue_statistics[ue_idx] = per_ue_throughput[ue_idx];
	}

	long double tmp;
	bool swap;
	do
	{
		swap = false; //sorting frequence in order of cqi
		for (int ue_idx = 0; ue_idx < num_ue - 1; ue_idx++)
		{
			if (ue_statistics[ue_idx] > ue_statistics[ue_idx + 1])
			{
				tmp = ue_statistics[ue_idx];
				ue_statistics[ue_idx] = ue_statistics[ue_idx + 1];
				ue_statistics[ue_idx + 1] = tmp;
				swap = true;
			}
		}
	} while (swap);

	long double avg_ue_thru = 0;
	long double min_ue_thru = ue_statistics[cell_edge_ue_idx];
	long double max_ue_thru = ue_statistics[num_ue - 1];

	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		avg_ue_thru += ue_statistics[ue_idx];
	}


	double num_error[4] = { 0,0,0,0 };
	double num_tx=0;
	double avg_pe[4]= { 0,0,0,0 };

	for (int i = 0; i < 4; i++)
	{
		for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
		{
			num_error[i] += ue[ue_idx].num_error[i];
		}
	}

	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		num_tx += ue[ue_idx].num_transmission;
	}
	

	avg_pe[0] += num_error[0] / num_tx ;
	avg_pe[1] += num_error[1] / num_error[0];
	avg_pe[2] += num_error[2] / num_error[1];
	avg_pe[3] += num_error[3] / num_error[2];


	OutputFile << "    UE Thruput [Avg, Max, Min] (b/s/Hz) = ";
	OutputFile << "[ " << avg_ue_thru / num_ue * time_inverse / (run_times - stable_time) /simulation_bandwidth
		<< ", " << max_ue_thru * time_inverse / (run_times - stable_time) / simulation_bandwidth
		<< ", " << min_ue_thru * time_inverse / (run_times - stable_time) / simulation_bandwidth
		<< "]" << endl;

	OutputFile << " first Packet Error     = " << avg_pe[0]<< endl;
	OutputFile << " second Packet Error = " <<avg_pe[1] << endl;
	OutputFile << " third Packet Error    = " <<avg_pe[2] << endl;
	OutputFile << " fourth Packet Error  = " <<avg_pe[3] << endl;


	OutputFile << "--------------------------------------------------------------------------" << endl;

	Total_Min += min_ue_thru * time_inverse / (run_times - stable_time) / simulation_bandwidth;
	
	if (drop_idx == (num_drops - 1))
	{
		OutputFile << " Sector  AVR = " << Total_Avr / num_drops << endl;
		OutputFile << " Minimum AVR = " << Total_Min / num_drops << endl;
		OutputFile.close();
	}
	


	delete per_sector_throughput;
}
