#include <stdio.h>
#include <iostream>
#include <fstream>
#include <time.h>
#include <string>
#include "paramSimul.h"
#include "ue.h"
#include "objectBSSectorUe.h"
#include <Eigen/Dense>
#include <unsupported/Eigen/MatrixFunctions>
#include "llsmapping.h"
#include "paramStatistics.h"
using namespace Eigen;



void Set_simul_param(int argc, char *argv[]);
void Make_ue_sector_object(void);
void Set_test_environment(void);
void Set_antenna_configuration(void);
void Set_fastfading_param();
void Set_antenna_location_vector();
void Deploy_bs_ue(void);
void Configure_sector_ue(void);
void Calculate_angle_in_GCS(void);
void Generate_pathloss(void);
void Get_Couplingloss_CDF(void);
void Select_adjacent_sector(void);
void Collect_Couplingloss(void);
void Allocate_memory(void);
void Delete_memory(void);
void Generate_LSP(void);
void Generate_SSP(void);
void Scheduling(void);
void Attach_ue_to_sector();
void Generate_longterm_channel(void);
void Update_channel(void);
void CSI_update(void);
void PerDropStatistics(int drop_idx);
void Generate_interference();

int main(int argc, char *argv[])
{
		
	Set_simul_param(argc, argv);
	cout << "Set_simul_param" << endl;
	
	Set_test_environment();
	cout << "Set_test_environment" << endl;
	
	Set_fastfading_param();
	cout << "Set_fastfading_param" << endl;

	Make_ue_sector_object();
	cout << "Make_ue_sector_object" << endl;
	
	Set_antenna_configuration();
	cout << "Set_antenna_configuration" << endl;

	Allocate_memory();
	cout << "Allocate_memory" << endl;


	for (drop_idx = 0; drop_idx < num_drops; drop_idx++)
	{

		cout << "drop_idx : " << drop_idx+1 <<"/"<<num_drops<< endl;
		cout << endl;
		

		Configure_sector_ue();
		cout << "Configure_sector_ue" << endl;
		cout << endl;

		Set_antenna_location_vector();

		cout << "Deploy_bs_ue" << endl;
		cout << endl;
		Deploy_bs_ue();
		
		cout << "Calculate_angle_in_GCS" << endl;
		cout << endl;
		Calculate_angle_in_GCS();
		
		cout << "Generate_pathloss" << endl;
		cout << endl;
		Generate_pathloss();

	
		cout << "Generate_LSP..." << endl;
		cout<<endl;
		Generate_LSP();
	
		//Select_adjacent_sector();
		

		cout << "Generate_SSP..." << endl;
		
		Generate_SSP();		
	
		cout << endl;
		cout << endl;
		cout << "Attach_ue_to_sector..." << endl;

		Attach_ue_to_sector();

		//for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
		//{
		//	cout << channel[ue[ue_idx].sector_in_control / 3][ue_idx]._2D_distance << endl;
		//}
		//getchar();
		//Collect_Couplingloss();
		cout << "Generate_longterm_channel.." << endl;
			
		Generate_longterm_channel();
		cout << endl; cout << endl;
		for (t = 0; t < run_times; t++)
		{


			cout << "---------"<<"drop_idx : "<< drop_idx <<"-----------------"  <<"run_times : " << t << "-----------------------------------------"<<endl;

			for (int sector_idx = 0; sector_idx < num_sector; sector_idx++)
			{
				if (t==0)
				{
					sector[sector_idx].RR_scheduling();
				}
			}

			cout << endl;
			cout << "Update_channel" << endl;
			
			Update_channel();
			
			cout << endl;
			cout << "Scheduling" << endl;


			Scheduling();

			
			//cout << "sector[0].pschedulewrite[0].CQI_selected :  "<<sector[0].pschedulewrite[0].CQI_selected << endl;
			
			cout << "Generate_interference" << endl;
			//Generate_interference();

			cout << "Receive_UL()" << endl;

			if ( t > stable_time)
			{
				for (int idx = 0; idx < num_ue; idx++)
				{
					ue[idx].Receive_UL();				
				}
			}

			CSI_update();
			cout << endl;
			
		}


		cout << endl;

		PerDropStatistics(drop_idx);
	}

	Get_Couplingloss_CDF();
	Delete_memory();
	
}