#ifndef _PARAMSIMUL_H_
#define _PARAMSIMUL_H_

#include "rvGenerater.h"
#include <iostream>
#include <Eigen/Dense>
#include "struct.h"
using namespace Eigen;
using namespace std;


extern struct Rand Rand;
extern unsigned long _seed;
extern bool calibration;

extern int t;
extern int run_times;
extern double stable_time;

extern int drop_idx;
extern int num_drops;
extern int num_ue;
extern int num_bs;
extern int num_sector;
extern int num_user_per_sector;
extern int csi_history_length;
extern int num_rb;
extern int num_TRxP_per_site;

extern int pathloss_model;
extern int test_environment;
extern int num_compute_coef;
extern double subcarrier_spacing;
extern int fft_size;
extern double slot_interval;
extern double sampling_frequency;
extern int num_freq_per_rbs;
extern double overhead;
extern int rs_size;
extern int num_neighbor;
extern int num_ue_antenna_port;

extern int Power_0;
extern double Power_alpha;

extern double grid_interval;

extern double carrier_freq;
extern double ue_power;
extern double TRxP_power;
extern double lamda_0;
extern int csi_feedback_interval;


extern char *file_name;
extern char path[100];


extern int wrap[19][19];
extern LOCATION bs_location[19];

extern Matrix<complex<double>, 4, 1> W_sigle_layer[28];
extern Matrix<complex<double>, 4, 2> W_two_layer[22];
extern Matrix<complex<double>, 4, 3> W_three_layer[7];
extern Matrix<complex<double>, 4, 4> W_four_layer[5];
extern Matrix<complex<double>, 2, 1> W_sigle_layer_two_port[6];
extern Matrix<complex<double>, 2, 2> W_two_layer_two_port[3];



extern int schedule_delay;
extern SCHEDULE_DECISION **ppSchedule_Map;

#endif