#include <iostream>

#include "objectBSSectorUe.h"
#include "paramSimul.h"
#include "evaluationConfigurerations.h"
#include "const.h"
#include "struct.h"
#include "ue.h"

using namespace std;

void Set_antenna_parameter();
void Generate_2D_DFT_beam_precoder();
void Generate_bs_2D_DFT_beam_precoder();
void Generate_ue_2D_DFT_beam_precoder();
complex <double> Generate_vertical_virtualization_weight(double theta, double dv, double k, double K);
complex <double> Generate_horizontal_virtualization_weight(double theta, double phi, double dH, double l, double L);
void Set_channel_matrix();
void Set_precoding_matrix();

void Set_antenna_configuration(void)
{

	Set_antenna_parameter();

	Generate_2D_DFT_beam_precoder();	

	Set_channel_matrix();
	cout << "Set_precoding_matrix" << endl;
	Set_precoding_matrix();

}
void 	Set_precoding_matrix()
{
	W_sigle_layer_two_port[0] << 1, 0;
	W_sigle_layer_two_port[1] << 0, 1;
	W_sigle_layer_two_port[2] << 1, 1;
	W_sigle_layer_two_port[3] << 1, -1;
	W_sigle_layer_two_port[4] << 1, 1i;
	W_sigle_layer_two_port[5] << 1, -1i;

	for (int i = 0; i < 6; i++)
	{
		W_sigle_layer_two_port[i] = W_sigle_layer_two_port[i] * 1. / pow(2., 0.5);
	}

	W_two_layer_two_port[0] << 1, 0, 0, 1;
	W_two_layer_two_port[1] << 1, 1, 1, -1;
	W_two_layer_two_port[2] << 1, 1, 1i, -1i;


	W_two_layer_two_port[0] = W_two_layer_two_port[0] * 1. / pow(2., 0.5);
	W_two_layer_two_port[1] = W_two_layer_two_port[1] * 1. / 2.;
	W_two_layer_two_port[2] = W_two_layer_two_port[2] * 1. / 2.;
	W_sigle_layer[0] << 1, 0, 0, 0;
	W_sigle_layer[1] << 0, 1, 0, 0;
	W_sigle_layer[2] << 0, 0, 1, 0;
	W_sigle_layer[3] << 0, 0, 0, 1;
	W_sigle_layer[4] << 1, 0, 1, 0;
	W_sigle_layer[5] << 1, 0, -1, 0;
	W_sigle_layer[6] << 1, 0, 1i, 0;
	W_sigle_layer[7] << 1, 0, -1i, 0;
	W_sigle_layer[8] << 0, 1, 0, 1;
	W_sigle_layer[9] << 0, 1, 0, -1;
	W_sigle_layer[10] << 0, 1, 0, 1i;
	W_sigle_layer[11] << 0, 1, 0, -1i;
	W_sigle_layer[12] << 1, 1, 1, -1;
	W_sigle_layer[13] << 1, 1, 1i, 1i;
	W_sigle_layer[14] << 1, 1, -1, 1;
	W_sigle_layer[15] << 1, 1, -1i, -1i;
	W_sigle_layer[16] << 1, 1i, 1, 1i;
	W_sigle_layer[17] << 1, 1i, 1i, 1;
	W_sigle_layer[18] << 1, 1i, -1, -1i;
	W_sigle_layer[19] << 1, 1i, -1i, -1;
	W_sigle_layer[20] << 1, -1, 1, 1;
	W_sigle_layer[21] << 1, -1, 1i, -1i;
	W_sigle_layer[22] << 1, -1, -1, -1;
	W_sigle_layer[23] << 1, -1, -1i, 1i;
	W_sigle_layer[24] << 1, -1i, 1, -1i;
	W_sigle_layer[25] << 1, -1i, 1i, -1;
	W_sigle_layer[26] << 1, -1i, -1, 1i;
	W_sigle_layer[27] << 1, -1i, -1i, 1;


	double power=0;
	for (int i = 0; i < 28; i++)
	{
		W_sigle_layer[i] = W_sigle_layer[i] * 0.5;
	}

	
	W_two_layer[0] 
    <<1, 0,
		0, 1,
		0, 0,
		0, 0;
	W_two_layer[1] 
	<<1, 0,
		0, 0,
		0, 1,
		0, 0;
	W_two_layer[2]
	<<1, 0,
		0, 0,
		0, 0,
		0, 1;
	W_two_layer[3]
	<<0, 0,
		1, 0,
		0, 1,
		0, 0;
	W_two_layer[4] 
	<<0, 0,
		1, 0,
		0, 0,
		0, 1;
	W_two_layer[5] 
	<<0, 0,
		0, 0,
		1, 0,
		0, 1;
	W_two_layer[6] 
	<<1, 0,
		0, 1,
		1, 0,
		0, -1i;
	W_two_layer[7] 
	<<1, 0,
		0, 1,
		1, 0,
		0, 1i;
	W_two_layer[8] 
	<<1, 0,
		0, 1,
		-1i, 0,
		0, 1;
	W_two_layer[9] 
	<<1, 0,
		0, 1,
		-1i, 0,
		0, -1;
	W_two_layer[10]
	<<1, 0,
		0, 1,
		-1, 0,
		0, -1i;
	W_two_layer[11] 
	<<1, 0,
		0, 1,
		-1, 0,
		0, 1i;
	W_two_layer[12] 
	<< 1, 0,
		0, 1,
		1i, 0,
		0, 1;
	W_two_layer[13] 
	<< 1, 0,
		0, 1,
		1i, 0,
		0, -1;
	W_two_layer[14] 
	<<1, 1,
		1, 1,
		1,-1,
		1,-1;
	W_two_layer[15] 
	<<1, 1,
		1, 1,
		1i, -1i,
		1i, -1i;
	W_two_layer[16] 
	<<1, 1,
		1i, 1i,
		1, -1,
		1i, -1i;
	W_two_layer[17] 
	<< 1, 1,
		1i, 1i,
		1i, -1i,
		-1, 1;
	W_two_layer[18] 
	<<1, 1,
		-1, -1,
		1, -1,
		-1, 1;
	W_two_layer[19] 
	<<1, 1,
		-1, -1,
		1i, -1i,
		-1i, 1i;
	W_two_layer[20] 
	<<1, 1,
		-1i, -1i,
		1, -1,
		-1i, 1i;
	W_two_layer[21] 
	<<1, 1,
		-1i, -1i,
		1i, -1i,
		1, -1;

	for (int i = 0; i < 22; i++)
	{
		if (i < 14)
		{
			W_two_layer[i] = W_two_layer[i] * 0.5;
		}
		else
		{
			W_two_layer[i] = W_two_layer[i] * 0.5/sqrt(2.0);
		}

	/*	cout << "W_two_layer["<<i<<"]" << endl;
		cout << W_two_layer[i] << endl;*/
	}

	
	W_three_layer[0]
		<<
		1, 0, 0,
		0, 1, 0,
		0, 0, 1,
		0, 0, 0;
	W_three_layer[1]
		<<
		1, 0, 0,
		0, 1, 0,
		1, 0, 0,
		0, 0, 1;
	W_three_layer[2]
		<<
		1, 0, 0,
		0, 1, 0,
		-1, 0, 0,
		0, 0, 1;
	W_three_layer[3]
		<<
		1, 1, 1,
		1, -1, 1,
		1, 1, -1,
		1, -1, -1;
	W_three_layer[4]
		<<
		1, 1, 1,
		1, -1, 1,
		1i, 1i, -1i,
		1i, -1i, -1i;
	W_three_layer[5]
		<<
		1, 1, 1,
		-1, 1, -1,
		1, 1, -1,
		-1, 1, 1;
	W_three_layer[6]
		<<
		1, 1, 1,
		-1, 1, -1,
		1i, 1i, -1i,
		-1i, 1i, 1i;


	for (int i = 0; i < 7; i++)
	{
		if (i < 3)
		{
			W_three_layer[i] = W_three_layer[i] * 0.5;
		}
		else
		{
			W_three_layer[i] = W_three_layer[i] * 0.5 / sqrt(3.0);
		}
		/*cout << "W_three_layer["<<i<<"]" << endl;
		cout << W_three_layer[i] << endl;*/


	
	}



	W_four_layer[0]
		<<
		1, 0, 0, 0,
		0, 1, 0, 0,
		0, 0, 1, 0,
		0, 0, 0, 1;
	W_four_layer[1]
		<<
		1, 1, 0, 0,
		0, 0, 1, 1,
		1,-1, 0, 0,
		0, 0, 1,-1;
	W_four_layer[2]
		<<
		1, 1, 0, 0,
		0, 0, 1, 1,
		1i, -1i, 0, 0,
		0, 0, 1i, -1i;
	W_four_layer[3]
		<<
		1, 1, 1, 1,
		1,-1, 1,-1,
		1, 1,-1,-1,
		1,-1,-1, 1;
	W_four_layer[4]
		<<
		1, 1, 1, 1,
		1,-1, 1,-1,
		1i, 1i,-1i,-1i,
		1i,-1i,-1i, 1i;

	for (int i = 0; i < 5; i++)
	{
		if (i < 1)
		{
			W_four_layer[i] = W_four_layer[i] * 0.5;
		}
		else if(i<3)
		{
			W_four_layer[i] = W_four_layer[i] * 0.5 / sqrt(2.0);
		}
		else
		{
			W_four_layer[i] = W_four_layer[i] * 0.25;
		}
	/*	cout << "W_four_layer["<<i<<"]" << endl;
		cout << W_four_layer[i] << endl;*/
	}

}

void Set_antenna_parameter()
{
	if (test_environment == InH_eMBB_A)
	{
		bs_antenna.element_gain_dBi = 5.0;//dBi
		ue_antenna.element_gain_dBi = 0.0;//dBi

		bs_antenna.num_txru = 32;
		ue_antenna.num_txru = 4;

		bs_antenna.M = 4;
		bs_antenna.N = 4;
		bs_antenna.P = 2;
		bs_antenna.Mg = 1;
		bs_antenna.Ng = 1;

		bs_antenna.Mp = 4;
		bs_antenna.Np = 4;
		bs_antenna.dH = lamda_0 * 0.5;
		bs_antenna.dV = lamda_0 * 0.5;


		if (num_TRxP_per_site == 3)
		{
			bs_antenna.mechanic_tilt = 110;
		}
		else
		{
			bs_antenna.mechanic_tilt = 180;
		}
		bs_antenna.electronic_tilt = 90;
	
		bs_antenna.polarization[0] = 45;
		bs_antenna.polarization[1] = -45;

		ue_antenna.M = 1;
		ue_antenna.N = 2;
		ue_antenna.P = 2;
		ue_antenna.Mg = 1;
		ue_antenna.Ng = 1;

		ue_antenna.Mp = 1;
		ue_antenna.Np = 2;
		ue_antenna.dH = lamda_0 * 0.5;
		ue_antenna.dV = 0;

		bs_antenna.polarization[0] = 0;
		bs_antenna.polarization[1] = 90;


		bs_analog_beam.zenith_steering_angle[0] = bs_antenna.electronic_tilt / 180.0 * PI;

		bs_analog_beam.num_steering_azimuth_angle = 1;
		bs_analog_beam.num_steering_zenith_angle = 1;

		ue_analog_beam.num_steering_azimuth_angle = 0;
		ue_analog_beam.num_steering_zenith_angle = 0;
	}
	else if (test_environment == InH_eMBB_B)
	{
		bs_antenna.element_gain_dBi = 5.0;//dBi
		ue_antenna.element_gain_dBi = 5.0;//dBi

		bs_antenna.num_txru = 8;
		ue_antenna.num_txru = 4;

		bs_antenna.M = 4;
		bs_antenna.N = 8;
		bs_antenna.P = 2;
		bs_antenna.Mg = 1;
		bs_antenna.Ng = 1;

		bs_antenna.Mp = 2;
		bs_antenna.Np = 2;
		bs_antenna.dH = lamda_0 * 0.5;
		bs_antenna.dV = lamda_0 * 0.5;

		if (num_TRxP_per_site == 3)
		{
			bs_antenna.mechanic_tilt = 110;
		}
		else
		{
			bs_antenna.mechanic_tilt = 180;
		}

		bs_antenna.polarization[0] = -45;
		bs_antenna.polarization[1] = 45;

		ue_antenna.M = 2;
		ue_antenna.N = 4;
		ue_antenna.P = 2;
		ue_antenna.Mg = 1;
		ue_antenna.Ng = 2;

		ue_antenna.Mp = 1;
		ue_antenna.Np = 1;
		ue_antenna.dH = lamda_0 * 0.5;
		ue_antenna.dV = lamda_0 * 0.5;

		bs_antenna.polarization[0] = 0;
		bs_antenna.polarization[1] = 90;


		bs_analog_beam.num_steering_azimuth_angle = 4;
		bs_analog_beam.num_steering_zenith_angle = 2;
		bs_analog_beam.azimuth_steering_angle[0] = -3.0 / 8.0 * PI;
		bs_analog_beam.azimuth_steering_angle[1] = -1.0 / 8.0 * PI;
		bs_analog_beam.azimuth_steering_angle[2] = 1.0 / 8.0 * PI;
		bs_analog_beam.azimuth_steering_angle[3] = 3.0 / 8.0 * PI;
		
		bs_analog_beam.zenith_steering_angle[0] = 1.0/ 4.0 * PI;
		bs_analog_beam.zenith_steering_angle[1] = 3.0 / 4.0 * PI;


		ue_analog_beam.num_steering_azimuth_angle = 4;
		ue_analog_beam.num_steering_zenith_angle = 2;
		ue_analog_beam.azimuth_steering_angle[0] = -3.0 / 8.0 * PI;
		ue_analog_beam.azimuth_steering_angle[1] = -1.0 / 8.0 * PI;
		ue_analog_beam.azimuth_steering_angle[2] = 1.0 / 8.0 * PI;
		ue_analog_beam.azimuth_steering_angle[3] = 3.0 / 8.0 * PI;
		
		ue_analog_beam.zenith_steering_angle[0] = 1.0 / 4.0 * PI;
		ue_analog_beam.zenith_steering_angle[1] = 3.0 / 4.0 * PI;



	}
	else if (test_environment == InH_eMBB_C)
	{

		bs_antenna.element_gain_dBi = 5.0;//dBi
		ue_antenna.element_gain_dBi = 5.0;//dBi

		bs_antenna.num_txru = 8;
		ue_antenna.num_txru = 4;

		bs_antenna.M = 8;
		bs_antenna.N = 16;
		bs_antenna.P = 2;
		bs_antenna.Mg = 1;
		bs_antenna.Ng = 1;

		bs_antenna.Mp = 2;
		bs_antenna.Np = 2;
		bs_antenna.dH = lamda_0 * 0.5;
		bs_antenna.dV = lamda_0 * 0.5;

		
		if (num_TRxP_per_site == 3)
		{
			bs_antenna.mechanic_tilt = 110;
		}
		else
		{
			bs_antenna.mechanic_tilt = 180;
		}

		bs_antenna.polarization[0] = -45;
		bs_antenna.polarization[1] = 45;

		ue_antenna.M = 2;
		ue_antenna.N = 4;
		ue_antenna.P = 2;
		ue_antenna.Mg = 1;
		ue_antenna.Ng = 2;

		ue_antenna.Mp = 1;
		ue_antenna.Np = 1;
		ue_antenna.dH = lamda_0 * 0.5;
		ue_antenna.dV = lamda_0 * 0.5;

		bs_antenna.polarization[0] = 0;
		bs_antenna.polarization[1] = 90;

		bs_analog_beam.num_steering_azimuth_angle = 8;
		bs_analog_beam.num_steering_zenith_angle = 4;

		bs_analog_beam.azimuth_steering_angle[0] = -7.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[1] = -5.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[2] = -3.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[3] = -1.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[4] = 1.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[5] = 3.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[6] = 5.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[7] = 7.0 / 16.0 * PI;
		
		bs_analog_beam.zenith_steering_angle[0] = 1.0 / 8.0 * PI;
		bs_analog_beam.zenith_steering_angle[1] = 3.0 / 8.0 * PI;
		bs_analog_beam.zenith_steering_angle[2] = 5.0 / 8.0* PI;
		bs_analog_beam.zenith_steering_angle[3] = 7.0 / 8.0 * PI;


		ue_analog_beam.num_steering_azimuth_angle = 4;
		ue_analog_beam.num_steering_zenith_angle = 2;

		ue_analog_beam.azimuth_steering_angle[0] = -3.0 / 8.0 * PI;
		ue_analog_beam.azimuth_steering_angle[1] = -1.0 / 8.0 * PI;
		ue_analog_beam.azimuth_steering_angle[2] = 1.0 / 8.0 * PI;
		ue_analog_beam.azimuth_steering_angle[3] = 3.0 / 8.0 * PI;

		ue_analog_beam.zenith_steering_angle[0] = 1.0 / 4.0 * PI;
		ue_analog_beam.zenith_steering_angle[1] = 3.0 / 4.0 * PI;


	}
	else if (test_environment == Dense_Urban_eMBB_A)
	{

		bs_antenna.element_gain_dBi = 8.0;//dBi
		ue_antenna.element_gain_dBi = 0.0;//dBi

		bs_antenna.num_txru = 32; //4
		ue_antenna.num_txru = 4;

		bs_antenna.M = 8;
		bs_antenna.N = 8;
		bs_antenna.P = 2;
		bs_antenna.Mg = 1;
		bs_antenna.Ng = 1;

		bs_antenna.Mp = 2;
		bs_antenna.Np = 8;//1
		bs_antenna.dH = lamda_0 * 0.5;
		bs_antenna.dV = lamda_0 * 0.8;

		bs_antenna.mechanic_tilt = 90;

		bs_antenna.polarization[0] = -45;
		bs_antenna.polarization[1] = 45;

		ue_antenna.M = 1;
		ue_antenna.N = 2;
		ue_antenna.P = 2;
		ue_antenna.Mg = 1;
		ue_antenna.Ng = 1;

		ue_antenna.Mp = 1;
		ue_antenna.Np = 2;
		ue_antenna.dH = lamda_0 * 0.5;
		ue_antenna.dV = 0;

		bs_antenna.polarization[0] = 0;
		bs_antenna.polarization[1] = 90;


		 //빔포밍 고정
		/*bs_analog_beam.num_steering_azimuth_angle = 1;
		bs_analog_beam.num_steering_zenith_angle = 1;*/
		bs_analog_beam.num_steering_azimuth_angle = 1;
		bs_analog_beam.num_steering_zenith_angle = 1;

		bs_analog_beam.zenith_steering_angle[0] = 105. / 180. * PI;

		ue_analog_beam.num_steering_azimuth_angle = 0;
		ue_analog_beam.num_steering_zenith_angle = 0;
	}
	else if (test_environment == Dense_Urban_eMBB_B)
	{

		bs_antenna.element_gain_dBi = 8.0;//dBi
		ue_antenna.element_gain_dBi = 5.0;//dBi

		bs_antenna.num_txru = 8;
		ue_antenna.num_txru = 4;

		bs_antenna.M = 4;
		bs_antenna.N = 8;
		bs_antenna.P = 2;
		bs_antenna.Mg = 2;
		bs_antenna.Ng = 2;

		bs_antenna.Mp = 1;
		bs_antenna.Np = 1;
		bs_antenna.dH = lamda_0 * 0.5;
		bs_antenna.dV = lamda_0 * 0.5;
		bs_antenna.dgH = lamda_0 * 4.0;
		bs_antenna.dgV = lamda_0 * 2.0;

		bs_antenna.mechanic_tilt = 90;

		bs_antenna.polarization[0] = -45;
		bs_antenna.polarization[1] = 45;

		ue_antenna.M = 2;
		ue_antenna.N = 4;
		ue_antenna.P = 2;
		ue_antenna.Mg = 1;
		ue_antenna.Ng = 2;

		ue_antenna.Mp = 1;
		ue_antenna.Np = 1;
		ue_antenna.dH = lamda_0 * 0.5;
		ue_antenna.dV = lamda_0 * 0.5;

		bs_antenna.polarization[0] = 0;
		bs_antenna.polarization[1] = 90;


		bs_analog_beam.num_steering_azimuth_angle = 6;
		bs_analog_beam.num_steering_zenith_angle = 2;

		bs_analog_beam.azimuth_steering_angle[0] = -5.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[1] = -3.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[2] = -1.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[3] = 1.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[4] = 3.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[5] = 5.0 / 16.0 * PI;

		bs_analog_beam.zenith_steering_angle[0] = 5.0 / 8.0 * PI;
		bs_analog_beam.zenith_steering_angle[1] = 7.0 / 8.0 * PI;


		ue_analog_beam.num_steering_azimuth_angle = 4;
		ue_analog_beam.num_steering_zenith_angle = 2;

		ue_analog_beam.azimuth_steering_angle[0] = -3.0 / 8.0 * PI;
		ue_analog_beam.azimuth_steering_angle[1] = -1.0 / 8.0 * PI;
		ue_analog_beam.azimuth_steering_angle[2] = 1.0 / 8.0 * PI;
		ue_analog_beam.azimuth_steering_angle[3] = 3.0 / 8.0 * PI;
		
		ue_analog_beam.zenith_steering_angle[0] = 1.0 / 4.0 * PI;
		ue_analog_beam.zenith_steering_angle[1] = 3.0 / 4.0 * PI;


	}
	else if (test_environment == Dense_Urban_eMBB_C_Macro)
	{

		bs_antenna.element_gain_dBi = 8.0;//dBi
		ue_antenna.element_gain_dBi = 0.0;//dBi

		bs_antenna.num_txru = 4;
		ue_antenna.num_txru = 4;

		bs_antenna.M = 8;
		bs_antenna.N = 8;
		bs_antenna.P = 2;
		bs_antenna.Mg = 1;
		bs_antenna.Ng = 1;

		bs_antenna.Mp = 2;
		bs_antenna.Np = 1;
		bs_antenna.dH = lamda_0 * 0.5;
		bs_antenna.dV = lamda_0 * 0.8;

		bs_antenna.mechanic_tilt = 90;

		bs_antenna.polarization[0] = -45;
		bs_antenna.polarization[1] = 45;

		ue_antenna.M = 1;
		ue_antenna.N = 2;
		ue_antenna.P = 2;
		ue_antenna.Mg = 1;
		ue_antenna.Ng = 1;

		ue_antenna.Mp = 1;
		ue_antenna.Np = 1;
		ue_antenna.dH = lamda_0 * 0.5;
		ue_antenna.dV = 0;

		bs_antenna.polarization[0] = 0;
		bs_antenna.polarization[1] = 90;


		bs_analog_beam.num_steering_azimuth_angle = 6;
		bs_analog_beam.num_steering_zenith_angle = 2;

		bs_analog_beam.azimuth_steering_angle[0] = -5.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[1] = -3.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[2] = -1.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[3] = 1.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[4] = 3.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[5] = 5.0 / 16.0 * PI;

		bs_analog_beam.zenith_steering_angle[0] = 5.0 / 8.0 * PI;
		bs_analog_beam.zenith_steering_angle[1] = 7.0 / 8.0 * PI;

		ue_analog_beam.num_steering_azimuth_angle = 0;
		ue_analog_beam.num_steering_zenith_angle = 0;
	}
	else if (test_environment == Dense_Urban_eMBB_C_Micro)
	{
		bs_antenna.element_gain_dBi = 8.0;//dBi
		ue_antenna.element_gain_dBi = 5.0;//dBi

		bs_antenna.num_txru = 8;
		ue_antenna.num_txru = 4;

		bs_antenna.M = 4;
		bs_antenna.N = 8;
		bs_antenna.P = 2;
		bs_antenna.Mg = 2;
		bs_antenna.Ng = 2;

		bs_antenna.Mp = 1;
		bs_antenna.Np = 1;
		bs_antenna.dH = lamda_0 * 0.5;
		bs_antenna.dV = lamda_0 * 0.5;

		bs_antenna.mechanic_tilt = 90;

		bs_antenna.polarization[0] = -45;
		bs_antenna.polarization[1] = 45;

		ue_antenna.M = 2;
		ue_antenna.N = 4;
		ue_antenna.P = 2;
		ue_antenna.Mg = 1;
		ue_antenna.Ng = 2;

		ue_antenna.Mp = 1;
		ue_antenna.Np = 1;
		ue_antenna.dH = lamda_0 * 0.5;
		ue_antenna.dV = lamda_0 * 0.5;

		bs_antenna.polarization[0] = 0;
		bs_antenna.polarization[1] = 90;

		
		bs_analog_beam.num_steering_azimuth_angle = 6;
		bs_analog_beam.num_steering_zenith_angle = 2;

		bs_analog_beam.azimuth_steering_angle[0] = -5.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[1] = -3.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[2] = -1.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[3] = 1.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[4] = 3.0 / 16.0 * PI;
		bs_analog_beam.azimuth_steering_angle[5] = 5.0 / 16.0 * PI;

		bs_analog_beam.zenith_steering_angle[0] = 5.0 / 8.0 * PI;
		bs_analog_beam.zenith_steering_angle[1] = 7.0 / 8.0 * PI;

		ue_analog_beam.num_steering_azimuth_angle = 4;
		ue_analog_beam.num_steering_zenith_angle = 2;

		ue_analog_beam.azimuth_steering_angle[0] = -3.0 / 8.0 * PI;
		ue_analog_beam.azimuth_steering_angle[1] = -1.0 / 8.0 * PI;
		ue_analog_beam.azimuth_steering_angle[2] =  1.0 / 8.0 * PI;
		ue_analog_beam.azimuth_steering_angle[3] =  3.0 / 8.0 * PI;
		ue_analog_beam.zenith_steering_angle[0] =   1.0 / 4.0 * PI;
		ue_analog_beam.zenith_steering_angle[1] =   3.0 / 4.0 * PI;
	}
	else if (test_environment == Rural_eMBB_A)
	{
		bs_antenna.element_gain_dBi = 8.0;//dBi
		ue_antenna.element_gain_dBi = 0.0;//dBi

		bs_antenna.num_txru = 8;
		ue_antenna.num_txru = 2;

		bs_antenna.M = 8;
		bs_antenna.N = 4;
		bs_antenna.P = 2;
		bs_antenna.Mg = 1;
		bs_antenna.Ng = 1;

		bs_antenna.Mp = 1;
		bs_antenna.Np = 4;
		bs_antenna.dH = lamda_0 * 0.5;
		bs_antenna.dV = lamda_0 * 0.8;

		bs_antenna.electronic_tilt = 100;
		bs_antenna.mechanic_tilt = 90;

		bs_antenna.polarization[0] = -45;
		bs_antenna.polarization[1] = 45;

		ue_antenna.M = 1;
		ue_antenna.N = 1;
		ue_antenna.P = 2;
		ue_antenna.Mg = 1;
		ue_antenna.Ng = 1;

		ue_antenna.Mp = 1;
		ue_antenna.Np = 1;
		ue_antenna.dH = 0;
		ue_antenna.dV = 0;

		bs_antenna.polarization[0] = 0;
		bs_antenna.polarization[1] = 90;



		bs_analog_beam.num_steering_azimuth_angle = 1;
		bs_analog_beam.num_steering_zenith_angle = 1;

		bs_analog_beam.zenith_steering_angle[0] = 100.0 / 180.0 * PI;

		ue_analog_beam.num_steering_azimuth_angle = 0;
		ue_analog_beam.num_steering_zenith_angle = 0;
	}
	else if (test_environment == Rural_eMBB_B)
	{
		bs_antenna.element_gain_dBi = 8.0;//dBi
		ue_antenna.element_gain_dBi = 0.0;//dBi

		bs_antenna.num_txru = 16;
		ue_antenna.num_txru = 4;

		bs_antenna.M = 8;
		bs_antenna.N = 8;
		bs_antenna.P = 2;
		bs_antenna.Mg = 1;
		bs_antenna.Ng = 1;

		bs_antenna.Mp = 1;
		bs_antenna.Np = 8;
		bs_antenna.dH = lamda_0 * 0.5;
		bs_antenna.dV = lamda_0 * 0.8;

		bs_antenna.electronic_tilt = 100;
		bs_antenna.mechanic_tilt = 90;

		bs_antenna.polarization[0] = -45;
		bs_antenna.polarization[1] = 45;

		ue_antenna.M = 1;
		ue_antenna.N = 2;
		ue_antenna.P = 2;
		ue_antenna.Mg = 1;
		ue_antenna.Ng = 1;

		ue_antenna.Mp = 1;
		ue_antenna.Np = 1;
		ue_antenna.dH = lamda_0 * 0.5;;
		ue_antenna.dV = 0;

		bs_antenna.polarization[0] = 0;
		bs_antenna.polarization[1] = 90;

		bs_analog_beam.num_steering_azimuth_angle = 1;
		bs_analog_beam.num_steering_zenith_angle = 1;

		bs_analog_beam.zenith_steering_angle[0] = 100.0 / 180.0 * PI;

		ue_analog_beam.num_steering_azimuth_angle = 0;
		ue_analog_beam.num_steering_zenith_angle = 0;

	}
	else if (test_environment == Rural_eMBB_C)
	{
		bs_antenna.element_gain_dBi = 8.0;//dBi
		ue_antenna.element_gain_dBi = 0.0;//dBi

		bs_antenna.num_txru = 8;
		ue_antenna.num_txru = 4;


		bs_antenna.M = 8;
		bs_antenna.N = 4;
		bs_antenna.P = 2;
		bs_antenna.Mg = 1;
		bs_antenna.Ng = 1;

		bs_antenna.Mp = 1;
		bs_antenna.Np = 4;
		bs_antenna.dH = lamda_0 * 0.5;
		bs_antenna.dV = lamda_0 * 0.8;

		bs_antenna.electronic_tilt = 96;
		bs_antenna.mechanic_tilt = 90;

		bs_antenna.polarization[0] = -45;
		bs_antenna.polarization[1] = 45;

		ue_antenna.M = 1;
		ue_antenna.N = 2;
		ue_antenna.P = 2;
		ue_antenna.Mg = 1;
		ue_antenna.Ng = 1;

		ue_antenna.Mp = 1;
		ue_antenna.Np = 1;
		ue_antenna.dH = lamda_0 * 0.5;;
		ue_antenna.dV = 0;

		bs_antenna.polarization[0] = 0;
		bs_antenna.polarization[1] = 90;

		bs_analog_beam.num_steering_azimuth_angle = 1;
		bs_analog_beam.num_steering_zenith_angle = 1;

		bs_analog_beam.zenith_steering_angle[0] = bs_antenna.electronic_tilt / 180.0 * PI;

		ue_analog_beam.num_steering_azimuth_angle = 0;
		ue_analog_beam.num_steering_zenith_angle = 0;
	}

	bs_antenna.K = bs_antenna.M / bs_antenna.Mp;
	bs_antenna.L = bs_antenna.N / bs_antenna.Np;
	ue_antenna.K = ue_antenna.M / ue_antenna.Mp;
	ue_antenna.L = ue_antenna.N / ue_antenna.Np;

}


void Generate_2D_DFT_beam_precoder()
{

	Generate_bs_2D_DFT_beam_precoder();

	Generate_ue_2D_DFT_beam_precoder();

}


void Generate_bs_2D_DFT_beam_precoder()
{
	complex <double> w[4][8];   //[num_vertical steering angle][num element in a port] (maximum)
	complex <double> v[4][8][8];//[num_vertical steering angle][num_horizontal sterring angle][num element in a port]  (maximum)

	for (int zenith_idx = 0; zenith_idx < bs_analog_beam.num_steering_zenith_angle; zenith_idx++)
	{
		for (int k = 0; k < bs_antenna.K; k++) // vertical element
		{
			w[zenith_idx][k] = Generate_vertical_virtualization_weight(bs_analog_beam.zenith_steering_angle[zenith_idx], bs_antenna.dV, double(k), double(bs_antenna.K));

		}
	}

	for (int zenith_idx = 0; zenith_idx < bs_analog_beam.num_steering_zenith_angle; zenith_idx++)
	{
		for (int azimuth_idx = 0; azimuth_idx < bs_analog_beam.num_steering_azimuth_angle; azimuth_idx++)
		{
			for (int l = 0; l < bs_antenna.L; l++) // horizontal element
			{
				v[zenith_idx][azimuth_idx][l] = Generate_horizontal_virtualization_weight(bs_analog_beam.zenith_steering_angle[zenith_idx], bs_analog_beam.azimuth_steering_angle[azimuth_idx], bs_antenna.dH, double(l), double(bs_antenna.L));
			}
		}
	}



	for (int zenith_idx = 0; zenith_idx<bs_analog_beam.num_steering_zenith_angle; zenith_idx++)
	{
		for (int azimuth_idx = 0; azimuth_idx<bs_analog_beam.num_steering_azimuth_angle; azimuth_idx++)
		{
			for (int k = 0; k < bs_antenna.K; k++) // vertical element
			{
				for (int l = 0; l < bs_antenna.L; l++) // horizontal element
				{
					bs_analog_beam.virtualization_weight[zenith_idx][azimuth_idx][k][l] = w[zenith_idx][k]*v[zenith_idx][azimuth_idx][l];
				}
			}
		}
	}

}

void Generate_ue_2D_DFT_beam_precoder()
{
	complex <double> w[2][2];
	complex <double> v[2][4][4];

	for (int zenith_idx = 0; zenith_idx < ue_analog_beam.num_steering_zenith_angle; zenith_idx++)
	{
		for (int k = 0; k < ue_antenna.K; k++) // vertical element
		{
			w[zenith_idx][k] = Generate_vertical_virtualization_weight(ue_analog_beam.zenith_steering_angle[zenith_idx], ue_antenna.dV, double(k), double(ue_antenna.K));
		}
	}
	
	
	for (int zenith_idx = 0; zenith_idx < ue_analog_beam.num_steering_zenith_angle; zenith_idx++)
	{

		for (int azimuth_idx = 0; azimuth_idx < ue_analog_beam.num_steering_azimuth_angle; azimuth_idx++)
		{
			for (int l = 0; l < ue_antenna.L; l++) // horizontal element
			{
				v[zenith_idx][azimuth_idx][l] = Generate_horizontal_virtualization_weight(ue_analog_beam.zenith_steering_angle[zenith_idx], ue_analog_beam.azimuth_steering_angle[azimuth_idx], ue_antenna.dH, double(l), double(ue_antenna.L));
			}
		}
	}


	for (int zenith_idx = 0; zenith_idx<ue_analog_beam.num_steering_zenith_angle; zenith_idx++)
	{
		for (int azimuth_idx = 0; azimuth_idx<ue_analog_beam.num_steering_azimuth_angle; azimuth_idx++)
		{
			for (int k = 0; k < ue_antenna.K; k++) // vertical element
			{
				for (int l = 0; l < ue_antenna.L; l++) // horizontal element
				{
					ue_analog_beam.virtualization_weight[zenith_idx][azimuth_idx][k][l] = w[zenith_idx][k] * v[zenith_idx][azimuth_idx][l];
				}
			}		
		}
	}

}

complex <double> Generate_vertical_virtualization_weight(double theta, double dv, double k, double K)
{
	complex <double> j(0.0, 1.0);
	complex <double> w;

	w = 1.0 / sqrt(double(K))*exp(-j * 2.0 * PI / lamda_0 * k * dv*cos(theta));
	
	return w;
}

complex <double> Generate_horizontal_virtualization_weight(double theta,double phi, double dH, double l, double L)
{
	complex <double> j(0.0, 1.0);
	complex <double> v;

	v = 1.0 / sqrt(double(L))*exp(-j * 2.0 * PI / lamda_0 * l * dH * sin(theta) * sin(phi));

	return v;
}

void Set_channel_matrix()
{

	int num_ue_antenna_port = ue_antenna.num_txru;
	int num_bs_antenna_port = bs_antenna.num_txru;
	if (ue_antenna.Ng == 2)
	{
		num_ue_antenna_port = ue_antenna.num_txru / 2;
	}
		

	for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
	{
		cout << "bs_idx : "<<bs_idx << endl;
		for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
		{
			for (int sec_idx = 0; sec_idx < num_TRxP_per_site; sec_idx++)
			{
				for (int azimuth_idx  = 0; azimuth_idx < bs_analog_beam.num_steering_azimuth_angle; azimuth_idx++)
				{
					for (int zenith_idx = 0; zenith_idx < bs_analog_beam.num_steering_zenith_angle; zenith_idx++)
					{

						channel[bs_idx][ue_idx].alpha_LOS[sec_idx][azimuth_idx][zenith_idx] = MatrixXcd(num_bs_antenna_port, num_ue_antenna_port);
						channel[bs_idx][ue_idx].alpha_LOS[sec_idx][azimuth_idx][zenith_idx].setZero();
						
						for (int cluster_idx = 0; cluster_idx < 20; cluster_idx++)
						{
							for (int ray_idx = 0; ray_idx < 20; ray_idx++)
							{
								channel[bs_idx][ue_idx].alpha_NLOS[sec_idx][azimuth_idx][zenith_idx][cluster_idx][ray_idx] = MatrixXcd(num_bs_antenna_port, num_ue_antenna_port);
								channel[bs_idx][ue_idx].alpha_NLOS[sec_idx][azimuth_idx][zenith_idx][cluster_idx][ray_idx].setZero();
							}
						}
					}
				}

				for (int rb_idx = 0; rb_idx < num_rb; rb_idx++)
				{
					channel[bs_idx][ue_idx].H[sec_idx][rb_idx] = MatrixXcd(num_bs_antenna_port, num_ue_antenna_port);
					channel[bs_idx][ue_idx].H[sec_idx][rb_idx].setZero();
				}
			}
		}	
	}

	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		for (int rb_idx = 0; rb_idx < num_rb; rb_idx++)
		{
			ue[ue_idx].R_inter[rb_idx] = MatrixXcd(num_bs_antenna_port, num_bs_antenna_port);
		}
	}
}
