﻿#include <iostream>
#include <Eigen/Dense>
#include "paramSimul.h"
#include "paramFastFading.h"
#include "const.h"

using namespace Eigen;
using namespace std;
void Set_corr_matrix();
void Set_corr_dist();


void Set_fastfading_param()
{
	Set_corr_dist();
	Set_corr_matrix();
	
	double fc = carrier_freq / 1000000000.;

	if (pathloss_model== InH_A)
	{
		if      ((0.5 < fc) && (fc <   6 ))
		{
			log_DS_mean[LOS]  = -7.70;
			log_DS_mean[NLOS] = -7.41;
			log_DS_mean[OUT2IN] = 0;

			log_DS_std[LOS]  = 0.18;
			log_DS_std[NLOS] = 0.14;
			log_DS_std[OUT2IN] = 0;

			log_ASD_mean[LOS]  = 1.60;
			log_ASD_mean[NLOS] = 1.62;
			log_ASD_mean[OUT2IN] = 0;

			log_ASD_std[LOS]  = 0.18;
			log_ASD_std[NLOS] = 0.25;
			log_ASD_std[OUT2IN] = 0;

			log_ASA_mean[LOS]  = 1.62;
			log_ASA_mean[NLOS] = 1.77;
			log_ASA_mean[OUT2IN] = 0;

			log_ASA_std[LOS]  = 0.22;
			log_ASA_std[NLOS] = 0.16;
			log_ASA_std[OUT2IN] = 0;

			log_ZSA_mean[LOS]  = 1.22;
			log_ZSA_mean[NLOS] = 1.26;
			log_ZSA_mean[OUT2IN] = 0;

			log_ZSA_std[LOS]  = 0.23;
			log_ZSA_std[NLOS] = 0.67;
			log_ZSA_std[OUT2IN] = 0;

			K_mean = 7;
			K_std = 4;
			
			delay_scaling_param[LOS]  = 3.6;
			delay_scaling_param[NLOS] = 3;
			delay_scaling_param[OUT2IN] = 0;

			XPR_mean[LOS]  = 11;
			XPR_mean[NLOS] = 10;
			XPR_mean[OUT2IN] = 0;

			XRP_std[LOS]  = 4;
			XRP_std[NLOS] = 4;
			XRP_std[OUT2IN] = 0;

			num_cluster[LOS]  = 15;
			num_cluster[NLOS] = 19;
			num_cluster[OUT2IN] = 0;

			num_ray_per_cluster[LOS]  = 20;
			num_ray_per_cluster[NLOS] = 20;
			num_ray_per_cluster[OUT2IN] = 0;

			C_DS[LOS] = 3.91;
			C_DS[NLOS] = 3.91;
			C_DS[OUT2IN] = 3.91;

			C_ASD[LOS]  = 5;
			C_ASD[NLOS] = 5;
			C_ASD[OUT2IN] = 0;

			C_ASA[LOS]  = 8;
			C_ASA[NLOS] = 11;
			C_ASA[OUT2IN] = 0;

			C_ZSA[LOS]  = 9;
			C_ZSA[NLOS] = 9;
			C_ZSA[OUT2IN] = 0;

			per_cluster_showing_std[LOS]  = 6;
			per_cluster_showing_std[NLOS] = 3;
			per_cluster_showing_std[OUT2IN] = 0;

			log_ZSD_mean[LOS]  = 1.02;
			log_ZSD_mean[NLOS] = 1.08;
			
			log_ZSD_std[LOS]  = 0.41;
			log_ZSD_std[NLOS] = 0.36;
			
			ZOD_offset[LOS]  = 0;
			ZOD_offset[NLOS] = 0;

			AOD_AOA_distribution = Laplacian;
			ZOD_ZOA_distribution = Laplacian;
		}
		else if (( 6  < fc) && (fc <= 100))
		{
			log_DS_mean[LOS]  = -0.01*log10(1 + fc) - 7.692;
			log_DS_mean[NLOS] = -0.28*log10(1 + fc) - 7.173;
			log_DS_mean[OUT2IN] = 0;

			log_DS_std[LOS] = 0.18;
			log_DS_std[NLOS] = 0.10*log10(1 + fc) + 0.055;
			log_DS_std[OUT2IN] = 0;

			log_ASD_mean[LOS] = 1.60;
			log_ASD_mean[NLOS] = 1.62;
			log_ASD_mean[OUT2IN] = 0;

			log_ASD_std[LOS] = 0.18;
			log_ASD_std[NLOS] = 0.25;
			log_ASD_std[OUT2IN] = 0;

			log_ASA_mean[LOS]  = -0.19 * log10(1 + fc) + 1.781;
			log_ASA_mean[NLOS] = -0.11 * log10(1 + fc) + 1.863;
			log_ASA_mean[OUT2IN] = 0;

			log_ASA_std[LOS]  = 0.12 * log10(1 + fc) + 0.119;
			log_ASA_std[NLOS] = 0.12 * log10(1 + fc) + 0.059;
			log_ASA_std[OUT2IN] = 0;

			log_ZSA_mean[LOS]  = -0.26 * log10(1 + fc) + 1.44;
			log_ZSA_mean[NLOS] = -0.15 * log10(1 + fc) + 1.387;
			log_ZSA_mean[OUT2IN] = 0;

			log_ZSA_std[LOS]  = -0.04 * log10(1 + fc) + 0.264;
			log_ZSA_std[NLOS] = -0.09 * log10(1 + fc) + 0.746;
			log_ZSA_std[OUT2IN] = 0;

			K_mean = 7;
			K_std = 4;

			delay_scaling_param[LOS] = 3.6;
			delay_scaling_param[NLOS] = 3;
			delay_scaling_param[OUT2IN] = 0;

			XPR_mean[LOS] = 11;
			XPR_mean[NLOS] = 10;
			XPR_mean[OUT2IN] = 0;

			XRP_std[LOS] = 4;
			XRP_std[NLOS] = 4;
			XRP_std[OUT2IN] = 0;

			num_cluster[LOS] = 15;
			num_cluster[NLOS] = 19;
			num_cluster[OUT2IN] = 0;

			num_ray_per_cluster[LOS] = 20;
			num_ray_per_cluster[NLOS] = 20;
			num_ray_per_cluster[OUT2IN] = 0;

			C_DS[LOS] = 3.91;
			C_DS[NLOS] = 3.91;
			C_DS[OUT2IN] = 3.91;

			C_ASD[LOS] = 5;
			C_ASD[NLOS] = 5;
			C_ASD[OUT2IN];

			C_ASA[LOS] = 8;
			C_ASA[NLOS] = 11;
			C_ASA[OUT2IN] = 0;

			C_ZSA[LOS] = 9;
			C_ZSA[NLOS] = 9;
			C_ZSA[OUT2IN] = 0;

			per_cluster_showing_std[LOS] = 6;
			per_cluster_showing_std[NLOS] = 3;
			per_cluster_showing_std[OUT2IN] = 0;

			log_ZSD_mean[LOS]  = -1.43 * log10(1 + fc) + 2.228;
			log_ZSD_mean[NLOS] = 1.08;
			
			log_ZSD_std[LOS]  = 0.13 * log10(1 + fc) + 0.30;
			log_ZSD_std[NLOS] = 0.36;
			
			ZOD_offset[LOS] = 0;
			ZOD_offset[NLOS] = 0;
			AOD_AOA_distribution = Wrapped_Gaussian;
			ZOD_ZOA_distribution = Laplacian;
		}
		else
		{
			cout << "fc : = " << fc << endl;
			cout <<" check Set_fastfading_param() carrier_freq" << endl;
			getchar();
		}
	}
	else if (pathloss_model == InH_B)
	{
		if (fc < 6) // ITU-R M.2412-0 page 62 InH_B
		{
			fc = 6;
		}

		log_DS_mean[LOS]  = -0.01 * log10(1 + fc) - 7.692;
		log_DS_mean[NLOS] = -0.28 * log10(1 + fc) - 7.173;
		log_DS_mean[OUT2IN] = 0;

		log_DS_std[LOS]  = 0.18;
		log_DS_std[NLOS] = 0.10 * log10(1 + fc) + 0.055;
		log_DS_std[OUT2IN] = 0;

		log_ASD_mean[LOS]  = 1.60;
		log_ASD_mean[NLOS] = 1.62;
		log_ASD_mean[OUT2IN] = 0;

		log_ASD_std[LOS]  = 0.18;
		log_ASD_std[NLOS] = 0.25;
		log_ASD_std[OUT2IN] = 0;

		log_ASA_mean[LOS] = -0.19 * log10(1 + fc) + 1.781;
		log_ASA_mean[NLOS] = -0.11 * log10(1 + fc) + 1.863;
		log_ASA_mean[OUT2IN] = 0;

		log_ASA_std[LOS] = 0.12 * log10(1 + fc) + 0.119;
		log_ASA_std[NLOS] = 0.12 * log10(1 + fc) + 0.059;
		log_ASA_std[OUT2IN] = 0;

		log_ZSA_mean[LOS] = -0.26 * log10(1 + fc) + 1.44;
		log_ZSA_mean[NLOS] = -0.15 * log10(1 + fc) + 1.387;
		log_ZSA_mean[OUT2IN] = 0;

		log_ZSA_std[LOS] = -0.04 * log10(1 + fc) + 0.264;
		log_ZSA_std[NLOS] = -0.09 * log10(1 + fc) + 0.746;
		log_ZSA_std[OUT2IN] = 0;

		K_mean = 7;
		K_std = 4;

		delay_scaling_param[LOS] = 3.6;
		delay_scaling_param[NLOS] = 3;
		delay_scaling_param[OUT2IN] = 0;

		XPR_mean[LOS] = 11;
		XPR_mean[NLOS] = 10;
		XPR_mean[OUT2IN] = 0;

		XRP_std[LOS] = 4;
		XRP_std[NLOS] = 4;
		XRP_std[OUT2IN] = 0;

		num_cluster[LOS] = 15;
		num_cluster[NLOS] = 19;
		num_cluster[OUT2IN] = 0;

		num_ray_per_cluster[LOS] = 20;
		num_ray_per_cluster[NLOS] = 20;
		num_ray_per_cluster[OUT2IN] = 0;

		C_DS[LOS] = 3.91;
		C_DS[NLOS] = 3.91;
		C_DS[OUT2IN] = 3.91;

		C_ASD[LOS] = 5;
		C_ASD[NLOS] = 5;
		C_ASD[OUT2IN] = 0;

		C_ASA[LOS] = 8;
		C_ASA[NLOS] = 11;
		C_ASA[OUT2IN] = 0;

		C_ZSA[LOS] = 9;
		C_ZSA[NLOS] = 9;
		C_ZSA[OUT2IN] = 0;

		per_cluster_showing_std[LOS] = 6;
		per_cluster_showing_std[NLOS] = 3;
		per_cluster_showing_std[OUT2IN] = 0;

		log_ZSD_mean[LOS] = -1.43 * log10(1 + fc) + 2.228;
		log_ZSD_mean[NLOS] = 1.08;

		log_ZSD_std[LOS] = 0.13 * log10(1 + fc) + 0.30;
		log_ZSD_std[NLOS] = 0.36;

		ZOD_offset[LOS] = 0;
		ZOD_offset[NLOS] = 0;
		AOD_AOA_distribution = Wrapped_Gaussian;
		ZOD_ZOA_distribution = Laplacian;
	}
	else if (pathloss_model == UMa_A)
	{
		if      ((0.5 < fc) && (fc <   6))
		{
			log_DS_mean[LOS]    = -7.03;
			log_DS_mean[NLOS]   = -6.44;
			log_DS_mean[OUT2IN] = -6.62;

			log_DS_std[LOS]		= 0.66;
			log_DS_std[NLOS]	= 0.39;
			log_DS_std[OUT2IN]	= 0.32;

			log_ASD_mean[LOS]	= 1.15;
			log_ASD_mean[NLOS]	= 1.41;
			log_ASD_mean[OUT2IN] = 1.25;

			log_ASD_std[LOS]	= 0.28;
			log_ASD_std[NLOS]	= 0.28;
			log_ASD_std[OUT2IN]	= 0.42;

			log_ASA_mean[LOS]	= 1.81;
			log_ASA_mean[NLOS]	= 1.87;
			log_ASA_mean[OUT2IN]	= 1.76;

			log_ASA_std[LOS]	= 0.20;
			log_ASA_std[NLOS]	= 0.11;
			log_ASA_std[OUT2IN]	= 0.16;

			log_ZSA_mean[LOS]	= 0.95;
			log_ZSA_mean[NLOS]	= 1.26;
			log_ZSA_mean[OUT2IN]	= 1.01;

			log_ZSA_std[LOS]	= 0.16;
			log_ZSA_std[NLOS]	= 0.16;
			log_ZSA_std[OUT2IN]	= 0.43;

			K_mean		= 9;
			K_std		= 3.5;
			
			delay_scaling_param[LOS]	= 2.5;
			delay_scaling_param[NLOS]	= 2.3;
			delay_scaling_param[OUT2IN]	= 2.2;

			XPR_mean[LOS]	= 8;
			XPR_mean[NLOS]	= 7;
			XPR_mean[OUT2IN]	= 9;

			XRP_std[LOS]	= 4;
			XRP_std[NLOS]	= 3;
			XRP_std[OUT2IN] = 5;



			num_cluster[LOS]	= 12;
			num_cluster[NLOS]	= 20;
			num_cluster[OUT2IN]	= 12;

			num_ray_per_cluster[LOS]	= 20;
			num_ray_per_cluster[NLOS]	= 20;
			num_ray_per_cluster[OUT2IN] = 20;

			C_DS[LOS] = 3.91;
			C_DS[NLOS] = 3.91;
			C_DS[OUT2IN] = 3.91;

			C_ASD[LOS]	  = 5;
			C_ASD[NLOS]	  = 2;
			C_ASD[OUT2IN] = 5;

			C_ASA[LOS]	  = 11;
			C_ASA[NLOS]	  = 15;
			C_ASA[OUT2IN] = 8;

			C_ZSA[LOS]	  = 7;
			C_ZSA[NLOS]	  = 7;
			C_ZSA[OUT2IN] = 3;

			per_cluster_showing_std[LOS]	= 3;
			per_cluster_showing_std[NLOS]	= 3;
			per_cluster_showing_std[OUT2IN]	= 4;

			AOD_AOA_distribution = Wrapped_Gaussian;
			ZOD_ZOA_distribution = Laplacian;
		}
		else if ((6  < fc) && (fc <= 100))
		{
			log_DS_mean[LOS]		= -6.955 - 0.0963 * log10(fc);
			log_DS_mean[NLOS]	= -6.28 - 0.204  * log10(fc);
			log_DS_mean[OUT2IN]	= -6.63;

			log_DS_std[LOS]		= 0.66;
			log_DS_std[NLOS]	= 0.39;
			log_DS_std[OUT2IN]	= 0.32;

			log_ASD_mean[LOS]	= 1.06 + 0.1114 * log10(fc);
			log_ASD_mean[NLOS]	= 1.5 - 0.1144 * log10(fc);
			log_ASD_mean[OUT2IN] = 1.25;

			log_ASD_std[LOS]	= 0.28;
			log_ASD_std[NLOS]	= 0.28;
			log_ASD_std[OUT2IN] = 0.42;

			log_ASA_mean[LOS]	= 1.81;
			log_ASA_mean[NLOS]	= 2.08 - 0.27 * log10(fc);
			log_ASA_mean[OUT2IN] = 1.76;

			log_ASA_std[LOS]	= 0.20;
			log_ASA_std[NLOS]	= 0.11;
			log_ASA_std[OUT2IN] = 0.16;

			log_ZSA_mean[LOS]	= 0.95;
			log_ZSA_mean[NLOS]	= -0.3236 * log10(fc) + 1.512;
			log_ZSA_mean[OUT2IN] = 1.01;

			log_ZSA_std[LOS] = 0.16;
			log_ZSA_std[NLOS] = 0.16;
			log_ZSA_std[OUT2IN] = 0.43;

			K_mean = 9;
			K_std = 3.5;

			delay_scaling_param[LOS]	= 2.5;
			delay_scaling_param[NLOS]	= 2.3;
			delay_scaling_param[OUT2IN] = 2.2;

			XPR_mean[LOS]	= 8;
			XPR_mean[NLOS]	= 7;
			XPR_mean[OUT2IN] = 9;

			XRP_std[LOS]	= 4;
			XRP_std[NLOS]	= 3;
			XRP_std[OUT2IN] = 5;

			num_cluster[LOS]	= 12;
			num_cluster[NLOS]	= 20;
			num_cluster[OUT2IN] = 12;

			num_ray_per_cluster[LOS]	= 20;
			num_ray_per_cluster[NLOS]	= 20;
			num_ray_per_cluster[OUT2IN] = 20;

			C_DS[LOS]	 = max(0.25, -3.4084 * log10(fc) + 6.5622);
			C_DS[NLOS]	 = max(0.25, -3.4084 * log10(fc) + 6.5622);
			C_DS[OUT2IN] = 11;

			C_ASD[LOS]	  = 5;
			C_ASD[NLOS]	  = 2;
			C_ASD[OUT2IN] = 5;

			C_ASA[LOS]	  = 11;
			C_ASA[NLOS]   = 15;
			C_ASA[OUT2IN] = 8;

			C_ZSA[LOS] = 7;
			C_ZSA[NLOS] = 7;
			C_ZSA[OUT2IN] = 3;

			per_cluster_showing_std[LOS] = 3;
			per_cluster_showing_std[NLOS] = 3;
			per_cluster_showing_std[OUT2IN] = 4;

			AOD_AOA_distribution = Wrapped_Gaussian;
			ZOD_ZOA_distribution = Laplacian;
		}
		else
		{
			cout << "fc : = " << fc << endl;
			cout << " check Set_fastfading_param() carrier_freq" << endl;
			getchar();
		}
	}
	else if (pathloss_model == UMa_B)
	{
		if (fc < 6)
		{
			fc = 6;
		}
		log_DS_mean[LOS]	 = -6.955 - 0.0963 * log10(fc);
		log_DS_mean[NLOS]  = -6.28 - 0.204  * log10(fc);
		log_DS_mean[OUT2IN] = -6.62;

		log_DS_std[LOS] = 0.66;
		log_DS_std[NLOS] = 0.39;
		log_DS_std[OUT2IN] = 0.32;

		log_ASD_mean[LOS] = 1.06 + 0.1114 * log10(fc);
		log_ASD_mean[NLOS] = 1.5 - 0.1144 * log10(fc);
		log_ASD_mean[OUT2IN] = 1.25;

		log_ASD_std[LOS] = 0.28;
		log_ASD_std[NLOS] = 0.28;
		log_ASD_std[OUT2IN] = 0.42;

		log_ASA_mean[LOS] = 1.81;
		log_ASA_mean[NLOS] = 2.08 - 0.27 * log10(fc);
		log_ASA_mean[OUT2IN] = 1.76;

		log_ASA_std[LOS] = 0.20;
		log_ASA_std[NLOS] = 0.11;
		log_ASA_std[OUT2IN] = 0.16;

		log_ZSA_mean[LOS] = 0.95;
		log_ZSA_mean[NLOS] = -0.3236 * log10(fc) + 1.512;
		log_ZSA_mean[OUT2IN] = 1.01;

		log_ZSA_std[LOS] = 0.16;
		log_ZSA_std[NLOS] = 0.16;
		log_ZSA_std[OUT2IN] = 0.43;

		K_mean = 9;
		K_std = 3.5;

		delay_scaling_param[LOS] = 2.5;
		delay_scaling_param[NLOS] = 2.3;
		delay_scaling_param[OUT2IN] = 2.2;

		XPR_mean[LOS] = 8;
		XPR_mean[NLOS] = 7;
		XPR_mean[OUT2IN] = 9;

		XRP_std[LOS] = 4;
		XRP_std[NLOS] = 3;
		XRP_std[OUT2IN] = 5;

		num_cluster[LOS] = 12;
		num_cluster[NLOS] = 20;
		num_cluster[OUT2IN] = 12;

		num_ray_per_cluster[LOS] = 20;
		num_ray_per_cluster[NLOS] = 20;
		num_ray_per_cluster[OUT2IN] = 20;

		C_DS[LOS] = max(0.25, -3.4084 * log10(fc) + 6.5622);
		C_DS[NLOS] = max(0.25, -3.4084 * log10(fc) + 6.5622);
		C_DS[OUT2IN] = 11;

		C_ASD[LOS] = 5;
		C_ASD[NLOS] = 2;
		C_ASD[OUT2IN] = 5;

		C_ASA[LOS] = 11;
		C_ASA[NLOS] = 15;
		C_ASA[OUT2IN] = 8;

		C_ZSA[LOS] = 7;
		C_ZSA[NLOS] = 7;
		C_ZSA[OUT2IN] = 3;

		per_cluster_showing_std[LOS] = 3;
		per_cluster_showing_std[NLOS] = 3;
		per_cluster_showing_std[OUT2IN] = 4;

		AOD_AOA_distribution = Wrapped_Gaussian;
		ZOD_ZOA_distribution = Laplacian;
	}
	else if (pathloss_model == UMi_A)
	{
		if      ((0.5 < fc) && (fc <   6 ))
		{
			log_DS_mean[LOS] = -7.19;
			log_DS_mean[NLOS] = -6.89;
			log_DS_mean[OUT2IN] = -6.62;

			log_DS_std[LOS] = 0.40;
			log_DS_std[NLOS] = 0.54;
			log_DS_std[OUT2IN] = 0.32;

			log_ASD_mean[LOS] = 1.20;
			log_ASD_mean[NLOS] = 1.41;
			log_ASD_mean[OUT2IN] = 1.25;

			log_ASD_std[LOS] = 0.43;
			log_ASD_std[NLOS] = 0.17;
			log_ASD_std[OUT2IN] = 0.42;

			log_ASA_mean[LOS] = 1.75;
			log_ASA_mean[NLOS] = 1.84;
			log_ASA_mean[OUT2IN] = 1.76;

			log_ASA_std[LOS] = 0.19;
			log_ASA_std[NLOS] = 0.15;
			log_ASA_std[OUT2IN] = 0.16;

			log_ZSA_mean[LOS] = 0.60;
			log_ZSA_mean[NLOS] = 0.88;
			log_ZSA_mean[OUT2IN] = 1.01;

			log_ZSA_std[LOS] = 0.16;
			log_ZSA_std[NLOS] = 0.16;
			log_ZSA_std[OUT2IN] = 0.43;

			K_mean = 9;
			K_std = 5;
			
			delay_scaling_param[LOS] = 3.2;
			delay_scaling_param[NLOS] = 3;
			delay_scaling_param[OUT2IN] = 2.2;

			XPR_mean[LOS] = 9;
			XPR_mean[NLOS] = 8;
			XPR_mean[OUT2IN] = 9;

			XRP_std[LOS] = 3;
			XRP_std[NLOS] = 3;
			XRP_std[OUT2IN] = 11;

			num_cluster[LOS] = 12;
			num_cluster[NLOS] = 19;
			num_cluster[OUT2IN] = 12;

			num_ray_per_cluster[LOS] = 20;
			num_ray_per_cluster[NLOS] = 20;
			num_ray_per_cluster[OUT2IN] = 20;

			C_DS[LOS] = 3.91;
			C_DS[NLOS] = 3.91;
			C_DS[OUT2IN] = 3.91;

			C_ASD[LOS] = 3;
			C_ASD[NLOS] = 10;
			C_ASD[OUT2IN] = 5;

			C_ASA[LOS] = 17;
			C_ASA[NLOS] = 22;
			C_ASA[OUT2IN] = 8;

			C_ZSA[LOS] = 7;
			C_ZSA[NLOS] = 7;
			C_ZSA[OUT2IN] = 3;

			per_cluster_showing_std[LOS] = 3;
			per_cluster_showing_std[NLOS] = 3;
			per_cluster_showing_std[OUT2IN] = 4;

			AOD_AOA_distribution = Wrapped_Gaussian;
			ZOD_ZOA_distribution = Laplacian;
		}
		else if (( 6  < fc) && (fc <= 100))
		{
			log_DS_mean[LOS] = -0.24 * log10(1 + fc) - 7.14;
			log_DS_mean[NLOS] = -0.24 * log10(1 + fc) - 6.83;
			log_DS_mean[OUT2IN] = -6.62;

			log_DS_std[LOS] = 0.38;
			log_DS_std[NLOS] = 0.16 * log10(1 + fc) + 0.28;
			log_DS_std[OUT2IN] = 0.32;

			log_ASD_mean[LOS] = -0.05 * log10(1 + fc) + 1.21;
			log_ASD_mean[NLOS] = -0.23 * log10(1 + fc) + 1.53;
			log_ASD_mean[OUT2IN] = 1.25;

			log_ASD_std[LOS] = 0.41;
			log_ASD_std[NLOS] = 0.11 * log10(1 + fc) + 0.33;
			log_ASD_std[OUT2IN] = 0.42;

			log_ASA_mean[LOS] = -0.08 * log10(1 + fc) + 1.73;
			log_ASA_mean[NLOS] = -0.08 * log10(1 + fc) + 1.81;
			log_ASA_mean[OUT2IN] = 1.76;

			log_ASA_std[LOS] = 0.014 * log10(1 + fc) + 0.28;
			log_ASA_std[NLOS] = 0.05 * log10(1 + fc) + 0.3;
			log_ASA_std[OUT2IN] = 0.16;

			log_ZSA_mean[LOS] = -0.1 * log10(1 + fc) + 0.73;
			log_ZSA_mean[NLOS] = -0.04 * log10(1 + fc) + 0.92;
			log_ZSA_mean[OUT2IN] = 1.01;

			log_ZSA_std[LOS] = -0.04 * log10(1 + fc) + 0.34;
			log_ZSA_std[NLOS] = -0.07 * log10(1 + fc) + 0.41;
			log_ZSA_std[OUT2IN] = 0.43;

			K_mean = 9;			
			K_std = 5;
			
			delay_scaling_param[LOS] = 3;
			delay_scaling_param[NLOS] = 2.1;
			delay_scaling_param[OUT2IN] = 2.2;

			XPR_mean[LOS] = 9;
			XPR_mean[NLOS] = 8;
			XPR_mean[OUT2IN] = 9;

			XRP_std[LOS] = 3;
			XRP_std[NLOS] = 3;
			XRP_std[OUT2IN] = 5;

			num_cluster[LOS] = 12;
			num_cluster[NLOS] = 19;
			num_cluster[OUT2IN] = 12;

			num_ray_per_cluster[LOS] = 20;
			num_ray_per_cluster[NLOS] = 20;
			num_ray_per_cluster[OUT2IN] = 20;

			C_DS[LOS] = 5;
			C_DS[NLOS] = 11;
			C_DS[OUT2IN] = 11;

			C_ASD[LOS] = 3;
			C_ASD[NLOS] = 10;
			C_ASD[OUT2IN] = 5;

			C_ASA[LOS] = 17;
			C_ASA[NLOS] = 22;
			C_ASA[OUT2IN] = 20;

			C_ZSA[LOS] = 7;
			C_ZSA[NLOS] = 7;
			C_ZSA[OUT2IN] = 6;

			per_cluster_showing_std[LOS] = 3;
			per_cluster_showing_std[NLOS] = 3;
			per_cluster_showing_std[OUT2IN] = 4;

			AOD_AOA_distribution = Wrapped_Gaussian;
			ZOD_ZOA_distribution = Laplacian;
		}
		else
		{
			cout << "fc : = " << fc << endl;
			cout << " check Set_fastfading_param() carrier_freq" << endl;
			getchar();
		}
	}
	else if (pathloss_model == UMi_B)
	{
		if (fc < 2)
		{
			fc = 2;
		}
		log_DS_mean[LOS] = -0.24 * log10(1 + fc) - 7.14;
		log_DS_mean[NLOS] = -0.24 * log10(1 + fc) - 6.83;
		log_DS_mean[OUT2IN] = -6.62;

		log_DS_std[LOS] = 0.38;
		log_DS_std[NLOS] = 0.16 * log10(1 + fc) + 0.28;
		log_DS_std[OUT2IN] = 0.32;

		log_ASD_mean[LOS] = -0.05 * log10(1 + fc) + 1.21;
		log_ASD_mean[NLOS] = -0.23 * log10(1 + fc) + 1.53;
		log_ASD_mean[OUT2IN] = 1.25;

		log_ASD_std[LOS] = 0.41;
		log_ASD_std[NLOS] = 0.11 * log10(1 + fc) + 0.33;
		log_ASD_std[OUT2IN] = 0.42;

		log_ASA_mean[LOS] = -0.08 * log10(1 + fc) + 1.73;
		log_ASA_mean[NLOS] = -0.08 * log10(1 + fc) + 1.81;
		log_ASA_mean[OUT2IN] = 1.76;

		log_ASA_std[LOS] = 0.014 * log10(1 + fc) + 0.28;
		log_ASA_std[NLOS] = 0.05 * log10(1 + fc) + 0.3;
		log_ASA_std[OUT2IN] = 0.16;

		log_ZSA_mean[LOS] = -0.1 * log10(1 + fc) + 0.73;
		log_ZSA_mean[NLOS] = -0.04 * log10(1 + fc) + 0.92;
		log_ZSA_mean[OUT2IN] = 1.01;

		log_ZSA_std[LOS] = -0.04 * log10(1 + fc) + 0.34;
		log_ZSA_std[NLOS] = -0.07 * log10(1 + fc) + 0.41;
		log_ZSA_std[OUT2IN] = 0.43;

		K_mean = 9;
		K_std = 5;

		delay_scaling_param[LOS] = 3;
		delay_scaling_param[NLOS] = 2.1;
		delay_scaling_param[OUT2IN] = 2.2;

		XPR_mean[LOS] = 9;
		XPR_mean[NLOS] = 8;
		XPR_mean[OUT2IN] = 9;

		XRP_std[LOS] = 3;
		XRP_std[NLOS] = 3;
		XRP_std[OUT2IN] = 5;

		num_cluster[LOS] = 12;
		num_cluster[NLOS] = 19;
		num_cluster[OUT2IN] = 12;

		num_ray_per_cluster[LOS] = 20;
		num_ray_per_cluster[NLOS] = 20;
		num_ray_per_cluster[OUT2IN] = 20;

		C_DS[LOS] = 5;
		C_DS[NLOS] = 11;
		C_DS[OUT2IN] = 11;

		C_ASD[LOS] = 3;
		C_ASD[NLOS] = 10;
		C_ASD[OUT2IN] = 5;

		C_ASA[LOS] = 17;
		C_ASA[NLOS] = 22;
		C_ASA[OUT2IN] = 8;

		C_ZSA[LOS] = 7;
		C_ZSA[NLOS] = 7;
		C_ZSA[OUT2IN] = 3;

		per_cluster_showing_std[LOS] = 3;
		per_cluster_showing_std[NLOS] = 3;
		per_cluster_showing_std[OUT2IN] = 4;

		AOD_AOA_distribution = Wrapped_Gaussian;
		ZOD_ZOA_distribution = Laplacian;
	}
	else if (pathloss_model == RMa_A || pathloss_model == RMa_B)
	{
		log_DS_mean[LOS] = -7.49;
		log_DS_mean[NLOS] = -7.43;
		log_DS_mean[OUT2IN] = -7.47;

		log_DS_std[LOS] = 0.55;
		log_DS_std[NLOS] = 0.48;
		log_DS_std[OUT2IN] = 0.24;

		log_ASD_mean[LOS] = 0.90;
		log_ASD_mean[NLOS] = 0.95;
		log_ASD_mean[OUT2IN] = 0.67;

		log_ASD_std[LOS] = 0.38;
		log_ASD_std[NLOS] = 0.45;
		log_ASD_std[OUT2IN] = 0.18;

		log_ASA_mean[LOS] = 1.52;
		log_ASA_mean[NLOS] = 1.52;
		log_ASA_mean[OUT2IN] = 1.66;

		log_ASA_std[LOS] = 0.24;
		log_ASA_std[NLOS] = 0.13;
		log_ASA_std[OUT2IN] = 0.21;

		log_ZSA_mean[LOS] = 0.47;
		log_ZSA_mean[NLOS] = 0.58;
		log_ZSA_mean[OUT2IN] = 0.93;

		log_ZSA_std[LOS] = 0.40;
		log_ZSA_std[NLOS] = 0.37;
		log_ZSA_std[OUT2IN] = 0.22;

		K_mean = 7;
		K_std = 4;

		delay_scaling_param[LOS] = 3.8;
		delay_scaling_param[NLOS] = 1.7;
		delay_scaling_param[OUT2IN] = 1.7;

		XPR_mean[LOS] = 12;
		XPR_mean[NLOS] = 7;
		XPR_mean[OUT2IN] = 7;

		XRP_std[LOS] = 4;
		XRP_std[NLOS] = 3;
		XRP_std[OUT2IN] = 3;

		num_cluster[LOS] = 11;
		num_cluster[NLOS] = 10;
		num_cluster[OUT2IN] = 10;

		num_ray_per_cluster[LOS] = 20;
		num_ray_per_cluster[NLOS] = 20;
		num_ray_per_cluster[OUT2IN] = 20;

		C_DS[LOS] = 3.91;
		C_DS[NLOS] = 3.91;
		C_DS[OUT2IN] = 3.91;

		C_ASD[LOS] = 2;
		C_ASD[NLOS] = 2;
		C_ASD[OUT2IN] = 2;

		C_ASA[LOS] = 3;
		C_ASA[NLOS] = 3;
		C_ASA[OUT2IN] = 3;

		C_ZSA[LOS] = 3;
		C_ZSA[NLOS] = 3;
		C_ZSA[OUT2IN] = 3;

		per_cluster_showing_std[LOS] = 3;
		per_cluster_showing_std[NLOS] = 3;
		per_cluster_showing_std[OUT2IN] = 3;
		AOD_AOA_distribution = Wrapped_Gaussian;
		ZOD_ZOA_distribution = Laplacian;
	}
	else
	{
		cout << "fc : = " << fc << endl;
		cout << " check Set_fastfading_param() pathloss_model" << endl;
		getchar();
	}



	C_DS[LOS] = C_DS[LOS]/1000000000.;
	C_DS[NLOS] = C_DS[NLOS]/1000000000.;
	C_DS[OUT2IN] = C_DS[OUT2IN]/1000000000.;
}

void Set_corr_matrix()
{
	MatrixXd corr_matrx_LOS(7,7);
	MatrixXd corr_matrx_NLOS(6,6);
	MatrixXd corr_matrx_Out_to_In(6,6);


	if (pathloss_model == InH_A || pathloss_model == InH_B)   
	{
							// SF	K		DS		ASD		ASA		ZSD		ZSA
		corr_matrx_LOS <<	1.00, 	0.50, - 0.80, - 0.40, - 0.50, 	0.20, 	0.30,
							0.50, 	1.00, - 0.50, 	0.00, 	0.00, 	0.00, 	0.10,
						  - 0.80, - 0.50, 	1.00, 	0.60, 	0.80, 	0.10, 	0.20,
						  - 0.40, 	0.00, 	0.60, 	1.00, 	0.40, 	0.50, 	0.00,
						  - 0.50, 	0.00, 	0.80, 	0.40, 	1.00, 	0.00, 	0.50,
							0.20, 	0.00, 	0.10, 	0.50, 	0.00, 	1.00, 	0.00,
							0.30, 	0.10, 	0.20, 	0.00, 	0.50, 	0.00, 	1.00;

						//	 SF		DS		ASD		ASA		ZSD		ZSA
		corr_matrx_NLOS <<	1.00, - 0.50, 	0.00, - 0.40, 	0.00, 	0.00,
						 -  0.50, 	1.00, 	0.40, 	0.00, - 0.27, - 0.06,
							0.00, 	0.40, 	1.00, 	0.00, 	0.35, 	0.23,
						  - 0.40, 	0.00, 	0.00, 	1.00, - 0.08, 	0.43,
							0.00, - 0.27, 	0.35, - 0.08, 	1.00, 	0.42,
							0.00, - 0.06, 	0.23, 	0.43, 	0.42, 	1.00;

	}
	else if(pathloss_model == UMa_A || pathloss_model == UMa_B)
	{					
		corr_matrx_LOS <<	1.00, 	0.00, - 0.40, - 0.50, - 0.50, 	0.00, - 0.80,
							0.00, 	1.00, - 0.40, 	0.00, - 0.20, 	0.00, 	0.00,
						  - 0.40, - 0.40, 	1.00, 	0.40, 	0.80, - 0.20, 	0.00,
						  - 0.50, 	0.00, 	0.40, 	1.00, 	0.00, 	0.50, 	0.00,
						  - 0.50, - 0.20, 	0.80, 	0.00, 	1.00, - 0.30, 	0.40,
							0.00, 	0.00, - 0.20, 	0.50, - 0.30, 	1.00, 	0.00,
						  - 0.80, 	0.00, 	0.00, 	0.00, 	0.40, 	0.00,	1.00;
		
		corr_matrx_NLOS <<	1.00, - 0.40, - 0.60, 	0.00, 	0.00, - 0.40,
						  - 0.40,  	1.00, 	0.40, 	0.60, - 0.50, 	0.00,
						  - 0.60,  	0.40, 	1.00, 	0.40, 	0.50, - 0.10,
							0.00,  	0.60, 	0.40,	1.00, 	0.00, 	0.00,
							0.00, - 0.50, 	0.50, 	0.00, 	1.00, 	0.00,
						  - 0.40,  	0.00, - 0.10, 	0.00, 	0.00, 	1.00;

		corr_matrx_Out_to_In << 1.00, - 0.50, 	0.20, 	0.00, 	0.00, 	0.00,
							  - 0.50, 	1.00, 	0.40, 	0.40, - 0.60, - 0.20,
								0.20,  	0.40, 	1.00, 	0.00, - 0.20, 	0.00,
								0.00,  	0.40, 	0.00, 	1.00, 	0.00, 	0.50,
								0.00, - 0.60, - 0.20, 	0.00, 	1.00, 	0.50,
								0.00, - 0.20, 	0.00, 	0.50, 	0.50, 	1.00;


	}
	else if (pathloss_model == UMi_A || pathloss_model == UMi_B)
	{
		corr_matrx_LOS <<	1.00, 	0.50, - 0.40, - 0.50, - 0.40, 	0.00, 	0.00,
							0.50, 	1.00, - 0.70, - 0.20, - 0.30, 	0.00, 	0.00,
						  - 0.40, - 0.70, 	1.00, 	0.50, 	0.80, 	0.00, 	0.20,
						  - 0.50, - 0.20, 	0.50, 	1.00, 	0.40, 	0.50, 	0.30,
						  - 0.40, - 0.30,	0.80, 	0.40, 	1.00, 	0.00, 	0.00,
							0.00, 	0.00, 	0.00, 	0.50, 	0.00,	1.00, 	0.00,
							0.00, 	0.00, 	0.20, 	0.30, 	0.00, 	0.00, 	1.00;
	
		corr_matrx_NLOS <<	1.00, - 0.70, 	0.00, - 0.40, 	0.00, 	0.00,
						  - 0.70,  	1.00, 	0.00, 	0.40, - 0.50, 	0.00,
							0.00,  	0.00, 	1.00, 	0.00, 	0.50, 	0.50,
						  - 0.40,  	0.40,	0.00, 	1.00,	0.00, 	0.20,
							0.00, - 0.50, 	0.50, 	0.00, 	1.00, 	0.00,
							0.00, 	0.00, 	0.50, 	0.20, 	0.00, 	1.00;
	
		corr_matrx_Out_to_In << 1.00, - 0.50,	0.20, 	0.00, 	0.00, 	0.00,
							  - 0.50, 	1.00, 	0.40, 	0.40, - 0.60, - 0.20,
								0.20, 	0.40,	1.00, 	0.00, - 0.20, 	0.00,
								0.00, 	0.40, 	0.00, 	1.00,	0.00, 	0.50,
								0.00, - 0.60, - 0.20, 	0.00, 	1.00, 	0.50,
								0.00, - 0.20, 	0.00, 	0.50, 	0.50, 	1.00;

	}
	else if (pathloss_model == RMa_A || pathloss_model == RMa_B)
	{
		corr_matrx_LOS <<	1.00, 	0.00, - 0.50, 	0.00, 	0.00, 	0.01, - 0.17,
							0.00, 	1.00, 	0.00, 	0.00, 	0.00, 	0.00, - 0.02,
						  - 0.50, 	0.00, 	1.00, 	0.00, 	0.00, - 0.05, 	0.27,
							0.00, 	0.00, 	0.00, 	1.00, 	0.00, 	0.73, - 0.14,
							0.00, 	0.00, 	0.00, 	0.00, 	1.00, - 0.20, 	0.24,
							0.01, 	0.00, - 0.05, 	0.73, - 0.20, 	1.00, - 0.07,
						  - 0.17, - 0.02, 	0.27, - 0.14, 	0.24, - 0.07, 	1.00;


		corr_matrx_NLOS <<	1.00, - 0.50, 	0.60, 	0.00, - 0.04, - 0.25,
						  - 0.50,  	1.00, - 0.40, 	0.00, - 0.10, - 0.40,
							0.60, - 0.40,	1.00,	0.00, 	0.42, - 0.27,
							0.00, 	0.00, 	0.00,	1.00, - 0.18, 	0.26,
						  - 0.04, - 0.10, 	0.42, - 0.18, 	1.00, - 0.27,
						  - 0.25, - 0.40, - 0.27, 	0.26, - 0.27, 	1.00;
		
		corr_matrx_Out_to_In << 1.00,  	0.00, 	0.00, 	0.00, 	0.00, 	0.00,
								0.00,  	1.00, 	0.00, 	0.00, 	0.00, 	0.00,
								0.00, 	0.00, 	1.00, - 0.70, 	0.66, 	0.47,
								0.00, 	0.00, - 0.70, 	1.00, - 0.55, - 0.22,
								0.00,	0.00, 	0.66, - 0.55, 	1.00, 	0.00,
								0.00, 	0.00, 	0.47, - 0.22, 	0.00, 	1.00;

	}
	else
	{
		cout << " check Set_corr_matrix() pathloss_model" << endl;
		getchar();
	}


	LLT<MatrixXd> llt_LOS(corr_matrx_LOS);
	sqrt_corr_matrx_LOS = llt_LOS.matrixL();
	
	LLT<MatrixXd> llt_NLOS(corr_matrx_NLOS);
	sqrt_corr_matrx_NLOS = llt_NLOS.matrixL();
	
	
	/*
	cout << "sqrt_corr_matrx_NLOS" << endl;
	cout << sqrt_corr_matrx_NLOS << endl;
	getchar();
	*/

	if (pathloss_model > 1)
	{
		LLT<MatrixXd> llt_Out_to_In(corr_matrx_Out_to_In);
		sqrt_corr_matrx_OUT2IN = llt_Out_to_In.matrixL();
	}

}

void Set_corr_dist()
{
	if (pathloss_model == InH_A || pathloss_model == InH_B)
	{
		corr_dist_DS[LOS] = 8;
		corr_dist_ASD[LOS] = 7;
		corr_dist_ASA[LOS] = 5;
		corr_dist_SF[LOS] = 10;
		corr_dist_K[LOS] = 4;
		corr_dist_ZSA[LOS] = 4;
		corr_dist_ZSD[LOS] = 4;
	
		corr_dist_DS[NLOS] = 5;
		corr_dist_ASD[NLOS] = 3;
		corr_dist_ASA[NLOS] = 3;
		corr_dist_SF[NLOS] = 6;
		corr_dist_ZSA[NLOS] = 4;
		corr_dist_ZSD[NLOS] = 4;

	}
	else if (pathloss_model == UMa_A || pathloss_model == UMa_B)
	{
		corr_dist_DS[LOS] = 30;
		corr_dist_ASD[LOS] = 18;
		corr_dist_ASA[LOS] = 15;
		corr_dist_SF[LOS] = 37;
		corr_dist_K[LOS] = 12;
		corr_dist_ZSA[LOS] = 15;
		corr_dist_ZSD[LOS] = 15;

		corr_dist_DS[NLOS] = 40;
		corr_dist_ASD[NLOS] = 50;
		corr_dist_ASA[NLOS] = 50;
		corr_dist_SF[NLOS] = 50;
		corr_dist_ZSA[NLOS] = 50;
		corr_dist_ZSD[NLOS] = 50;

		corr_dist_DS[OUT2IN] = 10;
		corr_dist_ASD[OUT2IN] = 11;
		corr_dist_ASA[OUT2IN] = 17;
		corr_dist_SF[OUT2IN] = 7;
		corr_dist_ZSA[OUT2IN] = 25;
		corr_dist_ZSD[OUT2IN] = 25;
	}
	else if (pathloss_model == UMi_A || pathloss_model == UMi_B)
	{
		corr_dist_DS[LOS] = 7;
		corr_dist_ASD[LOS] = 8;
		corr_dist_ASA[LOS] = 8;
		corr_dist_SF[LOS] = 10;
		corr_dist_K[LOS] = 15;
		corr_dist_ZSA[LOS] = 12;
		corr_dist_ZSD[LOS] = 12;

		corr_dist_DS[NLOS] = 10;
		corr_dist_ASD[NLOS] = 10;
		corr_dist_ASA[NLOS] = 9;
		corr_dist_SF[NLOS] = 13;
		corr_dist_ZSA[NLOS] = 10;
		corr_dist_ZSD[NLOS] = 10;

		corr_dist_DS[OUT2IN] = 10;
		corr_dist_ASD[OUT2IN] = 11;
		corr_dist_ASA[OUT2IN] = 17;
		corr_dist_SF[OUT2IN] = 7;
		corr_dist_ZSA[OUT2IN] = 25;
		corr_dist_ZSD[OUT2IN] = 25;
	}
	else if (pathloss_model == RMa_A || pathloss_model == RMa_B)
	{
		corr_dist_DS[LOS] = 50;
		corr_dist_ASD[LOS] = 25;
		corr_dist_ASA[LOS] = 35;
		corr_dist_SF[LOS] = 37;
		corr_dist_K[LOS] = 40;
		corr_dist_ZSA[LOS] = 15;
		corr_dist_ZSD[LOS] = 15;

		corr_dist_DS[NLOS] = 36;
		corr_dist_ASD[NLOS] = 30;
		corr_dist_ASA[NLOS] = 40;
		corr_dist_SF[NLOS] = 120;
		corr_dist_ZSA[NLOS] = 50;
		corr_dist_ZSD[NLOS] = 50;

		corr_dist_DS[OUT2IN] = 36;
		corr_dist_ASD[OUT2IN] = 30;
		corr_dist_ASA[OUT2IN] = 40;
		corr_dist_SF[OUT2IN] = 120;
		corr_dist_ZSA[OUT2IN] = 50;
		corr_dist_ZSD[OUT2IN] = 50;
	}
	else
	{
		cout << " check Set_corr_dist() pathloss_model" << endl;
		getchar();
	}
}
