#include <iostream>
#include "paramSimul.h"
#include "evaluationConfigurerations.h"
#include "const.h"
#include <complex>
#include "struct.h"

using namespace std;


void Set_test_environment()
{
	cout << endl;
	cout << "---------test_environment------------" << endl;
	
	if (test_environment == InH_eMBB_A)
	{
		carrier_freq = 4 * 1000000000.;
		subcarrier_spacing = 15000;
		sampling_frequency = 1536000000;
		fft_size = 1024;
		slot_interval=0.001;
		num_rb = 52;
		inter_site_distance = 20;
		secter_to_ue_min_distance = 0;

		indoor_ue_speed = 3;//km/h
		h_BS = 3;
		bs_noise_figure = 5; //dB
		ue_noise_figure = 7; //dB
		
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 10000000;// for FDD
		num_floor = 1;
		num_propagation_condition = 2; // LOS / NLOS
	    ue_power = 23;//dBm
		TRxP_power = 21;//dBm
		overhead = 0.165;
		
		Power_0=-60 ;
		Power_alpha=0.6;

	}
	else if (test_environment == InH_eMBB_B)
	{
		carrier_freq = 30 * 1000000000.;
		subcarrier_spacing = 120000;
		inter_site_distance = 20;
		secter_to_ue_min_distance = 0;
		indoor_ue_speed = 3;//km/h
		num_rb = 26;

		h_BS = 3;
		bs_noise_figure = 7; //dB
		ue_noise_figure = 10; //dB

		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 40000000;// for FDD
		num_floor = 1;
		num_propagation_condition = 2;
		ue_power = 20;//dBm
		TRxP_power = 23;//dBm
		overhead = 0.175;
		Power_0 = -80;
		Power_alpha = 0.8;
	}
	else if (test_environment == InH_eMBB_C)
	{
		carrier_freq = 70 * 1000000000.;
		subcarrier_spacing = 120000;
		inter_site_distance = 20;
		secter_to_ue_min_distance = 0;
		indoor_ue_speed = 3;//km/h
		num_rb = 26;

		h_BS = 3;
		bs_noise_figure = 7; //dB
		ue_noise_figure = 10; //dB

		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 40000000;// for FDD
		num_floor = 1;
		num_propagation_condition = 2;
		ue_power = 18;//dBm
		TRxP_power = 21;//dBm
		overhead = 0.175;
	}
	else if (test_environment == Dense_Urban_eMBB_A)
	{
		carrier_freq = 4 * 1000000000.;
		subcarrier_spacing = 15000;
		sampling_frequency = 1536000000;
		slot_interval = 0.001;
		num_rb = 52;
		h_BS = 25;
		high_loss_type_portion = 0.2;
		indoor_ue_portion = 0.8;
		inter_site_distance = 200;
		secter_to_ue_min_distance = 10;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 30;//km/h
		bs_noise_figure = 5; //dB
		ue_noise_figure = 7; //dB


		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 10000000;// for FDD
		num_floor = 8;
		num_propagation_condition = 3;
		
		ue_power = 23;//dBm
		TRxP_power = 41;//dBm
		overhead = 0.28;

		Power_0 = -60;
		Power_alpha = 0.6;
	}

	else if (test_environment == Dense_Urban_eMBB_B)
	{
		carrier_freq = 30 * 1000000000.;
		h_BS = 25;
		subcarrier_spacing = 120000;
		num_rb = 26;
		overhead = 0.34;

		high_loss_type_portion = 0.2;
		indoor_ue_portion = 0.8;
		inter_site_distance = 200;
		secter_to_ue_min_distance = 10;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 30;//km/h
		bs_noise_figure = 7; //dB
		ue_noise_figure =10; //dB
	
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 40000000;// for FDD
		num_floor = 8;
		num_propagation_condition = 3;

		ue_power = 23;//dBm
		TRxP_power = 37;//dBm

	}
	else if (test_environment == Dense_Urban_eMBB_C_Macro)
	{
		carrier_freq = 4 * 1000000000.;
		h_BS = 25;
		high_loss_type_portion = 0.2;
		indoor_ue_portion = 0.8;
		inter_site_distance = 200;
		secter_to_ue_min_distance = 10;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 30;//km/h
		bs_noise_figure = 5; //dB
		ue_noise_figure = 7; //dB
	
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 10000000;// for FDD
		num_floor = 8;
		num_propagation_condition = 3;
		ue_power = 23;//dBm
		TRxP_power = 41;//dBm

	}
	else if (test_environment == Dense_Urban_eMBB_C_Micro)
	{
		carrier_freq = 30 * 1000000000.;
		h_BS = 10;
		high_loss_type_portion = 0.2;
		indoor_ue_portion = 0.8;
		inter_site_distance = 200; 
		secter_to_ue_min_distance = 0;
		micro_min_inter_site_distance = 30;
		micro_cell_radius = 25;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 30;//km/h
		bs_noise_figure = 7; //dB
		ue_noise_figure = 10; //dB
	
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 40000000;// for FDD
		num_floor = 8;
		num_propagation_condition = 3;
		ue_power = 23;//dBm
		TRxP_power = 30;//dBm
	}
	else if (test_environment == Rural_eMBB_A)
	{
		carrier_freq = 0.7* 1000000000.;
		subcarrier_spacing = 15000;
		sampling_frequency = 1536000000;
		slot_interval = 0.001;
		num_rb = 52;
		h_BS = 35;
		high_loss_type_portion = 0;
		indoor_ue_portion = 0.5;
		inter_site_distance = 1732; //Macro
		secter_to_ue_min_distance = 0;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 120;//km/h
		bs_noise_figure = 5; //dB
		ue_noise_figure = 7; //dB
		
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 10000000;// for FDD
		num_floor = 1;
		num_propagation_condition = 3;
		ue_power = 23;//dBm
		TRxP_power = 46;//dBm
		overhead = 0.15;

		Power_0 = -80;
		Power_alpha = 0.7;
	}
	else if (test_environment == Rural_eMBB_B)
	{
		carrier_freq = 4* 1000000000.;
		subcarrier_spacing = 15000;
		num_rb = 52;

		h_BS = 35;
		high_loss_type_portion = 0;
		indoor_ue_portion = 0.5;
		inter_site_distance = 1732; //Macro
		secter_to_ue_min_distance = 0;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 120;//km/h
		bs_noise_figure = 5; //dB
		ue_noise_figure = 7; //dB
	
		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 10000000;// for FDD
		num_floor = 1;
		num_propagation_condition = 3;
		ue_power = 23;//dBm
		TRxP_power = 46;//dBm
		overhead = 0.15;

		Power_0 = -60;
		Power_alpha = 0.6;
	}
	else if (test_environment == Rural_eMBB_C)
	{
		carrier_freq = 0.7 * 1000000000.;
		h_BS = 35;
		high_loss_type_portion = 0;
		indoor_ue_portion = 0.4;
		outdoor_pedestrian_portion = 0.4;
		inter_site_distance = 6000; //Macro
		secter_to_ue_min_distance = 0;
		indoor_ue_speed = 3;//km/h
		outdoor_ue_car_speed = 120;//km/h
		outdoor_ue_pedestrian_speed = 3; //km/h
		bs_noise_figure = 5; //dB
		ue_noise_figure = 7; //dB

		thermal_nosie_level = -174; //dBm/Hz
		simulation_bandwidth = 10000000;// for FDD
		num_floor = 1;
		num_propagation_condition = 3;
		ue_power = 23;//dBm
		TRxP_power = 46;//dBm
	}


	rs_size = num_rb;


	if (pathloss_model == UMa_A ) //table 3-4
	{
		W = 20, h = 20;
	}
	else if (pathloss_model == RMa_A || pathloss_model == RMa_B)
	{
		W = 20, h = 5;
	}
	
	num_freq_per_rbs = 12;

	lamda_0 =  SPEED_LIGHT/carrier_freq;
	
	L_glass = 2. + 0.2*carrier_freq / 1000000000.;
	L_IRRglass = 23. + 0.3*carrier_freq / 1000000000.;
	L_concrete = 5. + 4.*carrier_freq / 1000000000.;
	L_wood = 4.85 + 0.12*carrier_freq / 1000000000.;

	Low_loss_model_PL = 5. - 10.*log10(0.3 * pow(10., -L_glass / 10.0) + 0.7*pow(10., -L_concrete / 10));
	High_loss_model_PL = 5. - 10.*log10(0.7 * pow(10., -L_IRRglass / 10.0) + 0.3*pow(10., -L_concrete / 10));
	
	Low_loss_model_std = 4.4;
	High_loss_model_std = 6.5;

	car_penet_loss_mean = 9;
	car_penet_loss_std = 5;

	if (test_environment >= 3) // NOT INDOOR 
	{
		bs_location[0].x = - sqrt(3.0) * inter_site_distance;
		bs_location[0].y = - inter_site_distance;
		bs_location[1].x = - sqrt(3.0) * inter_site_distance;
		bs_location[1].y = 0;
		bs_location[2].x = - sqrt(3.0) * inter_site_distance;
		bs_location[2].y =   inter_site_distance;
		bs_location[3].x = - sqrt(3.0) / 2.0 * inter_site_distance;
		bs_location[3].y = - 3.0/2.0 * inter_site_distance;
		bs_location[4].x = -sqrt(3.0) / 2.0 * inter_site_distance;
		bs_location[4].y = - 1.0/2.0 * inter_site_distance;
		bs_location[5].x = -sqrt(3.0) / 2.0 * inter_site_distance;
		bs_location[5].y =  1.0 / 2.0 * inter_site_distance;
		bs_location[6].x = -sqrt(3.0) / 2.0 * inter_site_distance;
		bs_location[6].y =  3.0 / 2.0 * inter_site_distance;
		bs_location[7].x = 0.0;
		bs_location[7].y =  - 2.0 * inter_site_distance;
		bs_location[8].x = 0.0;
		bs_location[8].y = - 1.0 * inter_site_distance;
		bs_location[9].x = 0.0;
		bs_location[9].y = 0.0;
		bs_location[10].x = 0.0;
		bs_location[10].y = 1.0 * inter_site_distance;
		bs_location[11].x = 0.0;
		bs_location[11].y = 2.0 * inter_site_distance;
		bs_location[12].x = sqrt(3.0) / 2.0 * inter_site_distance;
		bs_location[12].y = -3.0 / 2.0 * inter_site_distance;
		bs_location[13].x = sqrt(3.0) / 2.0 * inter_site_distance;
		bs_location[13].y = -1.0 / 2.0 * inter_site_distance;
		bs_location[14].x = sqrt(3.0) / 2.0 * inter_site_distance;
		bs_location[14].y = 1.0 / 2.0 * inter_site_distance;
		bs_location[15].x = sqrt(3.0) / 2.0 * inter_site_distance;
		bs_location[15].y = 3.0 / 2.0 * inter_site_distance;
		bs_location[16].x = sqrt(3.0) * inter_site_distance;
		bs_location[16].y = -inter_site_distance;
		bs_location[17].x = sqrt(3.0) * inter_site_distance;
		bs_location[17].y = 0.0 ;
		bs_location[18].x = sqrt(3.0) * inter_site_distance;
		bs_location[18].y = inter_site_distance;
	}



	cout << "carrier_freq              : " << carrier_freq << endl;
	cout << "wavelength                : " << lamda_0 << endl;
	cout << "inter_site_distance       : " << inter_site_distance << endl;
	cout << "secter_to_ue_min_distance : " << secter_to_ue_min_distance << endl;
	cout << "indoor_ue_speed           : " << indoor_ue_speed << endl;
	cout << "h_BS                      : " << h_BS << endl;
	cout << "bs_noise_figure           : " << bs_noise_figure << endl;
	cout << "ue_noise_figure           : " << ue_noise_figure << endl;

	cout << "thermal_nosie_level       : " << thermal_nosie_level << endl;
	cout << "simulation_bandwidth      : " << simulation_bandwidth << endl;
}

