#ifndef _UE_H_
#define _UE_H_
#include <vector>
#include <iostream>
#include <fstream>
#include "struct.h"
#include <Eigen/Dense>
#include "rvGenerater.h"
using namespace std;
using namespace Eigen;

class UE
{
public:
	UE();
	~UE();

	void Configure(int);
	void Allocate_memory(void);
	void Set_UE_speed_indoor_outdoor_state(void);
	void Set_2D_distance_indoor(void);
	void Calculate_O2I_penet_loss(double distance_indoor);
	void Set_car_penet_loss(void);
	void Set_h_UT(void);
	void Drop_ue_in_site(void);
	void Determine_LOS(int sec_idx);
	void Set_breakpoint_distance(int sec_idx);
	void Compute_PathLoss(int sec_idx);
	void Receive_UL(void);
	void Find_Allocated_Rbs(void);
	void CSI_calculation(void);
	void Calculate_Interference();
	double Compute_Effective_Snr(int mode);

	void Save_channel(void);

	int Find_PMI(double mutual_inf[], double SINR[][4][52], int num_layer,int rb_idx);
	void Find_R_for_pf(double SINR[][4][52]);
	void determine_CQI();
	
	double FER(double esinr, int mcs);
	

	double Update_Power_Control(int rb_idx);
	

	//void Update_Channel(void);
	//void Receive_UL();

	int sector_in_control;
	int zenith_steering_idx=0;
	int azimuth_steering_idx = 0;
	int sector_zenith_steering_idx = 0;
	int sector_azimuth_steering_idx = 0;
	int panel_idx=0;
	

	int  *adj_bs;
	int site_idx;
	int floor_idx;
	double  h_UT;
	double  speed;
	LOCATION  velocity;
	
	int  ue_indoor_outdoor_state;
	int O2I_penetration_loss_model;
	double _2D_distance_indoor;
	double Pathloss_tw;
	double Pathloss_car;
	double couplingloss_dB;
	
	double alpha;
	double beta;
	double gamma;
	LOCATION d_tx[2][4][2][1][2];//  antenna element location vector [M][N][P][Mg][Ng] (max num)
	
	LOCATION location_in_site;
	LOCATION pos_indoor;

	vector  <int> rb_indices;
	double power_per_RB; //linear
	double  geometry;
	double esinr;
	double spectralEfficiency;

	int CQI_selected;
	int **CQI;
	int **PMI;
	double SINR_dB[4][4][52]; // [RI][layer][num_rb][history_length]  for ESINR calculation

	int RI; // 0,1,2,3
	MatrixXcd precodingmatrix[52];
	MatrixXcd R_inter[52];//[layer][num_rb];
	MatrixXcd R_inter_history[52][5];//[layer][num_rb];
	MatrixXcd estimated_eff_channel[52][5];

	int num_of_rbs;
	int info_bits;


	int ack;
	int num_retransmission;
	vector <double> HARQeSINRs;
	double uplinkThroghput;

	
	
	double num_transmission;
	double num_error[4];
	
	double T_for_pf[52];
	double R_for_pf[52];
private:
	int     _ue_idx;

};

#endif
